package com.uas.customsdeclaration;

import com.uas.account.sso.integration.config.token.EnableSSOToken;
import com.uas.customsdeclaration.util.ContextUtils;
import org.springframework.boot.SpringApplication;
import org.springframework.boot.autoconfigure.SpringBootApplication;
import org.springframework.boot.context.event.ApplicationPreparedEvent;
import org.springframework.boot.web.servlet.MultipartConfigFactory;
import org.springframework.context.ApplicationListener;
import org.springframework.context.annotation.Bean;
import org.springframework.core.env.Environment;
import org.springframework.transaction.annotation.EnableTransactionManagement;
import org.springframework.web.servlet.config.annotation.EnableWebMvc;

import javax.servlet.MultipartConfigElement;
import java.io.FileNotFoundException;

@EnableSSOToken
@EnableTransactionManagement
@SpringBootApplication
@EnableWebMvc
public class PlatformCustomsdeclarationApplication {

	private Environment environment;

	public static void main(String[] args) throws FileNotFoundException {
//		File logFile = new File("logs/log.log");
//		if (!logFile.getParentFile().exists()) {
//			logFile.getParentFile().mkdir();
//		}
//		System.setErr(new PrintStream(new FileOutputStream(logFile, true)));
		SpringApplication application = new SpringApplication(PlatformCustomsdeclarationApplication.class);
		application.addListeners(new ApplicationListener<ApplicationPreparedEvent>() {
			@Override
			public void onApplicationEvent(ApplicationPreparedEvent event) {
				ContextUtils.setApplicationContext(event.getApplicationContext());
			}
		});

		application.run(args);
	}

	@Bean
	public MultipartConfigElement multipartConfigElement() {
		MultipartConfigFactory factory = new MultipartConfigFactory();
		//单个文件最大
		factory.setMaxFileSize("50MB"); //KB,MB
		/// 设置总上传数据总大小
		factory.setMaxRequestSize("50MB");
		return factory.createMultipartConfig();
	}
}
