package com.uas.customsdeclaration.business.common.controller;

import com.uas.customsdeclaration.business.common.model.BasicConfigure;
import com.uas.customsdeclaration.business.common.service.BasicConfigureService;
import com.uas.customsdeclaration.util.ResultMap;
import com.uas.platform.core.util.serializer.FlexJsonUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;

/**
 * 基础配置控制器
 *
 * @author yuj 2018-04-16 17:51
 */
@RestController
@RequestMapping(value = "/common/basicConfigure")
public class BasicConfigureController {

    private final BasicConfigureService basicConfigureService;

    @Autowired
    public BasicConfigureController(BasicConfigureService basicConfigureService) {
        this.basicConfigureService = basicConfigureService;
    }

    /**
     * 保存 基础配置信息
     * @param type 类型
     * @param params 需要保存的信息
     * @return ResultMap 成功之后包含保存之后的对象
     */
    @RequestMapping(value = "/save", method = RequestMethod.POST)
    public ResultMap save(String params, Integer type) {
        BasicConfigure basicConfigure = FlexJsonUtils.fromJson(params, BasicConfigure.class);
        return basicConfigureService.save(basicConfigure, type);
    }


    /**
     * 根据基础配置的类型获取配置信息
     * @param type 类型
     * @return ResultMap
     */
    @RequestMapping(value = "/type", method = RequestMethod.GET)
    public ResultMap getBasicConfigureByType(Integer type) {
        return basicConfigureService.getBasicConfigureByType(type);
    }
}
