package com.uas.customsdeclaration.business.common.controller;

import com.uas.customsdeclaration.business.common.service.CurrencyListService;
import com.uas.customsdeclaration.util.ResultMap;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;

/**
 * 币别信息的控制器
 *
 * @author yuj 2018-04-23 9:42
 */
@RestController
@RequestMapping(value = "/common/currencyList")
public class CurrencyListController {

    private final CurrencyListService currencyListService;

    @Autowired
    public CurrencyListController(CurrencyListService currencyListService) {
        this.currencyListService = currencyListService;
    }

    /**
     * 找出所有的币别信息
     * @return  ResultMap
     */
    @RequestMapping(value = "/all", method = RequestMethod.GET)
    public ResultMap getAll() {
        return currencyListService.getAll();
    }
}
