package com.uas.customsdeclaration.business.common.dao;

import com.uas.customsdeclaration.business.common.model.BasicConfigure;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.JpaSpecificationExecutor;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.Param;
import org.springframework.stereotype.Repository;

import java.util.List;

/**
 * description
 *
 * @author yuj 2018-04-16 17:44
 */
@Repository
public interface BasicConfigureDao extends JpaRepository<BasicConfigure, Long>, JpaSpecificationExecutor<BasicConfigure>{


    /**
     * 根据类型获取基础配置参数
     * @param type 类型
     * @return  List<BasicConfigure>
     */
    @Query(value = "select b from BasicConfigure b where b.type = :type")
    List<BasicConfigure> findBasicConfigureByType(@Param("type") Integer type);
}
