package com.uas.customsdeclaration.business.common.dao;

import com.uas.customsdeclaration.business.common.model.CurrencyList;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.JpaSpecificationExecutor;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.Param;
import org.springframework.stereotype.Repository;

import java.util.List;

/**
 * 汇总表
 * Created by yujia on 2018/3/8.
 */
@Repository
public interface CurrencyListDao extends JpaSpecificationExecutor<CurrencyList>, JpaRepository<CurrencyList, Long> {

    @Query(value = "select c from CurrencyList c where c.curAbbreviate = :currency or c.curChinese = :currency or c.curEnghlish = :currency or c.curAlias = :currency")
    List<CurrencyList> getCurrencyListByName(@Param("currency") String currency);

    /**
     * 根据币别中文名获取币别信息
     * @param chineseName 币别中文名称
     * @return List<CurrencyList>
     */
    @Query(value = "select c from CurrencyList c where c.curChinese = :chineseName")
    List<CurrencyList> getCurrencyListByChineseName(@Param("chineseName") String chineseName);
}
