package com.uas.customsdeclaration.business.common.dao;

import com.uas.customsdeclaration.business.common.model.TransactionMode;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.JpaSpecificationExecutor;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.Param;
import org.springframework.stereotype.Repository;

import java.util.List;

/**
 * 成交方式
 *
 * @author yuj 2018-03-27 14:08
 */
@Repository
public interface TransactionModeDao extends JpaRepository<TransactionMode, Long>, JpaSpecificationExecutor<TransactionMode> {

    /**
     * 根据成交方式获取信息
     * @param mode
     * @return
     */
    @Query(value = "select p from TransactionMode p where p.mode = :mode ")
    List<TransactionMode> findTransactionModeByMode(@Param("mode") String mode);
}
