package com.uas.customsdeclaration.business.common.model;

import com.uas.customsdeclaration.util.StringUtils;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.Table;
import java.io.Serializable;
import java.util.Date;

/**
 * 公司的基础资料配置
 *
 * @author yuj 2018-04-16 17:14
 */
@Entity
@Table(name = "cd$basicconfigure")
public class BasicConfigure implements Serializable {

    private static final long serialVersionUID = 1144668624623889774L;

    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    private Long id;

    /**
     * 类型名称
     */
    @Column(name = "bc_title")
    private String title;

    /**
     * 描述
     */
    @Column(name = "bc_description")
    private String description;

    /**
     * 创建时间
     */
    @Column(name = "bc_createtime")
    private Date createTime;

    /**
     * 类型
     */
    @Column(name = "bc_type")
    private Integer type;

    /**
     * 企业名称
     */
    @Column(name = "bc_enterprisename")
    private String enterpriseName;

    /**
     * 企业enuu
     */
    @Column(name = "bc_enuu")
    private Long enuu;

    /**
     * 操作人useruu
     */
    @Column(name = "bc_useruu")
    private Long useruu;

    /**
     * 操作人姓名
     */
    @Column(name = "bc_username")
    private String userName;

    public Long getId() {
        return id;
    }

    public BasicConfigure setId(Long id) {
        this.id = id;
        return this;
    }

    public String getTitle() {
        return title;
    }

    public BasicConfigure setTitle(String title) {
        this.title = title;
        return this;
    }

    public String getDescription() {
        return description;
    }

    public BasicConfigure setDescription(String description) {
        this.description = description;
        return this;
    }

    public Date getCreateTime() {
        return createTime;
    }

    public BasicConfigure setCreateTime(Date createTime) {
        this.createTime = createTime;
        return this;
    }

    public Integer getType() {
        return type;
    }

    public BasicConfigure setType(Integer type) {
        this.type = type;
        return this;
    }

    public String getEnterpriseName() {
        return enterpriseName;
    }

    public BasicConfigure setEnterpriseName(String enterpriseName) {
        this.enterpriseName = enterpriseName;
        return this;
    }

    public Long getEnuu() {
        return enuu;
    }

    public BasicConfigure setEnuu(Long enuu) {
        this.enuu = enuu;
        return this;
    }

    public Long getUseruu() {
        return useruu;
    }

    public BasicConfigure setUseruu(Long useruu) {
        this.useruu = useruu;
        return this;
    }

    public String getUserName() {
        return userName;
    }

    public BasicConfigure setUserName(String userName) {
        this.userName = userName;
        return this;
    }


    @Override
    public String toString() {
        return "BasicConfigure{" +
                "id=" + id +
                ", title='" + title + '\'' +
                ", description='" + description + '\'' +
                ", createTime=" + createTime +
                ", type=" + type +
                ", enterpriseName='" + enterpriseName + '\'' +
                ", enuu=" + enuu +
                ", useruu=" + useruu +
                ", userName='" + userName + '\'' +
                '}';
    }

    /**
     * 验证关键信息是否丢失
     * @return 验证通过或者验证失败
     */
    public Boolean isVerifyThrough() {
        if (this.enuu == null) {
            return Boolean.FALSE;
        } else if (StringUtils.isEmpty(this.getDescription())) {
            return Boolean.FALSE;
        } else if (this.type == null) {
            return Boolean.FALSE;
        } else {
            return Boolean.TRUE;
        }
    }
}
