package com.uas.customsdeclaration.business.common.model;

import com.alibaba.fastjson.annotation.JSONField;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.uas.customsdeclaration.util.DoubleUtil;
import com.uas.customsdeclaration.util.IntegerUtil;
import com.uas.customsdeclaration.util.StringUtils;

import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.Table;
import java.io.Serializable;
import java.util.Map;

/**
 * description
 *
 * @author yuj 2018-03-01 16:06
 */
@Entity
@Table(name = "cs$commissionsheetdetailhistory")
public class CommissionSheetDetailHistory implements Serializable {

    private static final long serialVersionUID = 5627609026062165437L;

    @Id
    @Column(name = "id")
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    private Long id;

    /**
     * 序号
     */
    @Column(name = "cs_dento", nullable = false)
    private Integer detno;

    /**
     * 商品名称
     */
    @Column(name = "cs_commodityname", nullable = false)
    private String commodityName;


    /**
     * 商品名称 (简体)
     */
    @Column(name = "cs_commodityname_simplify")
    private String commodityNameSimplify;

    /**
     * 规格型号
     */
    @Column(name = "cs_cmpcode", nullable = false)
    private String cmpCode;

    /**
     * 数量
     */
    @Column(name = "cs_amount")
    private Long amount;

    /**
     * 数量
     */
    @Column(name = "cs_amount_str")
    private String amountStr;

    /**
     * 数量是否错误
     */
    @Column(name = "cs_amount_error")
    private Boolean amountError;

    /**
     * 数量错误的描述信息
     */
    @Column(name = "cs_amount_error_message")
    private String amountErrorMessage;

    /**
     * 箱数
     */
    @Column(name = "cs_cartonnum")
    private Integer cartonNum;

    /**
     * 箱数整数
     */
    @Column(name = "cs_cartonnum_str")
    private String cartonNumStr;

    /**
     * 描述的错误信息
     */
    @Column(name = "cs_cartonnum_error_message")
    private String cartonNumErrorMessage;

    /**
     * 箱数是否错误
     */
    @Column(name = "cs_cartonnum_error")
    private Boolean cartonNumError;

    /**
     * 净重
     */
    @Column(name = "cs_netweight")
    private Double netWeight;

    /**
     * 净重str
     */
    @Column(name = "cs_netweight_str")
    private String netWeightStr;

    /**
     * 是否净重的错误
     */
    @Column(name = "cs_netweight_error")
    private Boolean netWeightError;

    /**
     * 净重错误的信息
     */
    @Column(name = "cs_netweight_error_message")
    private String netWeightErrorMessage;

    /**
     * 毛重
     */
    @Column(name = "cs_grossweight")
    private Double grossWeight;

    /**
     * 毛重
     */
    @Column(name = "cs_grossweight_str")
    private String grossWeightStr;

    /**
     * 毛重是否错误
     */
    @Column(name = "cs_grossweight_error")
    private Boolean grossWeightError;

    /**
     * 毛重的错误信息
     */
    @Column(name = "cs_grossweight_error_message")
    private String grossWeightErrorMessage;

    /**
     * 币种
     */
    @Column(name = "cs_currency")
    private String currency;

    /**
     * 币种的错误信息
     */
    @Column(name = "cs_currency_error_message")
    private String currencyErrorMessage;

    /**
     * 币种是否错误
     */
    @Column(name = "cs_currency_error")
    private Boolean currencyError;

    /**
     *  单价
     */
    @Column(name = "cs_unitprice")
    private Double unitPrice;

    /**
     * 单价 str
     */
    @Column(name = "cs_unitprice_str")
    private String unitPriceStr;

    /**
     * 单价是否错误
     */
    @Column(name = "cs_unitprice_error")
    private Boolean unitPriceError;

    /**
     * 单价的错误描述
     */
    @Column(name = "cs_unitpriceerrormessage")
    private String unitPriceErrorMessage;

    /**
     * 总价
     */
    @Column(name = "cs_totalprice")
    private Double totalPrice;

    /**
     * 总价 str
     */
    @Column(name = "cs_totalprice_str")
    private String totalPriceStr;

    /**
     * 总价是否错误
     */
    @Column(name = "cs_totalprice_error")
    private Boolean totalPriceError;

    /**
     * 总价的错误描述
     */
    @Column(name = "cs_totalprice_error_message")
    private String totalPriceErrorMessage;

    /**
     * 品牌
     */
    @Column(name = "cs_brand")
    private String brand;

    /**
     * 品牌的错误信息
     */
    @Column(name = "cs_brand_error_message")
    private String brandErrorMessage;

    /**
     * 品牌的错误描述
     */
    @Column(name = "cs_brand_error")
    private Boolean brandError;

    /**
     * 产地
     */
    @Column(name = "cs_producing_area")
    private String producingArea;

    /**
     * 产地错误描述信息
     */
    @Column(name = "cs_producing_area_error_message")
    private String producingAreaErrorMessage;

    /**
     * 错误描述信息
     */
    @Column(name = "cs_producing_area_error")
    private Boolean producingAreaError;

    /**
     * 产地 简体
     */
    @Column(name = "cs_producing_area_simplify")
    private String producingAreaSimplify;

    /**
     * 备注
     */
    @Column(name = "cs_remark")
    private String remark;

    /**
     * 备注
     */
    @Column(name = "cs_remark_simplify")
    private String remarkSimplify;

    /**
     * 主表的主键
     */
    @Column(name = "cs_sheet_id")
    private Long sheetId;

    /**
     * 批号
     */
    @Column(name = "cs_batch_num")
    private String batchNum;

    /**
     * 批号错误信息
     */
    @Column(name = "cs_batch_num_error_message")
    private String batchNumErrorMessage;

    /**
     * 批号是否错误
     */
    @Column(name = "cs_batch_num_error")
    private Boolean batchNumError;

    /**
     * 操作变化历史
     */
    @Column(name = "cs_operator_revision_history")
    private String operatorRevisionHistory;

    /**
     * 客服部验证
     */
    @Column(name = "cs_customerservice_operator")
    private String customerServiceOperator;

    /**
     * 仓储操作记录
     */
    @Column(name = "cs_storage_service_operator", columnDefinition = "TEXT")
    private String storageServiceOperator;

    /**
     * 对应的主表信息
     */
    @ManyToOne(cascade = {CascadeType.PERSIST, CascadeType.REFRESH, CascadeType.DETACH, CascadeType.MERGE}, optional = true)
    @JoinColumn(name = "sheetId", nullable = false)
    private CommissionSheetHistory commissionSheetHistory;

    public Long getId() {
        return id;
    }

    public CommissionSheetDetailHistory setId(Long id) {
        this.id = id;
        return this;
    }

    public String getCommodityNameSimplify() {
        return commodityNameSimplify;
    }

    public CommissionSheetDetailHistory setCommodityNameSimplify(String commodityNameSimplify) {
        this.commodityNameSimplify = commodityNameSimplify;
        return this;
    }

    public String getProducingAreaSimplify() {
        return producingAreaSimplify;
    }

    public CommissionSheetDetailHistory setProducingAreaSimplify(String producingAreaSimplify) {
        this.producingAreaSimplify = producingAreaSimplify;
        return this;
    }

    public Long getSheetId() {
        return sheetId;
    }

    public CommissionSheetDetailHistory setSheetId(Long sheetId) {
        this.sheetId = sheetId;
        return this;
    }

    @JsonIgnore
    @JSONField(serialize = false)
    public CommissionSheetHistory getCommissionSheet() {
        return commissionSheetHistory;
    }

    public CommissionSheetDetailHistory setCommissionSheet(CommissionSheetHistory commissionSheetHistory) {
        this.commissionSheetHistory = commissionSheetHistory;
        return this;
    }

    public Integer getDetno() {
        return detno;
    }

    public CommissionSheetDetailHistory setDetno(Integer detno) {
        this.detno = detno;
        return this;
    }

    public String getCommodityName() {
        return commodityName;
    }

    public CommissionSheetDetailHistory setCommodityName(String commodityName) {
        this.commodityName = commodityName;
        return this;
    }

    public String getCmpCode() {
        return cmpCode;
    }

    public CommissionSheetDetailHistory setCmpCode(String cmpCode) {
        this.cmpCode = cmpCode;
        return this;
    }

    public Long getAmount() {
        return amount;
    }

    public CommissionSheetDetailHistory setAmount(Long amount) {
        this.amount = amount;
        return this;
    }

    public Integer getCartonNum() {
        return cartonNum;
    }

    public CommissionSheetDetailHistory setCartonNum(Integer cartonNum) {
        this.cartonNum = cartonNum;
        return this;
    }

    public Double getNetWeight() {
        return netWeight;
    }

    public CommissionSheetDetailHistory setNetWeight(Double netWeight) {
        this.netWeight = netWeight;
        return this;
    }

    public Double getGrossWeight() {
        return grossWeight;
    }

    public CommissionSheetDetailHistory setGrossWeight(Double grossWeight) {
        this.grossWeight = grossWeight;
        return this;
    }

    public String getCurrency() {
        return currency;
    }

    public CommissionSheetDetailHistory setCurrency(String currency) {
        this.currency = currency;
        return this;
    }

    public Double getUnitPrice() {
        return unitPrice;
    }

    public CommissionSheetDetailHistory setUnitPrice(Double unitPrice) {
        this.unitPrice = unitPrice;
        return this;
    }

    public Double getTotalPrice() {
        return totalPrice;
    }

    public CommissionSheetDetailHistory setTotalPrice(Double totalPrice) {
        this.totalPrice = totalPrice;
        return this;
    }

    public String getBrand() {
        return brand;
    }

    public CommissionSheetDetailHistory setBrand(String brand) {
        this.brand = brand;
        return this;
    }

    public String getProducingArea() {
        return producingArea;
    }

    public CommissionSheetDetailHistory setProducingArea(String producingArea) {
        this.producingArea = producingArea;
        return this;
    }

    public String getRemark() {
        return remark;
    }

    public CommissionSheetDetailHistory setRemark(String remark) {
        this.remark = remark;
        return this;
    }

    public String getRemarkSimplify() {
        return remarkSimplify;
    }

    public CommissionSheetDetailHistory setRemarkSimplify(String remarkSimplify) {
        this.remarkSimplify = remarkSimplify;
        return this;
    }

    public String getBatchNum() {
        return batchNum;
    }

    public CommissionSheetDetailHistory setBatchNum(String batchNum) {
        this.batchNum = batchNum;
        return this;
    }

    public Boolean getAmountError() {
        return amountError;
    }

    public CommissionSheetDetailHistory setAmountError(Boolean amountError) {
        this.amountError = amountError;
        return this;
    }

    public String getAmountErrorMessage() {
        return amountErrorMessage;
    }

    public CommissionSheetDetailHistory setAmountErrorMessage(String amountErrorMessage) {
        this.amountErrorMessage = amountErrorMessage;
        return this;
    }

    public String getCartonNumErrorMessage() {
        return cartonNumErrorMessage;
    }

    public CommissionSheetDetailHistory setCartonNumErrorMessage(String cartonNumErrorMessage) {
        this.cartonNumErrorMessage = cartonNumErrorMessage;
        return this;
    }

    public Boolean getCartonNumError() {
        return cartonNumError;
    }

    public CommissionSheetDetailHistory setCartonNumError(Boolean cartonNumError) {
        this.cartonNumError = cartonNumError;
        return this;
    }

    public Boolean getNetWeightError() {
        return netWeightError;
    }

    public CommissionSheetDetailHistory setNetWeightError(Boolean netWeightError) {
        this.netWeightError = netWeightError;
        return this;
    }

    public String getNetWeightErrorMessage() {
        return netWeightErrorMessage;
    }

    public CommissionSheetDetailHistory setNetWeightErrorMessage(String netWeightErrorMessage) {
        this.netWeightErrorMessage = netWeightErrorMessage;
        return this;
    }

    public Boolean getGrossWeightError() {
        return grossWeightError;
    }

    public CommissionSheetDetailHistory setGrossWeightError(Boolean grossWeightError) {
        this.grossWeightError = grossWeightError;
        return this;
    }

    public String getGrossWeightErrorMessage() {
        return grossWeightErrorMessage;
    }

    public CommissionSheetDetailHistory setGrossWeightErrorMessage(String grossWeightErrorMessage) {
        this.grossWeightErrorMessage = grossWeightErrorMessage;
        return this;
    }

    public String getCurrencyErrorMessage() {
        return currencyErrorMessage;
    }

    public CommissionSheetDetailHistory setCurrencyErrorMessage(String currencyErrorMessage) {
        this.currencyErrorMessage = currencyErrorMessage;
        return this;
    }

    public Boolean getCurrencyError() {
        return currencyError;
    }

    public CommissionSheetDetailHistory setCurrencyError(Boolean currencyError) {
        this.currencyError = currencyError;
        return this;
    }

    public Boolean getUnitPriceError() {
        return unitPriceError;
    }

    public CommissionSheetDetailHistory setUnitPriceError(Boolean unitPriceError) {
        this.unitPriceError = unitPriceError;
        return this;
    }

    public String getUnitPriceErrorMessage() {
        return unitPriceErrorMessage;
    }

    public CommissionSheetDetailHistory setUnitPriceErrorMessage(String unitPriceErrorMessage) {
        this.unitPriceErrorMessage = unitPriceErrorMessage;
        return this;
    }

    public Boolean getTotalPriceError() {
        return totalPriceError;
    }

    public CommissionSheetDetailHistory setTotalPriceError(Boolean totalPriceError) {
        this.totalPriceError = totalPriceError;
        return this;
    }

    public String getTotalPriceErrorMessage() {
        return totalPriceErrorMessage;
    }

    public CommissionSheetDetailHistory setTotalPriceErrorMessage(String totalPriceErrorMessage) {
        this.totalPriceErrorMessage = totalPriceErrorMessage;
        return this;
    }

    public String getBrandErrorMessage() {
        return brandErrorMessage;
    }

    public CommissionSheetDetailHistory setBrandErrorMessage(String brandErrorMessage) {
        this.brandErrorMessage = brandErrorMessage;
        return this;
    }

    public Boolean getBrandError() {
        return brandError;
    }

    public CommissionSheetDetailHistory setBrandError(Boolean brandError) {
        this.brandError = brandError;
        return this;
    }

    public String getProducingAreaErrorMessage() {
        return producingAreaErrorMessage;
    }

    public CommissionSheetDetailHistory setProducingAreaErrorMessage(String producingAreaErrorMessage) {
        this.producingAreaErrorMessage = producingAreaErrorMessage;
        return this;
    }

    public Boolean getProducingAreaError() {
        return producingAreaError;
    }

    public CommissionSheetDetailHistory setProducingAreaError(Boolean producingAreaError) {
        this.producingAreaError = producingAreaError;
        return this;
    }

    public String getBatchNumErrorMessage() {
        return batchNumErrorMessage;
    }

    public CommissionSheetDetailHistory setBatchNumErrorMessage(String batchNumErrorMessage) {
        this.batchNumErrorMessage = batchNumErrorMessage;
        return this;
    }

    public Boolean getBatchNumError() {
        return batchNumError;
    }

    public CommissionSheetDetailHistory setBatchNumError(Boolean batchNumError) {
        this.batchNumError = batchNumError;
        return this;
    }

    public String getAmountStr() {
        return amountStr;
    }

    public CommissionSheetDetailHistory setAmountStr(String amountStr) {
        this.amountStr = amountStr;
        return this;
    }

    public String getCartonNumStr() {
        return cartonNumStr;
    }

    public CommissionSheetDetailHistory setCartonNumStr(String cartonNumStr) {
        this.cartonNumStr = cartonNumStr;
        return this;
    }

    public String getNetWeightStr() {
        return netWeightStr;
    }

    public CommissionSheetDetailHistory setNetWeightStr(String netWeightStr) {
        this.netWeightStr = netWeightStr;
        return this;
    }

    public String getGrossWeightStr() {
        return grossWeightStr;
    }

    public CommissionSheetDetailHistory setGrossWeightStr(String grossWeightStr) {
        this.grossWeightStr = grossWeightStr;
        return this;
    }

    public String getUnitPriceStr() {
        return unitPriceStr;
    }

    public CommissionSheetDetailHistory setUnitPriceStr(String unitPriceStr) {
        this.unitPriceStr = unitPriceStr;
        return this;
    }

    public String getTotalPriceStr() {
        return totalPriceStr;
    }

    public CommissionSheetDetailHistory setTotalPriceStr(String totalPriceStr) {
        this.totalPriceStr = totalPriceStr;
        return this;
    }

    public String getOperatorRevisionHistory() {
        return operatorRevisionHistory;
    }

    public CommissionSheetDetailHistory setOperatorRevisionHistory(String operatorRevisionHistory) {
        this.operatorRevisionHistory = operatorRevisionHistory;
        return this;
    }

    public String getCustomerServiceOperator() {
        return customerServiceOperator;
    }

    public CommissionSheetDetailHistory setCustomerServiceOperator(String customerServiceOperator) {
        this.customerServiceOperator = customerServiceOperator;
        return this;
    }

    public String getStorageServiceOperator() {
        return storageServiceOperator;
    }

    public CommissionSheetDetailHistory setStorageServiceOperator(String storageServiceOperator) {
        this.storageServiceOperator = storageServiceOperator;
        return this;
    }

    public CommissionSheetHistory getCommissionSheetHistory() {
        return commissionSheetHistory;
    }

    public CommissionSheetDetailHistory setCommissionSheetHistory(CommissionSheetHistory commissionSheetHistory) {
        this.commissionSheetHistory = commissionSheetHistory;
        return this;
    }

    public void updateInfo(Map<String, String> map) {
        String amountStr = map.get("amountStr");
        if (!StringUtils.isEmpty(amountStr)) {
            this.amountStr = StringUtils.cutOutBlank(amountStr);
            if (IntegerUtil.isInteger(this.amountStr)) {
                this.amount = Long.valueOf(this.amountStr);
            }
        }
        String batchNum = map.get("batchNum");
        if (!StringUtils.isEmpty(batchNum)) {
            this.batchNum = batchNum;
        }
        String brand = map.get("brand");
        if (!StringUtils.isEmpty(brand)) {
            this.brand = StringUtils.formatcmpName(brand);
        }
        String cartonNumStr = map.get("cartonNumStr");
        if (!StringUtils.isEmpty(cartonNumStr)) {
            this.cartonNumStr = StringUtils.cutOutBlank(cartonNumStr);
            if (IntegerUtil.isInteger(this.cartonNumStr)) {
                this.cartonNum = Integer.valueOf(this.cartonNumStr);
            }
        }

        String cmpCode = map.get("cmpCode");
        if (!StringUtils.isEmpty(cartonNumStr)) {
            this.cmpCode = StringUtils.formatcmpName(cmpCode);
        }
        String commodityName = map.get("commodityName");
        if (!StringUtils.isEmpty(cartonNumStr)) {
            this.commodityName = StringUtils.formatcmpName(commodityName);
        }
        String currency = map.get("currency");
        if (!StringUtils.isEmpty(cartonNumStr)) {
            this.currency = currency;
        }
        String grossWeightStr = map.get("grossWeightStr");
        if (!StringUtils.isEmpty(grossWeightStr)) {
            this.grossWeightStr = StringUtils.cutOutBlank(grossWeightStr);
            if (DoubleUtil.isNumber(this.cartonNumStr)) {
                this.grossWeight = Double.valueOf(this.grossWeightStr);
            }
        }
        String netWeightStr = map.get("netWeightStr");
        if (!StringUtils.isEmpty(netWeightStr)) {
            this.netWeightStr = StringUtils.cutOutBlank(netWeightStr);
            if (DoubleUtil.isNumber(this.netWeightStr)) {
                this.netWeight = Double.valueOf(this.netWeightStr);
            }
        }
        String unitPriceStr = map.get("unitPriceStr");
        if (!StringUtils.isEmpty(unitPriceStr)) {
            this.netWeightStr = StringUtils.cutOutBlank(unitPriceStr);
            if (DoubleUtil.isNumber(this.unitPriceStr)) {
                this.unitPrice = Double.valueOf(this.unitPriceStr);
            }
        }
        String totalPriceStr = map.get("totalPriceStr");
        if (!StringUtils.isEmpty(totalPriceStr)) {
            this.totalPriceStr = StringUtils.cutOutBlank(totalPriceStr);
            if (DoubleUtil.isNumber(this.totalPriceStr)) {
                this.totalPrice = Double.valueOf(this.totalPriceStr);
            }
        }
        String producingArea = map.get("producingArea");
        if (!StringUtils.isEmpty(producingArea)) {
            this.producingArea = StringUtils.formatcmpName(producingArea);
        }
        String remark = map.get("remark");
        if (!StringUtils.isEmpty(remark)) {
            this.remark = remark;
        }

    }
}
