package com.uas.customsdeclaration.business.common.model;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.Table;
import java.io.Serializable;

/**
 * 币别汇总表
 *
 * @author yuj 2018-03-08 16:20
 */
@Entity
@Table(name = "cd$currencylist")
public class CurrencyList implements Serializable {

    private static final long serialVersionUID = 3012296921566281004L;

    @Id
    @Column(name = "id")
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    private Long id;

    /**
     * 币别缩写
     */
    @Column(name = "cl_cur_abbreviate")
    private String curAbbreviate;

    /**
     * 币别中文
     */
    @Column(name = "cl_cur_chinese")
    private String curChinese;

    /**
     * 币别英文
     */
    @Column(name = "cl_cur_enghlish")
    private String  curEnghlish;

    /**
     * 币别别名
     */
    @Column(name = "cl_cur_alias")
    private String curAlias;

    /**
     * 币别代码
     */
    @Column(name = "cl_code")
    private String code;

    public Long getId() {
        return id;
    }

    public CurrencyList setId(Long id) {
        this.id = id;
        return this;
    }

    public String getCurAbbreviate() {
        return curAbbreviate;
    }

    public CurrencyList setCurAbbreviate(String curAbbreviate) {
        this.curAbbreviate = curAbbreviate;
        return this;
    }

    public String getCurChinese() {
        return curChinese;
    }

    public CurrencyList setCurChinese(String curChinese) {
        this.curChinese = curChinese;
        return this;
    }

    public String getCurEnghlish() {
        return curEnghlish;
    }

    public CurrencyList setCurEnghlish(String curEnghlish) {
        this.curEnghlish = curEnghlish;
        return this;
    }

    public String getCurAlias() {
        return curAlias;
    }

    public CurrencyList setCurAlias(String curAlias) {
        this.curAlias = curAlias;
        return this;
    }

    public String getCode() {
        return code;
    }

    public CurrencyList setCode(String code) {
        this.code = code;
        return this;
    }

    @Override
    public String toString() {
        return "CurrencyList{" +
                "id=" + id +
                ", curAbbreviate='" + curAbbreviate + '\'' +
                ", curChinese='" + curChinese + '\'' +
                ", curEnghlish='" + curEnghlish + '\'' +
                ", curAlias='" + curAlias + '\'' +
                ", code='" + code + '\'' +
                '}';
    }
}
