package com.uas.customsdeclaration.business.common.model;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.Table;
import java.io.Serializable;

/**
 * 快递的地址信息
 *
 * @author yuj 2018-03-06 16:55
 */
@Entity
@Table(name = "cd$expressaddress")
public class ExpressAddress implements Serializable{

    private static final long serialVersionUID = 9191308279542637436L;

    @Id
    @Column(name = "id")
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    private Long id;

    /**
     * 联系人
     */
    @Column(name = "ea_name")
    private String name;

    /**
     * 联系电话
     */
    @Column(name = "ea_telephone")
    private String telephone;

    /**
     * 地区
     */
    @Column(name = "ea_area")
    private String area;

    /**
     * 详细地址
     */
    @Column(name = "ea_detailaddress")
    private String detailAddress;

    public Long getId() {
        return id;
    }

    public ExpressAddress setId(Long id) {
        this.id = id;
        return this;
    }

    public String getName() {
        return name;
    }

    public ExpressAddress setName(String name) {
        this.name = name;
        return this;
    }

    public String getTelephone() {
        return telephone;
    }

    public ExpressAddress setTelephone(String telephone) {
        this.telephone = telephone;
        return this;
    }

    public String getArea() {
        return area;
    }

    public ExpressAddress setArea(String area) {
        this.area = area;
        return this;
    }

    public String getDetailAddress() {
        return detailAddress;
    }

    public ExpressAddress setDetailAddress(String detailAddress) {
        this.detailAddress = detailAddress;
        return this;
    }

    @Override
    public String toString() {
        return "ExpressAddress{" +
                "id=" + id +
                ", name='" + name + '\'' +
                ", telephone='" + telephone + '\'' +
                ", area='" + area + '\'' +
                ", detailAddress='" + detailAddress + '\'' +
                '}';
    }
}
