package com.uas.customsdeclaration.business.common.model;

import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.Table;
import java.io.Serializable;
import java.util.Date;

/**
 * 操作的历史记录
 *
 * @author yuj 2018-03-19 22:11
 */
@Entity
@Table(name = "cd$operatormessage")
public class OperatorMessage implements Serializable {

    private static final long serialVersionUID = 5050837809138856046L;

    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    @Column(name = "id")
    private Long id;


    /**
     * 登录的个人信息
     */
    @Column(name = "om_useruu")
    private Long useruu;

    /**
     * 操作人信息
     */
    @Column(name = "om_username")
    private String userName;

    /**
     * 操作的企业信息
     */
    @Column(name = "om_enuu")
    private Long enuu;

    /**
     * 登录的公司
     */
    @Column(name = "om_companyname")
    private String companyName;


    /**
     * 操作描述
     */
    @Column(name = "om_message")
    private String message;

    /**
     * 操作时间
     */
    @Column(name = "om_operatetime")
    private Date operateTime;

    /**
     * 序号
     */
    @Column(name = "om_detno")
    private Integer detno;

    @ManyToOne(cascade = {CascadeType.PERSIST, CascadeType.REFRESH, CascadeType.DETACH, CascadeType.MERGE}, optional = true)
    @JoinColumn(name = "sheet_id", nullable = false)
    private CommissionSheet commissionSheet;

    public Long getId() {
        return id;
    }

    public OperatorMessage setId(Long id) {
        this.id = id;
        return this;
    }

    public Long getUseruu() {
        return useruu;
    }

    public OperatorMessage setUseruu(Long useruu) {
        this.useruu = useruu;
        return this;
    }

    public String getMessage() {
        return message;
    }

    public OperatorMessage setMessage(String message) {
        this.message = message;
        return this;
    }

    public Date getOperateTime() {
        return operateTime;
    }

    public OperatorMessage setOperateTime(Date operateTime) {
        this.operateTime = operateTime;
        return this;
    }

    public Integer getDetno() {
        return detno;
    }

    public OperatorMessage setDetno(Integer detno) {
        this.detno = detno;
        return this;
    }

    public Long getEnuu() {
        return enuu;
    }

    public OperatorMessage setEnuu(Long enuu) {
        this.enuu = enuu;
        return this;
    }

    public CommissionSheet getCommissionSheet() {
        return commissionSheet;
    }

    public OperatorMessage setCommissionSheet(CommissionSheet commissionSheet) {
        this.commissionSheet = commissionSheet;
        return this;
    }

    public String getUserName() {
        return userName;
    }

    public OperatorMessage setUserName(String userName) {
        this.userName = userName;
        return this;
    }

    public String getCompanyName() {
        return companyName;
    }

    public OperatorMessage setCompanyName(String companyName) {
        this.companyName = companyName;
        return this;
    }

    @Override
    public String toString() {
        return "OperatorMessage{" +
                "id=" + id +
                ", useruu=" + useruu +
                ", userName='" + userName + '\'' +
                ", enuu=" + enuu +
                ", companyName='" + companyName + '\'' +
                ", message='" + message + '\'' +
                ", operateTime=" + operateTime +
                ", detno=" + detno +
                ", commissionSheet=" + commissionSheet +
                '}';
    }
}
