package com.uas.customsdeclaration.business.common.model;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.Table;
import java.io.Serializable;
import java.util.Date;

/**
 * 成交配置方式
 *
 * @author yuj 2018-03-27 14:04
 */
@Entity
@Table(name = "cd$transactionmode")
public class TransactionMode implements Serializable {

    private static final long serialVersionUID = 2970987690642477827L;

    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    private Long id;

    /**
     * 成交方式
     */
    @Column(name = "tm_mode")
    private String mode;

    /**
     * 创建方式
     */
    @Column(name = "tm_create_time")
    private Date createTime;

    /**
     * 描述
     */
    @Column(name = "tm_description")
    private String description;

    /**
     * 备注
     */
    @Column(name = "tm_remark")
    private String remark;

    public Long getId() {
        return id;
    }

    public TransactionMode setId(Long id) {
        this.id = id;
        return this;
    }

    public String getMode() {
        return mode;
    }

    public TransactionMode setMode(String mode) {
        this.mode = mode;
        return this;
    }

    public Date getCreateTime() {
        return createTime;
    }

    public TransactionMode setCreateTime(Date createTime) {
        this.createTime = createTime;
        return this;
    }

    public String getDescription() {
        return description;
    }

    public TransactionMode setDescription(String description) {
        this.description = description;
        return this;
    }

    public String getRemark() {
        return remark;
    }

    public TransactionMode setRemark(String remark) {
        this.remark = remark;
        return this;
    }

    @Override
    public String toString() {
        return "TransactionMode{" +
                "id=" + id +
                ", mode='" + mode + '\'' +
                ", createTime=" + createTime +
                ", description='" + description + '\'' +
                ", remark='" + remark + '\'' +
                '}';
    }
}
