package com.uas.customsdeclaration.business.common.service.impl;

import com.uas.customsdeclaration.business.common.dao.CommissionSheetDao;
import com.uas.customsdeclaration.business.common.dao.CommissionSheetDetailDao;
import com.uas.customsdeclaration.business.common.model.CommissionSheet;
import com.uas.customsdeclaration.business.common.model.CommissionSheetDetail;
import com.uas.customsdeclaration.business.common.service.CommissionSheetDetailService;
import com.uas.customsdeclaration.business.common.service.CommissionSheetService;
import com.uas.customsdeclaration.util.CodeType;
import com.uas.customsdeclaration.util.ResultMap;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.Set;

/**
 * 委托单明细的实现层
 *
 * @author yuj 2018-03-12 16:56
 */
@Service
public class CommissionSheetDetailServiceImpl implements CommissionSheetDetailService {

    private final CommissionSheetDetailDao commissionSheetDetailDao;

    private final CommissionSheetService commissionSheetService;

    private final CommissionSheetDao commissionSheetDao;

    @Autowired
    public CommissionSheetDetailServiceImpl(CommissionSheetDetailDao commissionSheetDetailDao, CommissionSheetService commissionSheetService, CommissionSheetDao commissionSheetDao) {
        this.commissionSheetDetailDao = commissionSheetDetailDao;
        this.commissionSheetService = commissionSheetService;
        this.commissionSheetDao = commissionSheetDao;
    }

    /**
     * 根据id删除 委托单明细
     *
     * @param id
     * @return ResultMap
     */
    @Transactional
    @Override
    public ResultMap deleteDetailById(Long id) {
        if (id == null) {
            return new ResultMap(CodeType.FAILURE, "传入的信息为空");
        } else {
            CommissionSheetDetail sheetDetail = commissionSheetDetailDao.findOne(id);
            if (sheetDetail == null) {
                return new ResultMap(CodeType.FAILURE, "找不到对应的信息");
            }
            commissionSheetDetailDao.delete(id);
            CommissionSheet commissionSheet = commissionSheetDao.findOne(sheetDetail.getCommissionSheet().getId());
            Set<CommissionSheetDetail> sheetDetail1 = commissionSheet.getCommissionSheetDetail();
            int i = 1;
            CommissionSheetDetail deleteDetail = null;
            for (CommissionSheetDetail detail : sheetDetail1) {
                if (detail.getId().longValue() == id.longValue()) {
                    deleteDetail = detail;
                } else {
                    detail.setDetno(i);
                    i++;
                }
            }
            sheetDetail1.remove(deleteDetail);
            commissionSheet.setCommissionSheetDetail(sheetDetail1);
            commissionSheetDao.save(commissionSheet);
            return new ResultMap(CodeType.OK, "成功");
        }
    }
}
