package com.uas.customsdeclaration.business.common.service.impl;

import com.uas.account.sso.integration.entity.UserAccount;
import com.uas.account.sso.integration.util.SSO;
import com.uas.customsdeclaration.business.common.constant.CommissionSheetConstant;
import com.uas.customsdeclaration.business.common.dao.BasicConfigureDao;
import com.uas.customsdeclaration.business.common.dao.CommissionSheetDao;
import com.uas.customsdeclaration.business.common.dao.CurrencyListDao;
import com.uas.customsdeclaration.business.common.dao.ProduceAreaDao;
import com.uas.customsdeclaration.business.common.dao.TransactionModeDao;
import com.uas.customsdeclaration.business.common.model.BasicConfigure;
import com.uas.customsdeclaration.business.common.model.CommissionSheet;
import com.uas.customsdeclaration.business.common.model.CommissionSheetDetail;
import com.uas.customsdeclaration.business.common.model.CurrencyList;
import com.uas.customsdeclaration.business.common.model.ExpressAddress;
import com.uas.customsdeclaration.business.common.model.ProduceArea;
import com.uas.customsdeclaration.business.common.model.TransactionMode;
import com.uas.customsdeclaration.business.common.service.CommissionSheetService;
import com.uas.customsdeclaration.business.common.status.SheetStatus;
import com.uas.customsdeclaration.business.common.status.ValidateStatus;
import com.uas.customsdeclaration.business.common.type.BasicConfigureType;
import com.uas.customsdeclaration.business.common.util.CommissionSheetConvertToCustomerHouseServiceSheetUtil;
import com.uas.customsdeclaration.business.common.util.CommissionSheetDetailUtil;
import com.uas.customsdeclaration.business.facilitator.dao.CustomerCodeInfoDao;
import com.uas.customsdeclaration.business.facilitator.dao.CustomerHouseServiceSheetDao;
import com.uas.customsdeclaration.business.facilitator.dao.CustomerHouseServiceSheetDetailDao;
import com.uas.customsdeclaration.business.facilitator.dao.DeliveryTypeDao;
import com.uas.customsdeclaration.business.facilitator.dao.FacilitatorDao;
import com.uas.customsdeclaration.business.facilitator.model.CustomerCodeInfo;
import com.uas.customsdeclaration.business.facilitator.model.CustomerHouseServiceSheet;
import com.uas.customsdeclaration.business.facilitator.model.CustomerHouseServiceSheetDetail;
import com.uas.customsdeclaration.business.facilitator.model.DeliveryType;
import com.uas.customsdeclaration.business.facilitator.model.Facilitator;
import com.uas.customsdeclaration.business.facilitator.model.ImportExportDelivery;
import com.uas.customsdeclaration.common.base.service.FileService;
import com.uas.customsdeclaration.core.DoubleConstant;
import com.uas.customsdeclaration.core.IntegerConstant;
import com.uas.customsdeclaration.core.LongConstant;
import com.uas.customsdeclaration.core.RegexConstant;
import com.uas.customsdeclaration.core.StringConstant;
import com.uas.customsdeclaration.core.UserInfoUtil;
import com.uas.customsdeclaration.util.CodeType;
import com.uas.customsdeclaration.util.DoubleUtil;
import com.uas.customsdeclaration.util.HSSFWorkbookUtil;
import com.uas.customsdeclaration.util.IntegerUtil;
import com.uas.customsdeclaration.util.LongArray;
import com.uas.customsdeclaration.util.NumberUtil;
import com.uas.customsdeclaration.util.OrderNumberUtil;
import com.uas.customsdeclaration.util.ResultMap;
import com.uas.customsdeclaration.util.SheetXlsxUtil;
import com.uas.customsdeclaration.util.StringUtils;
import com.uas.customsdeclaration.util.WorkBookFillDataUtil;
import com.uas.customsdeclaration.util.ZHConverter;
import com.uas.customsdeclaration.util.ZipUtil;
import com.uas.platform.core.model.PageInfo;
import com.uas.platform.core.model.PageParams;
import com.uas.platform.core.persistence.criteria.CriterionExpression;
import com.uas.platform.core.persistence.criteria.LogicalExpression;
import com.uas.platform.core.persistence.criteria.SimpleExpression;
import com.uas.platform.core.util.serializer.FlexJsonUtils;
import org.apache.commons.collections.CollectionUtils;
import org.apache.poi.hssf.usermodel.HSSFWorkbook;
import org.apache.poi.ss.usermodel.Cell;
import org.apache.poi.ss.usermodel.CellType;
import org.apache.poi.ss.usermodel.Row;
import org.apache.poi.ss.usermodel.Sheet;
import org.apache.poi.ss.usermodel.Workbook;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Sort;
import org.springframework.data.jpa.domain.Specification;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.web.multipart.MultipartFile;

import javax.persistence.EntityManager;
import javax.persistence.criteria.CriteriaBuilder;
import javax.persistence.criteria.CriteriaQuery;
import javax.persistence.criteria.Predicate;
import javax.persistence.criteria.Root;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.BufferedOutputStream;
import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStream;
import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Set;
import java.util.regex.Pattern;

import static com.uas.customsdeclaration.business.common.util.CommissionSheetConvertToCustomerHouseServiceSheetUtil.commissionSheetSplitCell;
import static com.uas.customsdeclaration.util.SheetXlsxUtil.getCellValue;
import static com.uas.customsdeclaration.util.StringUtils.formatcmpName;

/**
 * description
 *
 * @author yuj 2018-03-01 16:53
 */
@Service
public class CommissionSheetServiceImpl implements CommissionSheetService {

    private final CommissionSheetDao commissionSheetDao;

    private final UserInfoUtil userInfoUtil;

    private final ProduceAreaDao produceAreaDao;

    private final CurrencyListDao currencyListDao;

    private final DeliveryTypeDao deliveryTypeDao;

    private final FacilitatorDao facilitatorDao;

    private final FileService fileService;

    private final CustomerHouseServiceSheetDao customerHouseServiceSheetDao;

    private final CustomerHouseServiceSheetDetailDao customerHouseServiceSheetDetailDao;

    private final CustomerCodeInfoDao customerCodeInfoDao;

    private final TransactionModeDao  transactionModeDao;

    private final JdbcTemplate jdbcTemplate;

    private final EntityManager entityManager;

    private final BasicConfigureDao basicConfigureDao;

    @Autowired
    public CommissionSheetServiceImpl(CommissionSheetDao commissionSheetDao, UserInfoUtil userInfoUtil, ProduceAreaDao produceAreaDao, CurrencyListDao currencyListDao, DeliveryTypeDao deliveryTypeDao, FacilitatorDao facilitatorDao, FileService fileService, CustomerHouseServiceSheetDao customerHouseServiceSheetDao, CustomerHouseServiceSheetDetailDao customerHouseServiceSheetDetailDao, CustomerCodeInfoDao customerCodeInfoDao, TransactionModeDao transactionModeDao, JdbcTemplate jdbcTemplate, EntityManager entityManager, BasicConfigureDao basicConfigureDao) {
        this.commissionSheetDao = commissionSheetDao;
        this.userInfoUtil = userInfoUtil;
        this.produceAreaDao = produceAreaDao;
        this.currencyListDao = currencyListDao;
        this.deliveryTypeDao = deliveryTypeDao;
        this.facilitatorDao = facilitatorDao;
        this.fileService = fileService;
        this.customerHouseServiceSheetDao = customerHouseServiceSheetDao;
        this.customerHouseServiceSheetDetailDao = customerHouseServiceSheetDetailDao;
        this.customerCodeInfoDao = customerCodeInfoDao;
        this.transactionModeDao = transactionModeDao;
        this.jdbcTemplate = jdbcTemplate;
        this.entityManager = entityManager;
        this.basicConfigureDao = basicConfigureDao;
    }

    @Override
    public ResultMap save(CommissionSheet sheet, MultipartFile addressFile, MultipartFile contact, MultipartFile bill, MultipartFile packagelist) {
        if (sheet == null) {
            return new ResultMap(CodeType.FAILURE, "传入的信息为空");
        } else {
            ResultMap resultMap = validateMainSheetIsCompleteInfoAndLegalData(sheet);
            if (resultMap.getCode() != CodeType.OK.code()) {
                return resultMap;
            }
            // 繁体转简体
            convertToSimplify(sheet);
            //验证数据
            validateSheetDetailsInfo(sheet);
            //统计数据
            statisticalCommissionSheetData(sheet);
            if (addressFile != null) {
                String url = fileService.save(addressFile);
                sheet.setDeliveryFileUrl(url);
            }
            if (contact != null) {
                String contactUrl = fileService.save(contact);
                sheet.setContactUrl(contactUrl);
            }
            if (bill != null) {
                String billUrl = fileService.save(bill);
                sheet.setBillUrl(billUrl);
            }
            if (packagelist != null) {
                String packagelistUrl = fileService.save(packagelist);
                sheet.setPackagelistUrl(packagelistUrl);
            }
            CommissionSheet commissionSheet = commissionSheetDao.save(sheet);
            if (commissionSheet.getStatus().intValue() == SheetStatus.INDATAVALIDATEPASS.getCode()) {
                return new ResultMap(CodeType.VALIDATE_FAILURE.code(), "信息验证不通过", commissionSheet);
            } else {
                return new ResultMap(CodeType.OK.code(), "信息验证通过", commissionSheet);
            }
        }
    }

    /**
     * 验证CommissionSheet是否填写完整
     *
     * @param sheet
     * @return 如果填写完整，并且数据合法，
     */
    @Override
    public ResultMap validateMainSheetIsCompleteInfoAndLegalData(CommissionSheet sheet) {
        if (sheet == null) {
            return new ResultMap(CodeType.DEFICIENCY_INFO, "委托单信息为空，请填写之后重新上传");
        }
        UserAccount userAccount = SSO.get();
        if (userAccount == null) {
            return new ResultMap(CodeType.FAILURE, "登录的信息为空，请登录之后再操作。");
        }
        Long baileeCompanyenuu = sheet.getBaileeCompanyenuu();
        if (baileeCompanyenuu == null) {
            return new ResultMap(CodeType.DEFICIENCY_INFO, "报关公司为空，填写再上传");
        }
        String baileeCompanyName = sheet.getBaileeCompanyName();
        if (StringUtils.isEmpty(baileeCompanyName)) {
            return new ResultMap(CodeType.DEFICIENCY_INFO, "报关公司为空，填写再上传");
        }
        if (userAccount.getSpaceUU() == null) {
            return new ResultMap(CodeType.FAILURE, "登录的公司为空，请重新登录选择对应的公司");
        }
        sheet.setCommissionCompanyEnuu(Long.valueOf(userAccount.getSpaceUU()));
        sheet.setCommissionCompany(userAccount.getSpaceName());
        sheet.setCommissionPersonLiable(userAccount.getVipName());
        sheet.setCommissionPersonLiableTel(userAccount.getMobile());
        sheet.setCommissionPersonLiableUseruu(userAccount.getUserUU());
        String deliveryType = sheet.getDeliveryType();
        if (StringUtils.isEmpty(deliveryType)) {
            return new ResultMap(CodeType.DEFICIENCY_INFO, "交货方式不正确，修改之后再上传");
        } else {
            DeliveryType type = null;
            List<DeliveryType> deliveryAndDescription = deliveryTypeDao.getDeliveryTypeByEnuuAndImportExportDeliveryAndDescription(baileeCompanyenuu, ImportExportDelivery.IMPORTDELIVERY, deliveryType);
            if (CollectionUtils.isEmpty(deliveryAndDescription)) {
                return new ResultMap(CodeType.DEFICIENCY_INFO, "交货方式不正确，修改之后再上传");
            } else {
                type = deliveryAndDescription.get(0);
                sheet.setDeliveryType(type.getDescription());
            }
            if (type.getRequiredAddress()) {
                ExpressAddress deliveryAddress = sheet.getDeliveryAddress();
                Boolean validAddress = validAddress(deliveryAddress);
                if (!validAddress) {
                    return new ResultMap(CodeType.DEFICIENCY_INFO, "交货联系信息缺失，填写再上传");
                }
                sheet.setDeliveryContactInfo(FlexJsonUtils.toJson(deliveryAddress));
            }
        }

        String stockType = sheet.getStockType();
        if (StringUtils.isEmpty(stockType)) {
            return new ResultMap(CodeType.DEFICIENCY_INFO, "交货方式不正确，修改之后再上传");
        } else {
            DeliveryType type = null;
            List<DeliveryType> deliveryAndDescription = deliveryTypeDao.getDeliveryTypeByEnuuAndImportExportDeliveryAndDescription(baileeCompanyenuu, ImportExportDelivery.IMPORTSTOCK, stockType);
            if (CollectionUtils.isEmpty(deliveryAndDescription)) {
                return new ResultMap(CodeType.DEFICIENCY_INFO, "交货方式不正确，修改之后再上传");
            } else {
                type = deliveryAndDescription.get(0);
                sheet.setStockType(type.getDescription());
            }
            if (type.getRequiredAddress()) {
                ExpressAddress deliveryAddress = sheet.getStockAddress();
                Boolean validAddress = validAddress(deliveryAddress);
                if (!validAddress) {
                    return new ResultMap(CodeType.DEFICIENCY_INFO, "交货联系信息缺失，填写再上传");
                }
                sheet.setStockContactInfo(FlexJsonUtils.toJson(deliveryAddress));
            }
        }

        Set<CommissionSheetDetail> sheetDetails = sheet.getCommissionSheetDetail();
        ResultMap resultMap = validateDetailSheetIsCompleteInfoAndLegalData(sheetDetails, sheet, IntegerConstant.single);
        if (resultMap.getCode() != CodeType.OK.code()) {
            return resultMap;
        }
        sheet.setApplyName(userAccount.getVipName());
        sheet.setApplyTime(new Date(System.currentTimeMillis()));
        sheet.setApplyUseruu(Long.valueOf(userAccount.getUserUU()));

        String orderId = OrderNumberUtil.getOrderId();
        sheet.setCsid(orderId);
        return ResultMap.success(null);
    }

    /**
     * 验证CommissionSheet是否填写完整
     *
     * @param sheetDetails
     * @param detno 序号
     * @param sheet 主表信息
     * @return 如果填写完整，并且数据合法，
     */
    @Override
    public ResultMap validateDetailSheetIsCompleteInfoAndLegalData(Set<CommissionSheetDetail> sheetDetails, CommissionSheet sheet, Integer detno) {
        if (CollectionUtils.isEmpty(sheetDetails)) {
            return new ResultMap(CodeType.DEFICIENCY_INFO, "委托单商品明细缺失");
        }
        ArrayList<CommissionSheetDetail> sheetDetails1 = CommissionSheetDetailUtil.commissionSheetDetailOrderByDetnoASC(sheetDetails);
        for (CommissionSheetDetail detail : sheetDetails1) {
            if (detail.getAmount() != null) {
                detail.setAmountStr(detail.getAmount().toString());
            } else {
                detail.setAmountStr(null);
            }

            if (detail.getCartonNum() != null) {
                detail.setCartonNumStr(detail.getCartonNum().toString());
            } else {
                detail.setCartonNum(IntegerConstant.MERGE);
                detail.setCartonNumStr(null);
            }
            Double grossWeight = detail.getGrossWeight();
            if (grossWeight != null) {
                detail.setGrossWeightStr(grossWeight.toString());
            } else {
                detail.setGrossWeight(DoubleConstant.MERGE);
                detail.setGrossWeightStr(null);
            }
            Double netWeight = detail.getNetWeight();
            if (netWeight != null) {
                detail.setNetWeightStr(netWeight.toString());
            } else {
                detail.setNetWeight(DoubleConstant.MERGE);
                detail.setNetWeightStr(null);
            }
            Double totalPrice = detail.getTotalPrice();
            if (totalPrice != null) {
                detail.setTotalPriceStr(totalPrice.toString());
            } else {
                detail.setTotalPriceStr(null);
            }
            Double unitPrice = detail.getUnitPrice();
            if (unitPrice != null) {
                detail.setUnitPriceStr(unitPrice.toString());
            } else {
                detail.setUnitPriceStr(null);
            }
            detail.setDetno(detno);
            ++detno;
            detail.setCommissionSheet(sheet);
        }
        HashSet<CommissionSheetDetail> set = new HashSet<>();
        set.addAll(sheetDetails1);
        sheet.setCommissionSheetDetail(set);
        return ResultMap.success(null);
    }

    /**
     * 用户上传委托报关单的信息
     *
     * @param workbook
     * @return
     */
    @Override
    public ResultMap upload(Workbook workbook, MultipartFile contact, MultipartFile bill, MultipartFile packagelist) {
        Sheet sheet = workbook.getSheetAt(0);
        Boolean sheetPatternRight = validateSheetPattern(sheet);
        if (!sheetPatternRight) {
            return new ResultMap(CodeType.FAILURE, "上传的委托单格式不正确");
        }
        CommissionSheet commissionSheet = new CommissionSheet();
        // 获取主表
        ResultMap mainSheetInfo = getMainSheetInfo(commissionSheet, sheet);
        if (mainSheetInfo.getCode() != CodeType.OK.code()) {
            return mainSheetInfo;
        }
        // 获取明细表
        getDetailSheetInfos(commissionSheet, sheet);

        //统计数据
        statisticalCommissionSheetData(commissionSheet);
        // 繁体转简体
        convertToSimplify(commissionSheet);
        //验证数据
        validateSheetDetailsInfo(commissionSheet);
        if (contact !=  null) {
            String contactUrl = fileService.save(contact);
            commissionSheet.setContactUrl(contactUrl);
        }
        if (bill !=  null) {
            String billUrl = fileService.save(bill);
            commissionSheet.setBillUrl(billUrl);
        }
        if (packagelist !=  null) {
            String packagelistUrl = fileService.save(packagelist);
            commissionSheet.setPackagelistUrl(packagelistUrl);
        }
        CommissionSheet commissionSheet1 = commissionSheetDao.save(commissionSheet);
        if (commissionSheet1.getStatus().intValue() == SheetStatus.INDATAVALIDATEPASS.getCode()) {
            return new ResultMap(CodeType.VALIDATE_FAILURE.code(), "信息验证不通过", commissionSheet1);
        } else {
            return new ResultMap(CodeType.OK.code(), "信息验证通过", commissionSheet1);
        }
    }

    /**
     * 验证委托单上传的格式是否正确
     *
     * @param sheet 表单信息
     * @return Boolean 如果正确 true、否则 false
     */
    public Boolean validateSheetPattern(Sheet sheet) {
        Row row = sheet.getRow(3);
        Cell cell = row.getCell(5);
        String nameSheet = StringUtils.cutOutBlank(getCellValue(cell, CellType.STRING));
        // 验证委托报关单是否在指定的位置
        if (!CommissionSheetConstant.COMMISSION_SHEET_NAME.equals(nameSheet)) {
            return Boolean.FALSE;
        }

        // 验证入仓号的信息
        Cell cell1 = row.getCell(11);
        String warehouseNu = StringUtils.cutOutBlank(getCellValue(cell1, CellType.STRING));
        if (!CommissionSheetConstant.WAREHOUSEINGNO.equals(warehouseNu)) {
            return Boolean.FALSE;
        }

        Row row1 = sheet.getRow(11);
        //深圳交货方式
        String SZDeliveryContact = StringUtils.cutOutBlank(getCellValue(row1.getCell(0), CellType.STRING));
        if (!CommissionSheetConstant.SZ_DELIVERY.equals(SZDeliveryContact)) {
            return Boolean.FALSE;
        }
        //香港交货方式
        String HKDeliveryContact = StringUtils.cutOutBlank(getCellValue(row1.getCell(7), CellType.STRING));
        if (!CommissionSheetConstant.HK_DELIVERY.equals(HKDeliveryContact)) {
            return Boolean.FALSE;
        }
        Row row2 = sheet.getRow(12);
        //收货人
        String consignee = StringUtils.cutOutBlank(String.valueOf(getCellValue(row2.getCell(0), CellType.STRING)));
        if (!CommissionSheetConstant.CONSIGNEE.equals(consignee)) {
            return Boolean.FALSE;
        }
        // 货仓联系人
        String cargoPerson = StringUtils.cutOutBlank(getCellValue(row2.getCell(7), CellType.STRING));
        if (!CommissionSheetConstant.CARGO_PERSON.equals(cargoPerson)) {
            return Boolean.FALSE;
        }

        Row row3 = sheet.getRow(13);
        //联系方式
        String contactInformation1 = StringUtils.cutOutBlank(getCellValue(row3.getCell(0), CellType.STRING));
        if (!CommissionSheetConstant.CONTACT_INFORMATION.equals(contactInformation1)) {
            return Boolean.FALSE;
        }
        //联系方式
        String contactInformation2 = StringUtils.cutOutBlank(getCellValue(row3.getCell(7), CellType.STRING));
        if (!CommissionSheetConstant.CONTACT_INFORMATION.equals(contactInformation2)) {
            return Boolean.FALSE;
        }

        // 交货地址
        Row row4 = sheet.getRow(14);
        String deliveryAddress = StringUtils.cutOutBlank(getCellValue(row4.getCell(0), CellType.STRING));
        if (!CommissionSheetConstant.DELIVERY_ADDRESS.equals(deliveryAddress)) {
            return Boolean.FALSE;
        }
        // 香港仓库
        String hkCargo = StringUtils.cutOutBlank(getCellValue(row4.getCell(7), CellType.STRING));
        if (!CommissionSheetConstant.HK_CARGO.equals(hkCargo)) {
            return Boolean.FALSE;
        }

        Row row5 = sheet.getRow(15);
        Boolean correct = null;
        for (int i = 0; i < 13; i++) {
            Object obj = getCellValue(row5.getCell(i), CellType.STRING);
            String name = StringUtils.cutOutBlank(String.valueOf(obj));
            switch (i) {
                // 序号
                case 0:
                    correct = CommissionSheetConstant.DETNO.equals(name) ? Boolean.TRUE : Boolean.FALSE;
                    break;
                // 商品名称
                case 1:
                    correct = CommissionSheetConstant.CATALOGUE.equals(name) ? Boolean.TRUE : Boolean.FALSE;
                    break;
                // 规格型号
                case 2:
                    correct = CommissionSheetConstant.SPECIFICATION_TYPE.equals(name) ? Boolean.TRUE : Boolean.FALSE;
                    break;
                // 数量pcs
                case 3:
                    correct = CommissionSheetConstant.NUMBER.equals(name) ? Boolean.TRUE : Boolean.FALSE;
                    break;
                // 箱数
                case 4:
                    correct = CommissionSheetConstant.BOXES.equals(name) ? Boolean.TRUE : Boolean.FALSE;
                    break;
                // 净重(kg)
                case 5:
                    correct = CommissionSheetConstant.NET_WEIGHT.equals(name) ? Boolean.TRUE : Boolean.FALSE;
                    break;
                // 毛重（kg）
                case 6:
                    correct = CommissionSheetConstant.GROSS_WEIGHT.equals(name) ? Boolean.TRUE : Boolean.FALSE;
                    break;
                // 币种
                case 7:
                    correct = CommissionSheetConstant.CURRENCY.equals(name)? Boolean.TRUE : Boolean.FALSE;
                    break;
                // 单价
                case 8:
                    correct = CommissionSheetConstant.UNITPRICE.equals(name) ? Boolean.TRUE : Boolean.FALSE;
                    break;
                // 总价
                case 9:
                    correct = CommissionSheetConstant.TOTAL_PRICE.equals(name) ? Boolean.TRUE : Boolean.FALSE;
                    break;
                // 品牌
                case 10:
                    correct = CommissionSheetConstant.BRAND.equals(name) ? Boolean.TRUE : Boolean.FALSE;
                    break;
                // 产地
                case 11:
                    correct = CommissionSheetConstant.ORIGIN_PLACE.equals(name) ? Boolean.TRUE : Boolean.FALSE;
                    break;
                // 批号
                case 12:
                    correct = CommissionSheetConstant.BATCH.equals(name) ? Boolean.TRUE : Boolean.FALSE;
                    break;
                // 备注
                case 13:
                    correct = CommissionSheetConstant.REMARK.equals(name) ? Boolean.TRUE : Boolean.FALSE;
                    break;
                default:
                    correct = Boolean.TRUE;
            }
            if (!correct) {
                return Boolean.FALSE;
            }
        }
        return Boolean.TRUE;
    }




    /**
     * 从委托单中获取主表的信息
     *
     * @param commissionSheet 表单的信息
     * @param sheet 主表信息
     */
    public ResultMap getMainSheetInfo(CommissionSheet commissionSheet, Sheet sheet) {
        if (sheet == null || commissionSheet == null) {
            return new ResultMap(CodeType.FAILURE, "传入信息为空");
        } else {
            Row row3 = sheet.getRow(4);
            Cell cell3 = row3.getCell(11);
            String wareHouseStr = StringUtils.cutOutBlank(String.valueOf(getCellValue(cell3, CellType.STRING)));
            if (StringUtils.isEmpty(wareHouseStr)){
                return new ResultMap(CodeType.FAILURE, "委托单(入仓号)不能为空");
            }
            commissionSheet.setWarehousingNo(wareHouseStr);

            UserAccount userAccount = SSO.get();
            commissionSheet.setCommissionCompany(userAccount.getSpaceName());
            commissionSheet.setCommissionCompanyEnuu(Long.valueOf(userAccount.getSpaceUU()));
            // 设置委托方的信息
            Row row2 = sheet.getRow(8);
            Cell cell2 = row2.getCell(2);
            String liablePersonStr = StringUtils.cutOutBlank(String.valueOf(getCellValue(cell2, CellType.STRING)));
            if (!StringUtils.isEmpty(liablePersonStr)) {
                commissionSheet.setCommissionPersonLiable(liablePersonStr);
            }

            Row row = sheet.getRow(9);
            Cell cplCell = row.getCell(2);
            String cplCellStr = StringUtils.cutOutBlank(String.valueOf(getCellValue(cplCell, CellType.STRING)));
            boolean matcheContain = Pattern.matches(RegexConstant.REGEX_MOBILE, cplCellStr);
            if (!StringUtils.isEmpty(cplCellStr) && matcheContain) {
                commissionSheet.setCommissionPersonLiableTel(cplCellStr);
//                UserView view = userInfoUtil.getUserInfo(cplCellStr);
//                if (view != null) {
//                    commissionSheet.setCommissionPersonLiable(view.getName());
//                    commissionSheet.setCommissionPersonLiableTel(view.getUid());
//                    commissionSheet.setCommissionPersonLiableUseruu(Long.valueOf(view.getDialectUID()));
//                }
            }
            if (StringUtils.isEmpty(commissionSheet.getCommissionPersonLiableTel())) {
                commissionSheet.setCommissionPersonLiable(userAccount.getVipName());
                commissionSheet.setCommissionPersonLiableTel(userAccount.getMobile());
                commissionSheet.setCommissionPersonLiableUseruu(userAccount.getUserUU());
            }

            //目前写死，只有晶陵一家
            List<Facilitator> all = facilitatorDao.findAll();
            if (CollectionUtils.isEmpty(all)) {
                return new ResultMap(CodeType.FAILURE, "还未设置服务商");
            } else {
                Facilitator facilitator = all.get(0);
                commissionSheet.setBaileeCompanyenuu(facilitator.getEnuu());
                commissionSheet.setBaileeCompanyName(facilitator.getCompanyName());
                System.out.println(facilitator.getCompanyName());
                System.out.println(commissionSheet.getBaileeCompanyName());
            }

            // 深圳交货方式
            Row row1 = sheet.getRow(11);
            Cell cell = row1.getCell(2);
            String deliveryType = StringUtils.cutOutBlank(String.valueOf(getCellValue(cell, CellType.STRING)));
            if (StringUtils.isEmpty(deliveryType)) {
                return new ResultMap(CodeType.FAILURE, "深圳交货方式不支持，请选（自提、委托送货、快递）");
            } else {
                List<DeliveryType> deliveryAndDescription = deliveryTypeDao.getDeliveryTypeByEnuuAndImportExportDeliveryAndDescription(commissionSheet.getBaileeCompanyenuu(), ImportExportDelivery.IMPORTDELIVERY, deliveryType);
                if (CollectionUtils.isEmpty(deliveryAndDescription)) {
                    return new ResultMap(CodeType.FAILURE, "深圳交货方式不支持，请选（自提、委托送货、快递）");
                } else {
                    DeliveryType type = deliveryAndDescription.get(0);
                    commissionSheet.setDeliveryType(type.getDescription());
                    if (type.getRequiredAddress()) {
                        ExpressAddress address = new ExpressAddress();
                        getShipAddress(sheet, address, 2);
                        Boolean isHolonomy = validAddress(address);
                        if (!isHolonomy) {
                            return new ResultMap(CodeType.FAILURE, "收货信息不完整（收货人、联系方式、交货地址）");
                        }
                        commissionSheet.setDeliveryContactInfo(FlexJsonUtils.toJson(address));
                    }
                }
            }

            //交货方式
            Cell cell1 = row1.getCell(9);
            String stockType = StringUtils.cutOutBlank(String.valueOf(getCellValue(cell1, CellType.STRING)));
            if (!StringUtils.isEmpty(deliveryType)) {
                List<DeliveryType> importExportDeliveries = deliveryTypeDao.getDeliveryTypeByEnuuAndImportExportDeliveryAndDescription(commissionSheet.getBaileeCompanyenuu(), ImportExportDelivery.IMPORTSTOCK, stockType);
                if (CollectionUtils.isEmpty(importExportDeliveries)) {
                    return new ResultMap(CodeType.FAILURE, "香港交货方式不正确（送至京电运通香港仓、京电运通代提货）");
                } else {
                    DeliveryType type = importExportDeliveries.get(0);
                    commissionSheet.setStockType(type.getDescription());
                    if (type.getRequiredAddress()) {
                        ExpressAddress address = new ExpressAddress();
                        getShipAddress(sheet, address, 9);
                        Boolean isHolonomy = validAddress(address);
                        if (!isHolonomy) {
                            return new ResultMap(CodeType.FAILURE, "收货信息不完整（收货人、联系方式、交货地址）");
                        }
                        commissionSheet.setStockContactInfo(FlexJsonUtils.toJson(address));
                    }
                }
            } else {
                return new ResultMap(CodeType.FAILURE, "香港交货方式不正确（送至京电运通香港仓、京电运通代提货）");
            }


            String orderId = OrderNumberUtil.getOrderId();
            commissionSheet.setCsid(orderId);

            commissionSheet.setApplyUseruu(Long.valueOf(userAccount.getUserUU()));
            commissionSheet.setApplyTime(new Date());
            commissionSheet.setApplyName(userAccount.getVipName());
        }
        return ResultMap.success(null);
    }


    /**
     * 获取收货地址信息
     *
     * @param sheet 表单信息
     * @param address 地址信息
     */
    public void getShipAddress(Sheet sheet, ExpressAddress address, int column) {
        if (sheet == null) {
            return ;
        }

        if (address == null) {
            address = new ExpressAddress();
        }
        Row row1 = sheet.getRow(12);
        Cell personNameCell = row1.getCell(column);
        String shipName = StringUtils.cutOutBlank(String.valueOf(getCellValue(personNameCell, CellType.STRING)));
        address.setName(shipName);

        //联系方式
        Row row2 = sheet.getRow(13);
        Cell telephoneCell = row2.getCell(column);
        String telephone = StringUtils.cutOutBlank(String.valueOf(getCellValue(telephoneCell, CellType.STRING)));
        address.setTelephone(telephone);

        Row row3 = sheet.getRow(14);
        Cell addressCell = row3.getCell(column);
        String addr = StringUtils.cutOutBlank(String.valueOf(getCellValue(addressCell, CellType.STRING)));
        address.setDetailAddress(addr);
        return ;
    }

    /**
     * 验证地址信息
     *
     * @param address 地址信息
     * @return true  地址信息是否完整， false  地址信息不完整
     */
    public Boolean validAddress(ExpressAddress address) {
        if (address == null) {
            return Boolean.FALSE;
        }
        if (StringUtils.isEmpty(address.getName())) {
            return Boolean.FALSE;
        }
        if (StringUtils.isEmpty(address.getTelephone())) {
            return Boolean.FALSE;
        }
        if (StringUtils.isEmpty(address.getDetailAddress())) {
            return Boolean.FALSE;
        }
        return Boolean.TRUE;
    }

    /**
     * 获取商品清单信息
     *
     * @param commissionSheet 委托单信息
     * @param sheet 表单信息
     */
    public void getDetailSheetInfos(CommissionSheet commissionSheet, Sheet sheet) {
        Set<CommissionSheetDetail> set = new HashSet<>();
        int i = 16;
        int j = 1;
        Row row = sheet.getRow(i);
        Cell cell = row.getCell(0);
        String cellValue = StringUtils.cutOutBlank(String.valueOf(getCellValue(cell, CellType.STRING)));
        CommissionSheetDetail detail = null;
        while (!CommissionSheetConstant.ENDLINE.equals(cellValue)) {
            detail = getDetailSheetInfoByRow(row, j, sheet);
            i++;
            j++;
            row = sheet.getRow(i);
            cell = row.getCell(0);
            cellValue = StringUtils.cutOutBlank(String.valueOf(getCellValue(cell, CellType.STRING)));
            if (detail == null) {
                continue;
            }
            detail.setCommissionSheet(commissionSheet);
            set.add(detail);
        }
        commissionSheet.setCommissionSheetDetail(set);
    }

    /**
     * 获取一行的商品信息
     *
     * @param row 一行数据
     * @param rowNum 当前的行数
     * @return detail的信息
     */
    public CommissionSheetDetail getDetailSheetInfoByRow(Row row, int rowNum, Sheet sheet) {
        if (row  == null) {
            return null;
        }
        int num1 = row.getRowNum();
        CommissionSheetDetail detail = new CommissionSheetDetail();
        detail.setDetno(rowNum);
        // 商品名称
        Cell cell = row.getCell(1);
        String commodityName = formatcmpName(String.valueOf(getCellValue(cell, CellType.STRING)));
        if (StringUtils.isEmpty(commodityName)) {
            return null;
        } else {
            detail.setCommodityName(commodityName);
        }

        // 规格型号
        Cell cell1 = row.getCell(2);
        String cmpCode = formatcmpName(String.valueOf(getCellValue(cell1, CellType.STRING)));
        if (StringUtils.isEmpty(cmpCode)) {
            return null;
        } else {
            detail.setCmpCode(cmpCode);
        }

        //数量
        Cell cell2 = row.getCell(3);
        String amountStr = StringUtils.cutOutBlank(String.valueOf(getCellValue(cell2, CellType.STRING)));
        detail.setAmountStr(amountStr);
        if (IntegerUtil.isInteger(amountStr)) {
            Long amout = Long.valueOf(amountStr);
            detail.setAmount(amout);
        }

        // 箱数
        Boolean isMerge = false;
        Cell cell3 = row.getCell(4);
        String cartonNumStr = StringUtils.cutOutBlank(String.valueOf(getCellValue(cell3, CellType.STRING)));
        detail.setCartonNumStr(cartonNumStr);
        if (IntegerUtil.isInteger(cartonNumStr)) {
            Integer carton = Integer.valueOf(cartonNumStr);
            detail.setCartonNum(carton);
        } else {
            isMerge = SheetXlsxUtil.isMergedRegion(sheet, num1, 4);
            if (isMerge) {
                detail.setCartonNum(IntegerConstant.MERGE);
            }
        }

        //净重
        Cell cell4 = row.getCell(5);
        String netWeightStr = StringUtils.cutOutBlank(String.valueOf(getCellValue(cell4, CellType.STRING)));
        detail.setNetWeightStr(netWeightStr);
        if (DoubleUtil.isNumber(netWeightStr)) {
            Double netWeight = Double.valueOf(netWeightStr);
            detail.setNetWeight(netWeight);
        } else {
            isMerge = SheetXlsxUtil.isMergedRegion(sheet, num1, 5);
            if (isMerge) {
                detail.setNetWeight(DoubleConstant.MERGE);
            }
        }

        //毛重
        Cell cell5 = row.getCell(6);
        String grossWeightStr = StringUtils.cutOutBlank(String.valueOf(getCellValue(cell5, CellType.STRING)));
        detail.setGrossWeightStr(grossWeightStr);
        if (DoubleUtil.isNumber(grossWeightStr)) {
            Double grossWeight = Double.valueOf(grossWeightStr);
            detail.setGrossWeight(grossWeight);
        } else {
            isMerge = SheetXlsxUtil.isMergedRegion(sheet, num1, 6);
            if (isMerge) {
                detail.setGrossWeight(DoubleConstant.MERGE);
            }
        }

        // 币别
        Cell cell6 = row.getCell(7);
        String currencyStr = StringUtils.cutOutBlank(String.valueOf(getCellValue(cell6, CellType.STRING)));
        detail.setCurrency(currencyStr);

        Cell cell7 = row.getCell(8);
        String unitPriceStr = StringUtils.cutOutBlank(String.valueOf(getCellValue(cell7, CellType.STRING)));
        detail.setUnitPriceStr(unitPriceStr);
        if (DoubleUtil.isNumber(unitPriceStr)) {
            Double unitPrice = Double.valueOf(unitPriceStr);
            detail.setUnitPrice(unitPrice);
        }

        // 总价信息
        Cell cell8 = row.getCell(9);
        String totalPriceStr = StringUtils.cutOutBlank(String.valueOf(getCellValue(cell8, CellType.STRING)));
        detail.setTotalPriceStr(totalPriceStr);
        if (DoubleUtil.isNumber(unitPriceStr)) {
            Double totalPrice = Double.valueOf(totalPriceStr);
            detail.setTotalPrice(totalPrice);
        }

        // 品牌信息
        Cell cell9 = row.getCell(10);
        String brandStr = formatcmpName(String.valueOf(getCellValue(cell9, CellType.STRING)));
        detail.setBrand(brandStr);

        // 产地信息
        Cell cell10 = row.getCell(11);
        String producingAreaStr = formatcmpName(String.valueOf(getCellValue(cell10, CellType.STRING)));
        detail.setProducingArea(producingAreaStr);

        // 批号信息
        Cell cell11 = row.getCell(12);
        String bathNumStr = StringUtils.cutOutBlank(String.valueOf(getCellValue(cell11, CellType.STRING)));
        detail.setBatchNum(bathNumStr);


        // 备注信息
        Cell cell12 = row.getCell(13);
        String remarkStr = formatcmpName(String.valueOf(getCellValue(cell12, CellType.STRING)));
        detail.setRemark(remarkStr);
        return detail;
    }

    /**
     * 委托单转成简体
     *
     * @param sheet
     */
    public void convertToSimplify(CommissionSheet sheet) {
        ZHConverter converter = ZHConverter.getInstance(ZHConverter.SIMPLIFIED);

        String baileeCompanyNameSimplify = converter.convert(sheet.getBaileeCompanyName());
        sheet.setBaileeCompanyNameSimplify(baileeCompanyNameSimplify);

        String commissionCompanySimplify = converter.convert(sheet.getCommissionCompany());
        sheet.setCommissionCompanySimplify(commissionCompanySimplify);

        String commissionPersonLiableSimplify = converter.convert(sheet.getCommissionPersonLiable());
        sheet.setCommissionPersonLiableSimplify(commissionPersonLiableSimplify);

        String deliveryContactInfoSimplify = converter.convert(sheet.getDeliveryContactInfo());
        sheet.setDeliveryContactInfoSimplify(deliveryContactInfoSimplify);

        String stockContactInfoSimplify = converter.convert(sheet.getStockContactInfo());
        sheet.setStockContactInfoSimplify(stockContactInfoSimplify);

        Set<CommissionSheetDetail> detail = sheet.getCommissionSheetDetail();
        for (CommissionSheetDetail sheetDetail : detail) {
            String remark = sheetDetail.getRemark();
            String remarkSimplify = converter.convert(remark);
            sheetDetail.setRemarkSimplify(remarkSimplify);

            String commodityName = sheetDetail.getCommodityName();
            String commodityNameSimplify = converter.convert(commodityName);
            if (StringConstant.IC.equalsIgnoreCase(commodityNameSimplify)) {
                commodityNameSimplify = StringConstant.ICChineses;
            } else if (commodityNameSimplify.equals(StringConstant.JINGYUAN2)){
                commodityNameSimplify = StringConstant.JINGYUAN1;
            } else if (commodityNameSimplify.equals(StringConstant.LENS_ABBREVIATIONS) && StringConstant.COMPANYNAME.equals(sheet.getCommissionCompany())) {
                commodityNameSimplify = StringConstant.LENS;
            }
            sheetDetail.setCommodityNameSimplify(commodityNameSimplify);

            String producingArea = sheetDetail.getProducingArea();
            String producingAreaSimplify = converter.convert(producingArea);
            List<ProduceArea> produceAreaList = produceAreaDao.findByEnglishAndChinese(producingAreaSimplify);
            if (CollectionUtils.isEmpty(produceAreaList)) {
                sheetDetail.setProducingAreaError(Boolean.FALSE);
                sheetDetail.setProducingAreaErrorMessage(StringConstant.PRODUCINGAREAERRORMESSAGE);
            } else {
                producingAreaSimplify = produceAreaList.get(0).getProduceAreaChinese();
            }
            sheetDetail.setProducingAreaSimplify(producingAreaSimplify);
        }
        sheet.setCommissionSheetDetail(detail);
    }

    /**
     * 验证商品明细的信息
     * @param sheet
     */
    public void validateSheetDetailsInfo(CommissionSheet sheet) {
        Set<CommissionSheetDetail> sheetDetail = sheet.getCommissionSheetDetail();
        Boolean isPass = true;
        for (CommissionSheetDetail detail : sheetDetail) {
            Boolean validate = validateSheetDetailsInfo(detail);
            isPass = isPass && validate;
        }
        if (isPass) {
            sheet.setStatus(SheetStatus.TOBECUSTOMERSERVICEVALIDATE.getCode());
        } else {
            sheet.setStatus(SheetStatus.INDATAVALIDATEPASS.getCode());
        }
        return ;
    }


    /**
     * 验证 商品明细的数据 detail
     *
     * @param detail 返回TRUE  表示 验证通过  false  代表验证不通过
     */
    public Boolean validateSheetDetailsInfo(CommissionSheetDetail detail) {
        if (detail == null) {
            return Boolean.TRUE;
        } else {
            // 验证数量的错误的信息
            String amountStr = detail.getAmountStr();
            if (StringUtils.isEmpty(amountStr)) {
                detail.setAmountError(Boolean.TRUE);
                detail.setAmountErrorMessage(StringConstant.AMOUNTERRORMESSAGE);
            } else {
                boolean isLong = IntegerUtil.isInteger(amountStr);
                if (isLong) {
                    Long amount = Long.valueOf(amountStr);
                    if (amount.compareTo(LongConstant.ZERO) < 1) {
                        detail.setAmountError(Boolean.TRUE);
                        detail.setAmountErrorMessage(StringConstant.AMOUNTERRORMESSAGE);
                    } else {
                        detail.setAmountError(Boolean.FALSE);
                        detail.setAmountErrorMessage(null);
                    }
                } else {
                    detail.setAmountError(Boolean.TRUE);
                    detail.setAmountErrorMessage(StringConstant.AMOUNTERRORMESSAGE);
                }
            }

            //净重
            String netWeightStr = detail.getNetWeightStr();
            Double netWeight = detail.getNetWeight();
            Boolean isNetWeightMerge = false;
            if (StringUtils.isEmpty(netWeightStr)) {
                if (DoubleConstant.MERGE.equals(netWeight)) {
                    detail.setNetWeightError(Boolean.FALSE);
                    detail.setNetWeightErrorMessage(null);
                    isNetWeightMerge = true;
                }
            } else {
                if (netWeight != null) {
                    if (NumberUtil.compare(netWeight, DoubleConstant.ZERO) < 1) {
                        detail.setNetWeightError(Boolean.TRUE);
                        detail.setNetWeightErrorMessage(StringConstant.NETWEIGHTERRORMESSAGE);
                    } else {
                        detail.setNetWeightError(Boolean.FALSE);
                        detail.setNetWeightErrorMessage(null);
                    }
                } else {
                    detail.setNetWeightError(Boolean.TRUE);
                    detail.setNetWeightErrorMessage(StringConstant.NETWEIGHTERRORMESSAGE);
                }
            }

            //毛重
            String grossWeightStr = detail.getGrossWeightStr();
            Double grossWeight = detail.getGrossWeight();
            Boolean isGrossWeightMerge = false;
            if (StringUtils.isEmpty(grossWeightStr) || isNetWeightMerge) {
                if (DoubleConstant.MERGE.equals(grossWeight)) {
                    detail.setGrossWeightError(Boolean.FALSE);
                    detail.setGrossWeightErrorMessage(null);
                    isGrossWeightMerge = true;
                } else {
                    detail.setGrossWeightError(Boolean.TRUE);
                    detail.setGrossWeightErrorMessage(StringConstant.MERGEERRORMESSAGE);
                }
            } else {
                if (grossWeight != null) {
                    if (NumberUtil.compare(grossWeight, DoubleConstant.ZERO) < 1) {
                        detail.setGrossWeightError(Boolean.TRUE);
                        detail.setGrossWeightErrorMessage(StringConstant.NETWEIGHTERRORMESSAGE);
                    } else {
                        detail.setGrossWeightError(Boolean.FALSE);
                        detail.setGrossWeightErrorMessage(null);
                    }
                } else {
                    detail.setGrossWeightError(Boolean.TRUE);
                    detail.setGrossWeightErrorMessage(StringConstant.NETWEIGHTERRORMESSAGE);
                }
            }

            // 验证箱数信息
            String cartonNumStr = detail.getCartonNumStr();
            Integer cartonNum = detail.getCartonNum();
            //如果 cartonNumStr 为空 代表用户没有输入信息
            if (StringUtils.isEmpty(cartonNumStr) || isGrossWeightMerge || isNetWeightMerge) {
                if (cartonNum == IntegerConstant.MERGE) {
                    detail.setCartonNumError(Boolean.FALSE);
                    detail.setCartonNumErrorMessage(null);
                } else {
                    detail.setCartonNumError(Boolean.TRUE);
                    detail.setCartonNumErrorMessage(StringConstant.MERGEERRORMESSAGE);
                }
            } else {
                if (cartonNum != null) {
                    if (cartonNum.compareTo(IntegerConstant.ZERO) < 1) {
                        // 如果小于0，表示错误
                        detail.setCartonNumError(Boolean.TRUE);
                        detail.setCartonNumErrorMessage(StringConstant.CARTONERRORMESSAGE);
                    } else {
                        // 如果大于0 ，正确
                        detail.setCartonNumError(Boolean.FALSE);
                        detail.setCartonNumErrorMessage(null);
                    }
                } else {
                    detail.setCartonNumError(Boolean.TRUE);
                    detail.setCartonNumErrorMessage(StringConstant.CARTONERRORMESSAGE);
                }
            }

            //确定币种信息
            String currency = detail.getCurrency();
            if (StringUtils.isEmpty(currency)) {
                detail.setCurrencyError(Boolean.TRUE);
                detail.setCurrencyErrorMessage(StringConstant.CURRENCYERRORMESSAGE);
            } else {
                List<CurrencyList> listByName = currencyListDao.getCurrencyListByName(currency);
                if (CollectionUtils.isEmpty(listByName)) {
                    detail.setCurrencyError(Boolean.TRUE);
                    detail.setCurrencyErrorMessage(StringConstant.CURRENCYERRORMESSAGE);
                } else {
                    detail.setCurrencyError(Boolean.FALSE);
                    detail.setCurrencyErrorMessage(null);
                }
            }

            //确定单价的信息
            String unitPriceStr = detail.getUnitPriceStr();
            if (StringUtils.isEmpty(unitPriceStr)) {
                detail.setUnitPriceError(Boolean.TRUE);
                detail.setUnitPriceErrorMessage(StringConstant.UNITPRICEERRORMESSAGE);
            } else {
                boolean isNumber = DoubleUtil.isNumber(unitPriceStr);
                if (isNumber) {
                    Double unitPrice = Double.valueOf(unitPriceStr);
                    if (NumberUtil.compare(unitPrice, DoubleConstant.ZERO) < 1) {
                        detail.setUnitPriceError(Boolean.TRUE);
                        detail.setUnitPriceErrorMessage(StringConstant.UNITPRICEERRORMESSAGE);
                    } else {
                        detail.setUnitPriceError(Boolean.FALSE);
                        detail.setUnitPriceErrorMessage(null);
                    }
                } else {
                    detail.setUnitPriceError(Boolean.TRUE);
                    detail.setUnitPriceErrorMessage(StringConstant.UNITPRICEERRORMESSAGE);
                }
            }

            //确定总价的信息
            String totalPriceStr = detail.getTotalPriceStr();
            if (StringUtils.isEmpty(totalPriceStr)) {
                detail.setTotalPriceError(Boolean.TRUE);
                detail.setTotalPriceErrorMessage(StringConstant.TOTALRICEERRORMESSAGE);
            } else {
                boolean isNumber = DoubleUtil.isNumber(totalPriceStr);
                if (isNumber) {
                    Double totalPrice = Double.valueOf(totalPriceStr);
                    if (NumberUtil.compare(totalPrice, DoubleConstant.ZERO) < 1) {
                        detail.setTotalPriceError(Boolean.TRUE);
                        detail.setTotalPriceErrorMessage(StringConstant.UNITPRICEERRORMESSAGE);
                    } else {
                        if ((detail.getAmount() != null) && (detail.getUnitPrice() != null)) {
                            double price = NumberUtil.mul(Double.valueOf(detail.getAmount()), detail.getUnitPrice());
                            int result = NumberUtil.compare(price, detail.getTotalPrice());
                            if (result != 0) {
                                detail.setTotalPriceError(Boolean.TRUE);
                                detail.setTotalPriceErrorMessage(StringConstant.TOTALPRICEERROR);
                            } else {
                                detail.setTotalPriceError(Boolean.FALSE);
                                detail.setTotalPriceErrorMessage(null);
                            }
                        } else {
                            detail.setTotalPriceError(Boolean.FALSE);
                            detail.setTotalPriceErrorMessage(null);
                        }
                    }
                } else {
                    detail.setTotalPriceError(Boolean.TRUE);
                    detail.setTotalPriceErrorMessage(StringConstant.UNITPRICEERRORMESSAGE);
                }
            }

            String brand = detail.getBrand();
            if (StringUtils.isEmpty(brand)) {
                detail.setBrandError(Boolean.TRUE);
                detail.setBrandErrorMessage(StringConstant.BRANDERRORMESSAGE);
            } else {
                detail.setBrandError(Boolean.FALSE);
                detail.setBrandErrorMessage(null);
            }

            String producingArea = detail.getProducingArea();
            if (StringUtils.isEmpty(producingArea)) {
                detail.setProducingAreaError(Boolean.TRUE);
                detail.setProducingAreaErrorMessage(StringConstant.PRODUCEAREAERRORMESSAGE);
            } else {
                detail.setProducingAreaError(Boolean.FALSE);
                detail.setProducingAreaErrorMessage(null);
            }
            String commodityName = detail.getCommodityName();
            detail.setBatchNumError(Boolean.FALSE);
            detail.setBatchNumErrorMessage(null);
            if (StringConstant.JINGYUAN1.equals(commodityName) || StringConstant.ICChineses.equals(commodityName)) {
                String batchNum = detail.getBatchNum();
                if (StringUtils.isEmpty(batchNum)) {
                    detail.setBatchNumError(Boolean.TRUE);
                    detail.setBatchNumErrorMessage(StringConstant.BATCHERRORMESSAGE);
                }
            }
            if (detail.getAmountError() || detail.getBrandError() || detail.getCurrencyError() || detail.getBatchNumError() || detail.getCartonNumError() || detail.getGrossWeightError() || detail.getProducingAreaError() || detail.getNetWeightError() || detail.getTotalPriceError() || detail.getUnitPriceError()) {
                return Boolean.FALSE;
            } else {
                return Boolean.TRUE;
            }
        }
    }

    /**
     * 根据主键id CommissionSheet 信息
     *
     * @param id
     * @return CommissionSheet
     */
    @Override
    public ResultMap getCommissionSheetById(Long id) {
        if (id == null) {
            return new ResultMap(CodeType.DEFICIENCY_INFO, "信息丢失");
        } else {
            CommissionSheet commissionSheet = commissionSheetDao.findOne(id);
            return new ResultMap(CodeType.OK.code(), "成功", commissionSheet);
        }
    }

    /**
     * 添加新的商品明细
     *
     * @param id   需要添加的主键
     * @param list 新添加的商品明细
     * @return ResultMap
     */
    @Override
    public ResultMap addDetail(Long id, List<CommissionSheetDetail> list) {
        if (id == null) {
            return new ResultMap(CodeType.DEFICIENCY_INFO, "关键信息缺失");
        } else {
            CommissionSheet commissionSheet = commissionSheetDao.findOne(id);
            if (commissionSheet == null) {
                return new ResultMap(CodeType.DEFICIENCY_INFO, "找不到对应的委托单");
            } else {
                if (CollectionUtils.isEmpty(list)) {
                    return new ResultMap(CodeType.DEFICIENCY_INFO, "新增信息为空");
                } else {
                    HashSet<CommissionSheetDetail> details = new HashSet<>(list);
                    ResultMap resultMap = validateDetailSheetIsCompleteInfoAndLegalData(details, commissionSheet, commissionSheet.getCommissionSheetDetail().size() + 1);
                    if (resultMap.getCode() != CodeType.OK.code()) {
                        return resultMap;
                    }
                    Set<CommissionSheetDetail> sheetDetails = commissionSheet.getCommissionSheetDetail();
                    sheetDetails.addAll(details);
                    commissionSheet.setCommissionSheetDetail(sheetDetails);
                    // 繁体转简体
                    convertToSimplify(commissionSheet);
                    //验证数据
                    validateSheetDetailsInfo(commissionSheet);
                    CommissionSheet sheet = commissionSheetDao.save(commissionSheet);
                    if (sheet.getStatus().intValue() == SheetStatus.INDATAVALIDATEPASS.getCode()) {
                        return new ResultMap(CodeType.VALIDATE_FAILURE.code(), "信息验证不通过", sheet);
                    } else {
                        return new ResultMap(CodeType.OK.code(), "信息验证通过", sheet);
                    }
                }
            }
        }
    }


    /**
     * 获取客户的订单
     *
     * @param page 页信息
     * @param keyword 搜索关键字
     * @param start 开始时间
     * @param end 结束时间
     * @return
     */
    @Override
    public ResultMap getClientSheetByPage(PageParams page, String keyword, Date start, Date end) {
        final PageInfo info = new PageInfo(page);

        Long spaceUID = SSO.get().getSpaceUU();
        SimpleExpression simpleExpression = new SimpleExpression("commissionCompanyEnuu", spaceUID, CriterionExpression.Operator.EQ);
        info.expression(simpleExpression);
        return getPageCommissionSheet(keyword, start, end, info);
    }

    /**
     * 获取服务商的订单
     *
     * @param page
     * @param keyword
     * @return
     */
    @Override
    public ResultMap getFacilitatorSheetByPage(PageParams page, String keyword, Date start, Date end) {
        final PageInfo info = new PageInfo(page);
        Long spaceUID = SSO.get().getSpaceUU();
        SimpleExpression simpleExpression = new SimpleExpression("baileeCompanyenuu", spaceUID, CriterionExpression.Operator.EQ);
        info.expression(simpleExpression);
        return getPageCommissionSheet(keyword, start, end, info);
    }

    /***
     * 根据页面信息 分页获取委托报关单信息
     * @param keyword 搜索关键字
     * @param start 开始时间
     * @param end 结束时间
     * @param info 页面信息
     * @return  ResultMap
     */
    protected ResultMap getPageCommissionSheet(String keyword, Date start, Date end, final PageInfo info) {
        if (!StringUtils.isEmpty(keyword)) {
            info.filter("csid", keyword);
        }
        info.sorting("applyTime", Sort.Direction.DESC);
        // 设置下单时间区段
        SimpleExpression[] simpleExp = new SimpleExpression[2];
        if (start != null) {
            simpleExp[0] = new SimpleExpression("applyTime", start, CriterionExpression.Operator.GTE);
        }
        if (end != null) {
            simpleExp[1] = new SimpleExpression("applyTime", end, CriterionExpression.Operator.LT);
        }

        if (simpleExp[0] != null && simpleExp[1] != null) {
            LogicalExpression expression = new LogicalExpression(simpleExp, CriterionExpression.Operator.AND);
            info.expression(expression);
        } else if (simpleExp[0] != null && simpleExp[1] == null) {
            info.expression(simpleExp[0]);
        } else if (simpleExp[0] == null && simpleExp[1] != null) {
            info.expression(simpleExp[1]);
        }
        SimpleExpression simpleExpression1 = new SimpleExpression("status", SheetStatus.DELETE.getCode(), CriterionExpression.Operator.NE);
        info.expression(simpleExpression1);
        Page<CommissionSheet> sheets = commissionSheetDao.findAll(new Specification<CommissionSheet>() {
            @Override
            public Predicate toPredicate(Root<CommissionSheet> root, CriteriaQuery<?> query, CriteriaBuilder cb) {
                query.where(info.getPredicates(root, query, cb));
                return null;
            }
        }, info);
        return ResultMap.success(sheets);
    }


    /**
     * 更新委托单据的信息
     *
     * @param json
     * @return
     */
    @Override
    public ResultMap updateCommissionSheet(String json, MultipartFile addressFile, MultipartFile contact, MultipartFile bill, MultipartFile packagelist, Long id) {
        if (StringUtils.isEmpty(json)) {
            return new ResultMap(CodeType.FAILURE, "信息丢失");
        } else {
            CommissionSheet updateSheet = null;
            try {
                updateSheet = FlexJsonUtils.fromJson(json, CommissionSheet.class);
            } catch (Exception e) {
                e.printStackTrace();
                return new ResultMap(CodeType.FAILURE, "数据转委托报关单失败");
            }

            if (id == null) {
                return new ResultMap(CodeType.FAILURE, "委托单主键丢失");
            }
            CommissionSheet persistSheet = commissionSheetDao.findOne(id);
            if (persistSheet == null) {
                return new ResultMap(CodeType.FAILURE, "委托单主键不正确");
            }

            // 更新主表信息
            ResultMap resultMap = updateMainCommissionSheetInfo(updateSheet, persistSheet);
            if (resultMap.getCode() != CodeType.OK.code()) {
                return resultMap;
            }
            // 更新从表信息
            Set<CommissionSheetDetail> commissionSheetDetails = updateSheet.getCommissionSheetDetail();
            ResultMap detailMap = updateDetailCommissionSheetInfo(commissionSheetDetails, persistSheet);
            if (detailMap.getCode() != CodeType.OK.code()) {
                return detailMap;
            }
            // 繁体转简体
            convertToSimplify(persistSheet);
            //验证数据
            validateSheetDetailsInfo(persistSheet);
            if (addressFile != null) {
                String url = fileService.save(addressFile);
                persistSheet.setDeliveryFileUrl(url);
            }
            if (contact != null) {
                String url = fileService.save(addressFile);
                persistSheet.setContactUrl(url);
            }
            if (bill != null) {
                String url = fileService.save(bill);
                persistSheet.setBillUrl(url);
            }
            if (packagelist != null) {
                String url = fileService.save(bill);
                persistSheet.setPackagelistUrl(url);
            }
            // 统计数据
            statisticalCommissionSheetData(persistSheet);
            CommissionSheet commissionSheet1 = commissionSheetDao.save(persistSheet);
            if (commissionSheet1.getStatus().intValue() == SheetStatus.INDATAVALIDATEPASS.getCode()) {
                return new ResultMap(CodeType.VALIDATE_FAILURE.code(), "信息验证不通过", commissionSheet1);
            } else {
                return new ResultMap(CodeType.OK.code(), "信息验证通过", commissionSheet1);
            }
        }
    }




    /**
     * 更新用户的信息
     * @param updateSheet 需要更新的信息
     * @param persistSheet 数据库的信息
     */
    public ResultMap updateMainCommissionSheetInfo(CommissionSheet updateSheet, CommissionSheet persistSheet) {
        String deliveryType = updateSheet.getDeliveryType();
        Long baileeCompanyenuu = persistSheet.getBaileeCompanyenuu();
        if (StringUtils.isEmpty(deliveryType)) {
            return new ResultMap(CodeType.DEFICIENCY_INFO, "深圳交货方式为空");
        } else {
            List<DeliveryType> exportDeliveryAndDescription = deliveryTypeDao.getDeliveryTypeByEnuuAndImportExportDeliveryAndDescription(baileeCompanyenuu, ImportExportDelivery.IMPORTDELIVERY, deliveryType);
            if (StringUtils.isEmpty(exportDeliveryAndDescription)) {
                return new ResultMap(CodeType.DEFICIENCY_INFO, "深圳交货方式不正确");
            }
            DeliveryType type = exportDeliveryAndDescription.get(0);
            persistSheet.setDeliveryType(deliveryType);
            if (type.getRequiredAddress()) {
                ExpressAddress deliveryAddress = updateSheet.getDeliveryAddress();
                Boolean aBoolean = validAddress(deliveryAddress);
                if (!aBoolean) {
                    return new ResultMap(CodeType.DEFICIENCY_INFO, "深圳交货方式联系信息缺失");
                }
                persistSheet.setDeliveryContactInfo(FlexJsonUtils.toJson(deliveryAddress));
            }
        }

        String stockType = updateSheet.getStockType();
        if (StringUtils.isEmpty(stockType)) {
            return new ResultMap(CodeType.DEFICIENCY_INFO, "香港交货方式为空");
        } else {
            List<DeliveryType> exportDeliveryAndDescription = deliveryTypeDao.getDeliveryTypeByEnuuAndImportExportDeliveryAndDescription(baileeCompanyenuu, ImportExportDelivery.IMPORTSTOCK, stockType);
            if (StringUtils.isEmpty(exportDeliveryAndDescription)) {
                return new ResultMap(CodeType.DEFICIENCY_INFO, "香港交货方式不正确");
            }
            DeliveryType type = exportDeliveryAndDescription.get(0);
            persistSheet.setStockType(stockType);
            if (type.getRequiredAddress()) {
                ExpressAddress deliveryAddress = updateSheet.getStockAddress();
                Boolean aBoolean = validAddress(deliveryAddress);
                if (!aBoolean) {
                    return new ResultMap(CodeType.DEFICIENCY_INFO, "香港交货方式联系信息缺失");
                }
                persistSheet.setStockContactInfo(FlexJsonUtils.toJson(deliveryAddress));
            }
        }
        return ResultMap.success(null);
    }

    /**
     * 更新委托单明细
     *
     * @param updateDetail
     * @param persistSheet
     * @return
     */
    public ResultMap updateDetailCommissionSheetInfo(Set<CommissionSheetDetail> updateDetail, CommissionSheet persistSheet) {
        ResultMap resultMap = validateDetailSheetIsCompleteInfoAndLegalData(updateDetail, persistSheet, IntegerConstant.single);
        if (resultMap.getCode() != CodeType.OK.code()) {
            return resultMap;
        } else {
            persistSheet.setCommissionSheetDetail(updateDetail);
            return ResultMap.success(null);
        }
    }

    /**
     * 仓储部验证
     *
     * @param id 主键信息
     * @param json 传输的数据
     * @return ResultMap
     */
    @Override
    public ResultMap storageValid(Long id, String json, String status) {
        if (id == null || StringUtils.isEmpty(status) || (status.equals(ValidateStatus.FAILURE) && StringUtils.isEmpty(json))) {
            return new ResultMap(CodeType.FAILURE, "传入数据缺失");
        } else {
            CommissionSheet commissionSheet = commissionSheetDao.findOne(id);
            if (commissionSheet == null) {
                return new ResultMap(CodeType.FAILURE, "找不到对应的委托单");
            }
//            if (commissionSheet.getStatus().intValue() != SheetStatus.TOBECUSTOMHOUSEANDSTORAGEVALIDATE.getCode()) {
//                return new ResultMap(CodeType.FAILURE, "该委托单据不在仓储操作的状态");
//            }
            if (commissionSheet.getBaileeCompanyenuu().longValue() != Long.valueOf(SSO.get().getSpaceUU()).longValue()) {
                return new ResultMap(CodeType.FAILURE, "该委托单据不属于该供应商操作");
            }
            if (status.equals(ValidateStatus.FAILURE)) {
                Map<String, String> map = FlexJsonUtils.fromJson(json, HashMap.class);
                Set<Map.Entry<String, String>> entrySet = map.entrySet();
                Set<CommissionSheetDetail> commissionSheetDetail = commissionSheet.getCommissionSheetDetail();
                for (Map.Entry<String, String> stringEntry : entrySet) {
                    String stringEntryKey = stringEntry.getKey();
                    for (CommissionSheetDetail sheetDetail : commissionSheetDetail) {
                        if (sheetDetail.getId().longValue() == Long.valueOf(stringEntryKey).longValue()) {
                            sheetDetail.setStorageServiceOperator(stringEntry.getValue());
                        }
                    }
                }
            } else {
                if (status.equals(ValidateStatus.SUCCESS)) {
                    commissionSheet.setStorageValid(Boolean.TRUE);
                }
            }
            CommissionSheet commissionSheet1 = commissionSheetDao.save(commissionSheet);
            return ResultMap.success(commissionSheet1);
        }
    }

    /**
     * 更新委托单的产地信息
     *
     * @param id 委托单的主键
     * @return
     */
    @Override
    public ResultMap updateProducingArea(Long id) {
        if (id == null) {
            return new ResultMap(CodeType.FAILURE, "关键信息缺失");
        } else {
            CommissionSheet commissionSheet = commissionSheetDao.findOne(id);
            if (commissionSheet == null) {
                return new ResultMap(CodeType.FAILURE, "找不到对应的委托单");
            }
            Set<CommissionSheetDetail> sheetDetail = commissionSheet.getCommissionSheetDetail();
            for (CommissionSheetDetail commissionSheetDetail : sheetDetail) {
                List<ProduceArea> produceAreas = produceAreaDao.findByEnglishAndChinese(commissionSheetDetail.getProducingArea().toUpperCase());
                if (CollectionUtils.isNotEmpty(produceAreas)) {
                    ProduceArea produceArea = produceAreas.get(0);
                    commissionSheetDetail.setProducingAreaSimplify(produceArea.getProduceAreaChinese());
                }
            }
            CommissionSheet commissionSheet1 = commissionSheetDao.save(commissionSheet);
            return ResultMap.success(commissionSheet1);
        }
    }

    /**
     * 客服部验证通过
     *
     * @param id 传入的主键信息
     * @param json 需要修改的信息
     * @param status 是否正确
     * @param operatorMessage 操作的记录
     * @return ResultMap
     */
    @Override
    public ResultMap customServicePass(Long id, String json, String status, String operatorMessage) {
        if ((id == null) || (StringUtils.isEmpty(status)) || (status.equals(ValidateStatus.FAILURE) && StringUtils.isEmpty(json))) {
            return new ResultMap(CodeType.FAILURE, "关键信息缺失");
        } else {
            CommissionSheet commissionSheet = commissionSheetDao.findOne(id);
            if (commissionSheet == null) {
                return new ResultMap(CodeType.FAILURE, "找不到对应的委托单");
            }
            if (commissionSheet.getBaileeCompanyenuu().longValue() != Long.valueOf(SSO.get().getSpaceUU()).longValue()) {
                return new ResultMap(CodeType.FAILURE, "该委托单据不属于该供应商操作");
            }
            commissionSheet.setCustomServiceOperator(operatorMessage);
            if (status.equals(ValidateStatus.FAILURE)) {
                HashMap<String, String> hashMap = FlexJsonUtils.fromJson(json, HashMap.class);
                Set<Map.Entry<String, String>> entrySet = hashMap.entrySet();
                Set<CommissionSheetDetail> sheetDetail = commissionSheet.getCommissionSheetDetail();
                for (Map.Entry<String, String> stringEntry : entrySet) {
                    for (CommissionSheetDetail detail : sheetDetail) {
                        if (Long.valueOf(stringEntry.getKey()).longValue() == detail.getId().longValue()) {
                            detail.setCustomerServiceOperator(stringEntry.getValue());
                        }
                    }

                }
            } else {
                commissionSheet.addHistory(SheetStatus.TOBECUSTOMHOUSEANDSTORAGEVALIDATE, SSO.get().getUserUU());
            }
            CommissionSheet commissionSheet1 = commissionSheetDao.save(commissionSheet);
            return ResultMap.success(commissionSheet1);
        }
    }


    /**
     * 统计委托单据的信息
     *
     * @param sheet
     */
    @Override
    public void statisticalCommissionSheetData(CommissionSheet sheet) {
        if (sheet == null) {
            return ;
        } else {
            Set<CommissionSheetDetail> commissionSheetDetails = sheet.getCommissionSheetDetail();
            String currency = "";
            Long totalAmount = 0l;
            Integer totalCartonNum = 0;
            Double totalNetWeight = 0.0d;
            Double totalGrossWeight = 0.0d;
            Double totalPrice = 0.0d;
            for (CommissionSheetDetail sheetDetail : commissionSheetDetails) {
                totalAmount += sheetDetail.getAmount();
                totalCartonNum += (sheetDetail.getCartonNum() == -1 ? 0 : sheetDetail.getCartonNum()) ;
                totalNetWeight = NumberUtil.add(totalNetWeight, (sheetDetail.getNetWeight() == -1 ? 0 : sheetDetail.getNetWeight()));
                totalGrossWeight = NumberUtil.add(totalGrossWeight, (sheetDetail.getGrossWeight() == -1 ? 0 : sheetDetail.getGrossWeight()));
                totalPrice = NumberUtil.add(totalPrice, sheetDetail.getTotalPrice());
                if (!currency.contains(sheetDetail.getCurrency())) {
                    currency +=  sheetDetail.getCurrency();
                }
            }
            sheet.setCurrency(currency);
            sheet.setTotalAmount(totalAmount);
            sheet.setTotalCartonNum(totalCartonNum);
            sheet.setTotalNetWeight(totalNetWeight);
            sheet.setTotalGrossWeight(totalGrossWeight);
            sheet.setTotalPrice(totalPrice);
        }

    }


    /**
     * 关务部验证id
     *
     * @param id
     * @return
     */
    @Transactional
    @Override
    public ResultMap customerHouseValid(Long id) {
        if (id == null) {
            return new ResultMap(CodeType.FAILURE, "传入的数据为空");
        } else {
            CommissionSheet commissionSheet = commissionSheetDao.findOne(id);
            if (commissionSheet == null) {
                return new ResultMap(CodeType.FAILURE, "找不到对应的信息");
            }
            CustomerHouseServiceSheet sheet = new CustomerHouseServiceSheet();
            //生成关务验证单据
            CommissionSheetConvertToCustomerHouseServiceSheetUtil.commissionSheetConvertToCustomerHouseServiceSheet(commissionSheet, sheet);
            CustomerHouseServiceSheet houseServiceSheet = customerHouseServiceSheetDao.save(sheet);
            Long aLong = houseServiceSheet.getId();
            //更新对应的信息
            String sql = "update cd$customerhouseservicesheetdetail d join (select de.de_customer_house_code,de.de_description,de.de_commodityname, de.de_brand, de.de_cmpcode from cd$declarationelements de) r on upper(r.de_commodityname) = upper(d.chssd_commodity_name) and upper(r.de_brand) = upper(d.chssd_brand) and upper(r.de_cmpcode)=upper(d.chssd_cmp_code) set d.chssd_declare_element = r.de_description, d.chssd_customer_house_code = r.de_customer_house_code where d.sheet_id = " + aLong;
            jdbcTemplate.execute(sql);
            entityManager.refresh(houseServiceSheet);
            //CustomerHouseServiceSheet serviceSheet = customerHouseServiceSheetDao.findOne(aLong);
            Set<CustomerHouseServiceSheetDetail> sheetDetail = houseServiceSheet.getCustomerHouseServiceSheetDetail();
            List<String> codes = new ArrayList<>();
            for (CustomerHouseServiceSheetDetail serviceSheetDetail : sheetDetail) {
                if (!StringUtils.isEmpty(serviceSheetDetail.getCustomerHouseCode())) {
                    codes.add(serviceSheetDetail.getCustomerHouseCode());
                }
            }

            if (CollectionUtils.isNotEmpty(codes)) {
                List<CustomerCodeInfo> customerCodeInfos = customerCodeInfoDao.findCustomerCodeInfoInCodes(codes);
                for (CustomerHouseServiceSheetDetail houseServiceSheetDetail : sheetDetail) {
                    houseServiceSheetDetail.setTransactionUnit(StringConstant.TRANSACTIONUNIT);
                    houseServiceSheetDetail.setTransactionQuantity(String.valueOf(houseServiceSheetDetail.getAmount()));
                    houseServiceSheetDetail.setDestinationCountry(StringConstant.DESTINATIONCOUNTRY);
                    List<CurrencyList> listByName = currencyListDao.getCurrencyListByName(houseServiceSheetDetail.getCurrency());
                    if (CollectionUtils.isNotEmpty(listByName)) {
                        CurrencyList currencyList = listByName.get(0);
                        if (StringUtils.isEmpty(currencyList.getCode())) {
                            return new ResultMap(CodeType.FAILURE, houseServiceSheetDetail.getCurrency() + "对应的海关代码未维护");
                        } else {
                            houseServiceSheetDetail.setCurrency(currencyList.getCode() + "  " + currencyList.getCurChinese());
                        }
                    } else {
                        return new ResultMap(CodeType.FAILURE, "找不到对应的币别信息");
                    }

                    // 默认写一般征税;
                    houseServiceSheetDetail.setExemption("101 一般征税");
                    for (CustomerCodeInfo codeInfo : customerCodeInfos) {
                        if (codeInfo.getCustomerHouseCode().equals(houseServiceSheetDetail.getCustomerHouseCode())) {
                            //根据 第一单位 设置法定数量
                            if (StringConstant.KILOGRAM.equals(codeInfo.getFirstUnit())) {
                                houseServiceSheetDetail.setStatutoryQuantity(houseServiceSheetDetail.getNetWeight().toString());
                            } else if (codeInfo.getFirstUnit().contains(StringConstant.THOUSAND)) {
                                houseServiceSheetDetail.setStatutoryQuantity(String.valueOf(NumberUtil.div(Double.valueOf(houseServiceSheetDetail.getAmount()), Double.valueOf(1000))));
                            } else {
                                houseServiceSheetDetail.setStatutoryQuantity(String.valueOf(houseServiceSheetDetail.getAmount()));
                            }
                            if (!StringUtils.isEmpty(codeInfo.getSecondUnit())) {
                                houseServiceSheetDetail.setSecondUnit(codeInfo.getSecondUnit());
                                if (StringConstant.KILOGRAM.equals(codeInfo.getFirstUnit())) {
                                    houseServiceSheetDetail.setSecondQuantity(String.valueOf(houseServiceSheetDetail.getNetWeight()));
                                } else if (codeInfo.getSecondUnit().contains(StringConstant.THOUSAND)) {
                                    houseServiceSheetDetail.setSecondQuantity(String.valueOf(NumberUtil.div(Double.valueOf(houseServiceSheetDetail.getAmount()), Double.valueOf(1000))));
                                } else {
                                    houseServiceSheetDetail.setSecondQuantity(String.valueOf(houseServiceSheetDetail.getAmount()));
                                }
                            }
                            break;
                        }
                    }
                }
            }

            CustomerHouseServiceSheet serviceSheet = entityManager.merge(houseServiceSheet);
            return ResultMap.success(serviceSheet);
        }
    }

    /**
     * 成交方式
     *
     * @param id              主键id
     * @param transactionMode 成交方式
     * @return ResultMap
     */
    @Override
    public ResultMap updateCommissionSheetTransactionMode(Long id, String transactionMode) {
        if (id == null || StringUtils.isEmpty(transactionMode)) {
            return new ResultMap(CodeType.FAILURE, "信息丢失，请重新上传");
        } else {
            CommissionSheet commissionSheet = commissionSheetDao.findOne(id);
            List<TransactionMode> transactionModes = transactionModeDao.findTransactionModeByMode(transactionMode.toUpperCase());
            if (CollectionUtils.isNotEmpty(transactionModes)) {
                commissionSheet.setTransactionMode(transactionMode.toUpperCase());
            } else {
                return new ResultMap(CodeType.FAILURE, "选择的成交方式不存在");
            }
            CommissionSheet commissionSheet1 = commissionSheetDao.save(commissionSheet);
            return ResultMap.success(commissionSheet1);
        }
    }

    /**
     * 供应商资料导入
     *
     * @param contact     需要上传的文件信息
     * @param bill        发票信息
     * @param packagelist 供应商箱单
     * @param ids          调整的委托单信息
     * @return
     */
    @Override
    public ResultMap facilitatorInfoUpload(MultipartFile contact, MultipartFile bill, MultipartFile packagelist, String ids) {
        if (StringUtils.isEmpty(ids)) {
            return new ResultMap(CodeType.DEFICIENCY_INFO, "委托单信息为空");
        }
        if (contact == null && bill == null && packagelist == null) {
            return new ResultMap(CodeType.DEFICIENCY_INFO, "没有需要上传的信息");
        }
        List<Long> longList = LongArray.convertToLongArray(ids);
        String contactUrl = null, billUrl = null, packagelistUrl = null;
        if (contact != null) {
            contactUrl = fileService.save(contact);
        }
        if (bill != null) {
            billUrl = fileService.save(bill);
        }
        if (packagelist != null) {
            packagelistUrl = fileService.save(packagelist);
        }
        List<CommissionSheet> sheets = commissionSheetDao.findAll(longList);
        for (CommissionSheet commissionSheet : sheets) {
            if (commissionSheet != null) {
                if (!StringUtils.isEmpty(contactUrl)) {
                    commissionSheet.setContactUrl(contactUrl);
                }
                if (!StringUtils.isEmpty(billUrl)) {
                    commissionSheet.setBillUrl(billUrl);
                }
                if (!StringUtils.isEmpty(packagelistUrl)) {
                    commissionSheet.setPackagelistUrl(packagelistUrl);
                }
            }
        }
        List<CommissionSheet> sheetList = commissionSheetDao.save(sheets);
        return ResultMap.success(sheetList);
    }

    /**
     * 作废单据
     *
     * @param ids 主表信息
     */
    @Override
    public ResultMap abandonedSheet(String ids) {
        if (ids == null) {
            return new ResultMap(CodeType.FAILURE, "传入的信息为空");
        } else {
            List<Long> longList = LongArray.convertToLongArray(ids);
            int i = 0, j = 0;
            List<CommissionSheet> commissionSheets = commissionSheetDao.findAll(longList);
            for (CommissionSheet commissionSheet : commissionSheets) {
                if (commissionSheet.getStatus().intValue() == SheetStatus.MAKE_SHEET.getCode() ||
                        commissionSheet.getStatus().intValue() ==  SheetStatus.COMMIT.getCode() || commissionSheet.getStatus().intValue() ==  SheetStatus.INDATAVALIDATEPASS.getCode() || commissionSheet.getStatus().intValue() ==  SheetStatus.TOBECUSTOMERSERVICEVALIDATE.getCode() || commissionSheet.getStatus().intValue() ==  SheetStatus.TOBECUSTOMHOUSEANDSTORAGEVALIDATE.getCode()) {
                    commissionSheet.addHistory(SheetStatus.ABANDONED, SSO.get().getUserUU());
                    commissionSheetDao.save(commissionSheet);
                    i++;
                } else {
                    j++;
                }
            }
            int length = i + j;
            if (i == 0) {
                String str = "总计" + length + "条";
                if (j != 0) {
                    str = str + "，" + j + "条委托报关单状态不是制单或已提交状态，不能作废";
                }
                int i1 = length - j;
                if (i1 != 0) {
                    str = str + "， " + i1 + "数据有误，或者找不到委托报关单";
                }
                return new ResultMap(CodeType.FAILURE, str);
            } else {
                String str = "总计" + length + "条，" + i + "条作废";
                if (j != 0) {
                    str = str + "，" + j + "条委托报关单状态不是制单或已提交状态，不能作废";
                }
                int i1 = length - j - i;
                if (i1 != 0) {
                    str = str + "， " + i1 +"条数据有误，或者找不到委托报关单";
                }
                return ResultMap.success(null, str);
            }
        }
    }

    /**
     * 作废单据
     *
     * @param ids 主表信息
     * @return ResultMap 返回的单据
     */
    @Override
    public ResultMap deleteSheet(String ids) {
        if (ids == null) {
            return new ResultMap(CodeType.FAILURE, "传入的信息为空");
        } else {
            List<Long> longList = LongArray.convertToLongArray(ids);
            int i = 0, j = 0;
            List<CommissionSheet> commissionSheets = commissionSheetDao.findAll(longList);
            for (CommissionSheet commissionSheet : commissionSheets) {
                if (commissionSheet.getStatus().intValue() == SheetStatus.MAKE_SHEET.getCode() ||
                        commissionSheet.getStatus().intValue() ==  SheetStatus.COMMIT.getCode() || commissionSheet.getStatus().intValue() ==  SheetStatus.INDATAVALIDATEPASS.getCode() || commissionSheet.getStatus().intValue() ==  SheetStatus.TOBECUSTOMERSERVICEVALIDATE.getCode() || commissionSheet.getStatus().intValue() ==  SheetStatus.TOBECUSTOMHOUSEANDSTORAGEVALIDATE.getCode()) {
                    commissionSheet.addHistory(SheetStatus.DELETE, SSO.get().getUserUU());
                    commissionSheetDao.save(commissionSheet);
                    i++;
                } else {
                    j++;
                }
            }
            int length = i + j;
            if (i == 0) {
                String str = "总计" + length + "条";
                if (j != 0) {
                    str = str + "，" + j + "条委托报关单状态不是制单或已提交状态，不能删除";
                }
                int i1 = length - j;
                if (i1 != 0) {
                    str = str + "， " + i1 + "条数据有误，或者找不到委托报关单";
                }
                return new ResultMap(CodeType.FAILURE, str);
            } else {
                String str = "总计" + length + "条，" + i + "条删除";
                if (j != 0) {
                    str = str + "，" + j + "条委托报关单状态不是制单或已提交状态，不能删除";
                }
                return ResultMap.success(null, str);
            }
        }
    }

    /**
     * 批量下载委托报关单信息
     *
     * @param ids
     */
    @Override
    public void batchDownCommissionSheet(String ids, HttpServletRequest request,
                                         HttpServletResponse response) {
        if (!StringUtils.isEmpty(ids)) {
            List<Long> longList = LongArray.convertToLongArray(ids);
            String fileName = null;
            ByteArrayOutputStream byteArrayOutputStream = null;
            if (longList.size() == 1) {
                Long id = longList.get(0);
                CommissionSheet commissionSheet = commissionSheetDao.findOne(id);

                HSSFWorkbook workbook = HSSFWorkbookUtil.createCommissionSheetTemplate();
                WorkBookFillDataUtil.fillCommissionSheetWorkBookData(workbook, commissionSheet);
                byteArrayOutputStream = new ByteArrayOutputStream();
                fileName = commissionSheet.getCsid() + ".xls";
                File file = null;
                try {
                    String dicPath = new File(".").getCanonicalPath();
                    String srcPath = dicPath + "\\down";
                    File newPath = new File(srcPath);
                    newPath.mkdirs();
                    file = new File(newPath + "\\"+ fileName);
                    FileOutputStream fos = new FileOutputStream(file);
                    workbook.write(fos);
                    FileInputStream fin = new FileInputStream(file);
                    int b;
                    while ((b = fin.read()) != -1) {
                        byteArrayOutputStream.write(b);
                    }
                    fin.close();
                } catch (IOException e) {
                    e.printStackTrace();
                }

                if (file.exists()) {
                    file.delete();
                }

            } else {
                List<CommissionSheet> commissionSheets = commissionSheetDao.findAll(longList);
                byteArrayOutputStream = ZipUtil.createZipStream(commissionSheets);
                fileName = "压缩.zip";
            }

            try {
                // 清空response
                response.reset();
                OutputStream outputStream = new BufferedOutputStream(response.getOutputStream());
                response.setContentType("application/octet-stream");
                response.setHeader("Content-Disposition", "attachment;filename=" + new String(fileName.getBytes("UTF-8"),"ISO-8859-1"));
                outputStream.write(byteArrayOutputStream.toByteArray());
                outputStream.flush();
                outputStream.close();
            } catch (IOException ex) {
                ex.printStackTrace();
            }
        }
    }

    /**
     * 复制多张委托报关单信息
     *
     * @param ids
     * @return 成功或失败
     */
    @Override
    public ResultMap copyCommissionSheet(String ids) {
        if (StringUtils.isEmpty(ids)) {
            return new ResultMap(CodeType.FAILURE, "没有需要复制的信息");
        } else {
            List<Long> longArray = LongArray.convertToLongArray(ids);
            List<CommissionSheet> commissionSheets = commissionSheetDao.findAll(longArray);
            List<CommissionSheet> sheets = new ArrayList<>();
            CommissionSheet sheet = null;
            for (CommissionSheet commissionSheet : commissionSheets) {
                sheet = new CommissionSheet();
                BeanUtils.copyProperties(commissionSheet, sheet, new String[]{"id"});

                sheet.setOperatorMessages(null);
                sheet.setCustomServiceOperator(null);
                sheet.setApplyTime(new Date());
                String orderId = OrderNumberUtil.getOrderId();
                sheet.setCsid(orderId);
                Set<CommissionSheetDetail> sheetDetails = sheet.getCommissionSheetDetail();
                HashSet<CommissionSheetDetail> set = new HashSet<>();
                CommissionSheetDetail  detail = null;
                for (CommissionSheetDetail sheetDetail : sheetDetails) {
                    detail = new CommissionSheetDetail();
                    BeanUtils.copyProperties(sheetDetail, detail, new String[]{"id"});
                    detail.setCommissionSheet(sheet);
                    set.add(detail);
                }
                sheet.setCommissionSheetDetail(set);
                sheets.add(sheet);
            }
            List<CommissionSheet> sheetList = commissionSheetDao.save(sheets);
            return ResultMap.success(sheetList);
        }
    }

    /**
     * 关务部验证id
     *
     * @param ids
     * @return
     */
    @Override
    public ResultMap customerHouseValid(String ids) {
        if (StringUtils.isEmpty(ids)) {
            return new ResultMap(CodeType.FAILURE, "传入的委托报关单信息为空");
        } else {
            List<Long> longList = LongArray.convertToLongArray(ids);
            List<CommissionSheet> commissionSheets = commissionSheetDao.findAll(longList);
            for (CommissionSheet commissionSheet : commissionSheets) {
                if (commissionSheet.getStatus().intValue() != SheetStatus.TOBECUSTOMHOUSEANDSTORAGEVALIDATE.getCode()) {
                    return new ResultMap(CodeType.FAILURE, "委托单状态不在待关务部验证的状态");
                }
            }
            List<BasicConfigure> configures = basicConfigureDao.findBasicConfigureByType(BasicConfigureType.MAX_COUNT.getType());
            if (CollectionUtils.isEmpty(configures)) {
                return new ResultMap(CodeType.FAILURE, "贵公司未配置报关商品上线条数");
            }
            Integer maxCount = null;
            try {
                maxCount = Integer.valueOf(configures.get(0).getDescription());
            } catch (Exception e) {
                return new ResultMap(CodeType.FAILURE, "报关商品上线条数信息不是数字");
            }

            if (maxCount == null) {
                return new ResultMap(CodeType.FAILURE, "报关商品上线条数为空");
            }
            for (CommissionSheet commissionSheet : commissionSheets) {
                // TODO 状态是否正确
            }
            int totalCount = 0;
            String currency = commissionSheets.get(0).getCurrency();
            Boolean isSameCurrency = Boolean.TRUE;
            for (CommissionSheet commissionSheet : commissionSheets) {
                totalCount += commissionSheet.getCommissionSheetDetail().size();
                if (!StringUtils.compare(currency, commissionSheet.getCurrency())) {
                    isSameCurrency = Boolean.FALSE;
                }
            }
            if (totalCount > maxCount) {
                return new ResultMap(CodeType.FAILURE, commissionSheets.size() + "张委托报关单的商品明细总数:"+totalCount+",超过报关商品上线条数" + maxCount);
            }

            if (!isSameCurrency) {
                return  new ResultMap(CodeType.FAILURE, "存在单据币别不一致的情况，不能合并验证");
            }

            CommissionSheetDetail[] arraies = new CommissionSheetDetail[totalCount];
            int i = 0;
            for (CommissionSheet commissionSheet : commissionSheets) {
                Set<CommissionSheetDetail> commissionSheetDetails = commissionSheet.getCommissionSheetDetail();
                // 拆分净重和毛重的单元格
                Set<CommissionSheetDetail> sheetDetails = commissionSheetSplitCell(commissionSheetDetails);
                for (CommissionSheetDetail sheetDetail : sheetDetails) {
                    arraies[i++] = sheetDetail;
                }
            }
            return ResultMap.success(arraies);
        }
    }

    /**
     * 批量下载发票信息
     *
     * @param ids  委托单信息的id
     * @param request 请求
     * @param response 相应题
     */
    @Override
    public void batchDownInvoiceCommissionSheet(String ids, HttpServletRequest request, HttpServletResponse response) {
        if (!StringUtils.isEmpty(ids)) {
            List<Long> longs = LongArray.convertToLongArray(ids);
            try {
                ByteArrayOutputStream byteArrayOutputStream = new ByteArrayOutputStream();;
                List<CommissionSheet> commissionSheets = commissionSheetDao.findAll(longs);
                for (CommissionSheet commissionSheet : commissionSheets) {
                    if (!StringUtils.isEmpty(commissionSheet.getBillUrl())) {
                        File file = new File(commissionSheet.getBillUrl());
                        FileInputStream fin = new FileInputStream(file);
                        int b;
                        while ((b = fin.read()) != -1) {
                            byteArrayOutputStream.write(b);
                        }
                    }
                }

                try {
                    // 清空response
                    response.reset();
                    OutputStream outputStream = new BufferedOutputStream(response.getOutputStream());
                    response.setContentType("application/octet-stream");
                    response.setHeader("Content-Disposition", "attachment;filename=" + new String("发票信息".getBytes("UTF-8"),"ISO-8859-1"));
                    outputStream.write(byteArrayOutputStream.toByteArray());
                    outputStream.flush();
                    outputStream.close();
                } catch (IOException ex) {
                    ex.printStackTrace();
                }
            }catch (Exception e) {
                e.printStackTrace();
            }
        }
    }
}
