package com.uas.customsdeclaration.business.common.service.impl;

import com.uas.customsdeclaration.business.common.dao.CurrencyListDao;
import com.uas.customsdeclaration.business.common.model.CurrencyList;
import com.uas.customsdeclaration.business.common.service.CurrencyListService;
import com.uas.customsdeclaration.util.ResultMap;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * 币别信息的服务层
 *
 * @author yuj 2018-04-23 9:40
 */
@Service
public class CurrencyListServiceImpl implements CurrencyListService {

    private final CurrencyListDao currencyListDao;

    @Autowired
    public CurrencyListServiceImpl(CurrencyListDao currencyListDao) {
        this.currencyListDao = currencyListDao;
    }

    /**
     * 找出所有的币别信息
     *
     * @return ResultMap
     */
    @Override
    public ResultMap getAll() {
        List<CurrencyList> lists = currencyListDao.findAll();
        return ResultMap.success(lists);
    }
}
