package com.uas.customsdeclaration.business.common.service.impl;

import com.uas.customsdeclaration.business.common.dao.ExemptionNatureDao;
import com.uas.customsdeclaration.business.common.model.ExemptionNature;
import com.uas.customsdeclaration.business.common.service.ExemptionNatureService;
import com.uas.customsdeclaration.business.common.util.ExemptionNatureUtil;
import com.uas.customsdeclaration.util.CodeType;
import com.uas.customsdeclaration.util.ResultMap;
import com.uas.customsdeclaration.util.StringUtils;
import com.uas.platform.core.util.serializer.FlexJsonUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.Date;

/**
 * description
 *
 * @author yuj 2018-03-27 19:44
 */
@Service
public class ExemptionNatureServiceImpl implements ExemptionNatureService {

    private final ExemptionNatureDao exemptionNatureDao;

    @Autowired
    public ExemptionNatureServiceImpl(ExemptionNatureDao exemptionNatureDao) {
        this.exemptionNatureDao = exemptionNatureDao;
    }

    /**
     * 保存征免性质
     *
     * @param json
     * @return
     */
    @Override
    public ResultMap save(String json) {
        if (StringUtils.isEmpty(json)) {
            return new ResultMap(CodeType.FAILURE, "信息丢失，请重新保存");
        } else {
            ExemptionNature exemptionNature = FlexJsonUtils.fromJson(json, ExemptionNature.class);
            Boolean exemptionNature1 = ExemptionNatureUtil.validateExemptionNature(exemptionNature);
            if (!exemptionNature1) {
                return new ResultMap(CodeType.FAILURE, "请完善相关信息");
            }
            exemptionNature.setCreateTime(new Date());
            ExemptionNature nature = exemptionNatureDao.save(exemptionNature);
            return ResultMap.success(nature);
        }
    }


}
