package com.uas.customsdeclaration.business.common.status;

/**
 * 订单状态
 *
 * @author yuj 2018-03-12 14:56
 */
public enum SheetStatus {

    /**
     * 302 表单验证不通过
     */
    INDATAVALIDATEPASS(302, "验证不通过"),

    /**
     * 待客服部验证
     */
    TOBECUSTOMERSERVICEVALIDATE(303, "客服验证"),

    /**
     * 待关务和仓储验证
     */
    TOBECUSTOMHOUSEANDSTORAGEVALIDATE(304, "待关务和仓库验证"),


    /**
     * 制单
     */
    MAKE_SHEET(305, "制单"),

    /**
     * 已提交
     */
    COMMIT(306, "已提交"),

    /**
     * 已发送海关
     */
    ALREADY_SENT_CUSTOMS(307, "已发送海关"),
    /**
     * 已交税待放行
     */
    PAIED_TAXES(308, "已交税待放行"),

    /**
     * 单据已放行
     */
    CUSTOMS_RELEASED(309, "单据已放行"),

    /**
     * 正在通过香港关
     */
    PASSING_HK_CUSTOMS(310, "正在通过香港关"),

    /**
     * 正在查车
     */
    LOOKING_UP_CAR(311, "正在查车"),

    /**
     * 已过深圳湾关
     */
    SHENZHEN_BAY_PASS(312, "已过深圳湾关"),

    /**
     * 已入晶琳国内仓
     */
    JL_DOMESTIC_WAREHOUSE(313, "已入晶琳国内仓"),


    /**
     * 正在派送
     */
    BEING_SENT_OUT(314, "正在派送"),

    /**
     * 已完成
     */
    COMPLETE(315, "已完成"),

    /**
     * 已删除
     */
    DELETE(316, "已删除"),

    /**
     * 已作废
     */
    ABANDONED(317, "已作废");

    SheetStatus(int code, String phrase) {
        this.code = code;
        this.phrase = phrase;
    }

    private int code;

    private String phrase;

    public int getCode() {
        return code;
    }

    public SheetStatus setCode(int code) {
        this.code = code;
        return this;
    }

    public String getPhrase() {
        return phrase;
    }

    public SheetStatus setPhrase(String phrase) {
        this.phrase = phrase;
        return this;
    }
}
