package com.uas.customsdeclaration.business.common.type;

/**
 * 地址类型
 *
 * @author yuj 2018-04-19 15:29
 */
public enum AddressType {

    COMPANY_ADDRESS(100, "服务商公司地址"),

    PERSONAL_COMPANY_ADDRESS(101, "客户公司地址"),

    DELIVER_ADDRESS(102, "发票地址"),

    STORAGE_ADDRESS(103, "仓储地址"),

    DELIVERY_ADDRESS(104, "收货地址");

    private int type;

    private String phrase;

    AddressType(int type, String phrase) {
        this.type = type;
        this.phrase = phrase;
    }

    public int getType() {
        return type;
    }

    public AddressType setType(int type) {
        this.type = type;
        return this;
    }

    public String getPhrase() {
        return phrase;
    }

    public AddressType setPhrase(String phrase) {
        this.phrase = phrase;
        return this;
    }

    /**
     * 根据数据，找出对应的地址类型
     * @param type
     * @return
     */
    public static AddressType valueof(Integer type) {
        for (AddressType addressType : values()) {
            if (addressType.getType() == type) {
                return addressType;
            }
        }
        return null;
    }
}
