package com.uas.customsdeclaration.business.common.type;

/**
 * Created by yujia on 2018/4/16.
 */
public enum BasicConfigureType {

    /**
     * 汇率类型
     */
    EXCHANGE_RATE(300, "汇率"),

    CHARGE_METHOD(301, "计费方式"),

    TRANSATION_MODE(302, "成交方式"),

    INVOICE_MODE(303, "发票类型"),

    MAX_COUNT(304, "报关商品上线条数");

    private int type;

    private String phrase;

    public int getType() {
        return type;
    }

    public BasicConfigureType setType(int type) {
        this.type = type;
        return this;
    }

    public String getPhrase() {
        return phrase;
    }

    public BasicConfigureType setPhrase(String phrase) {
        this.phrase = phrase;
        return this;
    }

    BasicConfigureType(int type, String phrase) {
        this.type = type;
        this.phrase = phrase;
    }

    /**
     *  返回匹配的基础配置类型
     * @param type 传入的代码
     * @return
     */
    public static BasicConfigureType valueOf(Integer type) {
        for (BasicConfigureType status : values()) {
            if (status.type == type) {
                return status;
            }
        }
        return null;
    }
}
