package com.uas.customsdeclaration.business.common.util;

import com.uas.customsdeclaration.business.common.model.CommissionSheetDetail;
import com.uas.customsdeclaration.business.facilitator.model.CustomerHouseServiceSheet;
import com.uas.customsdeclaration.business.facilitator.model.CustomerHouseServiceSheetDetail;
import com.uas.customsdeclaration.util.NumberUtil;
import com.uas.customsdeclaration.util.StringUtils;
import org.springframework.util.CollectionUtils;

import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;
import java.util.HashSet;
import java.util.Set;

/**
 * 委托单明细表
 *
 * @author yuj 2018-03-20 20:56
 */
public class CommissionSheetDetailUtil {

    /**
     * 委托单明细表
     *
     * @param updateSheetDetail
     * @param sheetDetail
     * @return
     */
    public static String commissionSheetDetailModifyChange(CommissionSheetDetail updateSheetDetail, CommissionSheetDetail sheetDetail) {
        StringBuffer sb = new StringBuffer();
        String commodityNameSimplify = null,commodityNameSimplify1 = null,
                cmpCode = null,cmpCode1 = null,remarkSimplify = null,remarkSimplify1 = null,
                amount = null,amount1 = null,cartonNum = null,cartonNum1 = null,
                netWeight = null,netWeight1 = null,grossWeight = null,grossWeight1 = null,
                currency = null,currency1 = null,unitPrice = null,unitPrice1 = null,
                totalPrice = null,totalPrice1 = null,brand = null,brand1 = null,
                producingArea = null,producingArea1 = null,batchNum = null,batchNum1 = null;

        if (updateSheetDetail != null) {
            commodityNameSimplify = updateSheetDetail.getCommodityNameSimplify();
            cmpCode = updateSheetDetail.getCmpCode();
            amount = updateSheetDetail.getAmountStr();
            cartonNum = updateSheetDetail.getCartonNumStr();
            netWeight = updateSheetDetail.getNetWeightStr();
            grossWeight = updateSheetDetail.getGrossWeightStr();
            currency = updateSheetDetail.getCurrency();
            unitPrice = updateSheetDetail.getUnitPriceStr();
            totalPrice = updateSheetDetail.getTotalPriceStr();
            brand = updateSheetDetail.getBrand();
            producingArea = updateSheetDetail.getProducingArea();
            batchNum = updateSheetDetail.getBatchNum();
            remarkSimplify = updateSheetDetail.getRemarkSimplify();
        } else {
            commodityNameSimplify = "空";cmpCode = "空";
            amount = "空";cartonNum = "空";
            netWeight = "空";grossWeight = "空";
            currency = "空";unitPrice = "空";
            totalPrice = "空";brand = "空";
            producingArea = "空";batchNum = "空";
            remarkSimplify = "空";
        }
        if (sheetDetail != null) {
            commodityNameSimplify1 = sheetDetail.getCommodityNameSimplify();
            cmpCode1 = sheetDetail.getCmpCode();
            amount1 = sheetDetail.getAmountStr();
            cartonNum1 = sheetDetail.getCartonNumStr();
            netWeight1 = sheetDetail.getNetWeightStr();
            grossWeight1 = sheetDetail.getGrossWeightStr();
            currency1 = sheetDetail.getCurrency();
            unitPrice1 = sheetDetail.getUnitPriceStr();
            totalPrice1 = sheetDetail.getTotalPriceStr();
            brand1 = sheetDetail.getBrand();
            producingArea1 = sheetDetail.getProducingArea();
            batchNum1 = sheetDetail.getBatchNum();
            remarkSimplify1 = sheetDetail.getRemarkSimplify();
        } else {
            commodityNameSimplify1 = "空";cmpCode1 = "空";
            amount1 = "空";cartonNum1 = "空";
            netWeight1 = "空";grossWeight1 = "空";
            currency1 = "空";unitPrice1 = "空";
            totalPrice1 = "空";brand1 = "空";
            producingArea1 = "空";batchNum1 = "空";
            remarkSimplify1 = "空";
        }
        if (!StringUtils.compare(commodityNameSimplify, commodityNameSimplify1)) {
            sb.append("商品名称：" + commodityNameSimplify1 +"->" + commodityNameSimplify + "。");
        }
        if (!StringUtils.compare(cmpCode, cmpCode1)) {
            sb.append("规格型号：" + cmpCode1 +"->" + cmpCode + "。");
        }
        if (!StringUtils.compare(amount, amount1)) {
            sb.append("数量：" + amount1 +"->" + amount + "。");
        }
        if (!StringUtils.compare(cartonNum, cartonNum1)) {
            sb.append("箱数：" + cartonNum1 +"->" + cartonNum + "。");
        }
        if (!StringUtils.compare(netWeight, netWeight1)) {
            sb.append("净重：" + netWeight1 +"->" + netWeight + "。");
        }
        if (!StringUtils.compare(grossWeight, grossWeight1)) {
            sb.append("毛重：" + grossWeight1 +"->" + grossWeight + "。");
        }
        if (!StringUtils.compare(currency, currency1)) {
            sb.append("币别：" + currency1 +"->" + currency + "。");
        }
        if (!StringUtils.compare(unitPrice, unitPrice1)) {
            sb.append("单价：" + unitPrice1 +"->" + unitPrice + "。");
        }
        if (!StringUtils.compare(totalPrice, totalPrice1)) {
            sb.append("总价：" + totalPrice1 +"->" + totalPrice + "。");
        }
        if (!StringUtils.compare(brand, brand1)) {
            sb.append("品牌：" + brand1 +"->" + brand + "。");
        }
        if (!StringUtils.compare(producingArea, producingArea1)) {
            sb.append("产地：" + producingArea1 +"->" + producingArea + "。");
        }
        if (!StringUtils.compare(batchNum, batchNum1)) {
            sb.append("批号：" + batchNum1 +"->" + batchNum + "。");
        }
        if (!StringUtils.compare(remarkSimplify, remarkSimplify1)) {
            sb.append("备注：" + remarkSimplify1 +"->" + remarkSimplify + "。");
        }
        return sb.toString();
    }

    /**
     * 根据委托单明细生成 关务验证单明细
     *
     * @param set
     * @return
     */
    public static HashSet<CustomerHouseServiceSheetDetail> customerHouseServiceSheetDetailsValid(Set<CommissionSheetDetail> set, CustomerHouseServiceSheet sheet) {
        if (CollectionUtils.isEmpty(set)) {
            return null;
        } else {
            HashSet<CustomerHouseServiceSheetDetail> chssdSet = new HashSet<>();
            CustomerHouseServiceSheetDetail detail = null;
            CommissionSheetDetail[] array = null;
            Double unitPrice = 0.0d;
            Double totalPrice = 0.0d;
            Double netWeight = 0.0d;
            Double grossWeight = 0.0d;
            Long amount = 0l;
            StringBuilder sb = new StringBuilder();
            while (org.apache.commons.collections.CollectionUtils.isNotEmpty(set)) {
                detail = new CustomerHouseServiceSheetDetail();
                array = new CommissionSheetDetail[set.size()];
                set.toArray(array);
                CommissionSheetDetail sheetDetail = array[0];
                amount = sheetDetail.getAmount();
                totalPrice = sheetDetail.getTotalPrice();
                grossWeight = sheetDetail.getGrossWeight();
                netWeight = sheetDetail.getNetWeight();
                sb.append(sheetDetail.getDetno());
                for (int i = 1; i < array.length; i++) {
                    CommissionSheetDetail sheetDetail1 = array[i];
                    Boolean sameMateriel = isSameMateriel(sheetDetail, sheetDetail1);
                    if (sameMateriel) {
                        amount += sheetDetail1.getAmount();
                        totalPrice = NumberUtil.add(totalPrice, sheetDetail1.getTotalPrice());
                        grossWeight = NumberUtil.add(grossWeight, sheetDetail1.getGrossWeight());
                        netWeight = NumberUtil.add(netWeight, sheetDetail1.getNetWeight());
                        sb.append("," + sheetDetail1.getDetno());
                        set.remove(sheetDetail1);
                    }
                }
                unitPrice = NumberUtil.div(totalPrice, Double.valueOf(amount.toString()), 8);
                detail.setGrossWeight(grossWeight);
                detail.setNetWeight(netWeight);
                detail.setBrand(sheetDetail.getBrand());
                detail.setCommodityName(sheetDetail.getCommodityNameSimplify());
                detail.setCmpCode(sheetDetail.getCmpCode());
                detail.setProduceArea(sheetDetail.getProducingAreaSimplify());
                detail.setOriginCountry(sheetDetail.getProducingArea());
                detail.setUnitPrice(unitPrice);
                detail.setCurrency(sheetDetail.getCurrency());
                detail.setSourceid(sb.toString());
                detail.setAmount(amount);
                detail.setTotalPrice(totalPrice);
                chssdSet.add(detail);
                set.remove(sheetDetail);
                detail.setSheet(sheet);
            }
            return chssdSet;
        }

    }

    /**
     *
     * 商品名称、型号、产地、品牌完全相同则代表
     *
     * @param sheetDetail1
     * @param sheetDetail2
     * @return
     */
    public static Boolean isSameMateriel(CommissionSheetDetail sheetDetail1, CommissionSheetDetail sheetDetail2) {
        if (sheetDetail1 == null && sheetDetail2 == null) {
            return Boolean.TRUE;
        } else if (sheetDetail1 == null || sheetDetail2 == null) {
            return Boolean.FALSE;
        } else {
            Boolean commodityName = StringUtils.compare(sheetDetail1.getCommodityNameSimplify(), sheetDetail2.getCommodityNameSimplify());
            Boolean cmpCode = StringUtils.compare(sheetDetail1.getCmpCode(), sheetDetail2.getCmpCode());
            Boolean producingArea = StringUtils.compare(sheetDetail1.getProducingAreaSimplify(), sheetDetail2.getProducingAreaSimplify());
            Boolean brand = StringUtils.compare(sheetDetail1.getBrand(), sheetDetail2.getBrand());
            Boolean currency = StringUtils.compare(sheetDetail1.getCurrency(), sheetDetail2.getCurrency());
            if (commodityName && cmpCode && producingArea && brand && currency) {
                return Boolean.TRUE;
            } else {
                return Boolean.FALSE;
            }
        }
    }


    /**
     *  按照
     *
     * @param set 产地
     * @return
     */
    public static ArrayList<CommissionSheetDetail> commissionSheetDetailOrderByDetnoASC(Set<CommissionSheetDetail> set) {
        if (CollectionUtils.isEmpty(set)) {
            return null;
        } else {
            ArrayList<CommissionSheetDetail>  list = new ArrayList<>();
            list.addAll(set);
            Collections.sort(list, new Comparator<CommissionSheetDetail>() {
                public int compare(CommissionSheetDetail o1, CommissionSheetDetail o2) {
                    return o1.getDetno() - o2.getDetno();
                }
            });
            return list;
        }

    }
}
