package com.uas.customsdeclaration.business.common.util;

import com.uas.customsdeclaration.business.common.model.CommissionSheet;
import com.uas.customsdeclaration.util.StringUtils;

/**
 * 委托单的辅助工具类
 *
 * @author yuj 2018-03-20 17:29
 */
public class CommissionSheetUtil {

    /**
     * 比较委托单的变化
     * @param updateSheet
     * @param sheet
     * @return
     */
    public static String commissionSheetModifyChange(CommissionSheet updateSheet, CommissionSheet sheet) {
        if (updateSheet == null || sheet == null) {
            return "";
        } else {
            StringBuffer str = new StringBuffer();
            String deliveryContactInfo1 = updateSheet.getDeliveryContactInfoSimplify();
            String deliveryContactInfo2 = sheet.getDeliveryContactInfoSimplify();
            if (!StringUtils.compare(deliveryContactInfo1, deliveryContactInfo2)) {
                str.append("香港交货联系信息：" + deliveryContactInfo2 + "->" + deliveryContactInfo1 + "。");
            }
            String deliveryType = updateSheet.getDeliveryType();
            String deliveryType1 = sheet.getDeliveryType();
            if (!StringUtils.compare(deliveryType, deliveryType1)) {
                str.append("香港交货方式信息：" + deliveryType1 + "->" + deliveryType + "。");
            }

            String stockContactInfo = updateSheet.getStockContactInfoSimplify();
            String stockContactInfo1 = sheet.getStockContactInfoSimplify();
            if (!StringUtils.compare(stockContactInfo, stockContactInfo1)) {
                str.append("深圳交货联系信息：" + stockContactInfo1 + "->" + stockContactInfo + "。");
            }
            String stockType = updateSheet.getStockType();
            String stockType1 = sheet.getStockType();
            if (!StringUtils.compare(stockType, stockType1)) {
                str.append("深圳交货方式为：" + stockType1 + "->" + stockType + "。");
            }

            String deliveryFileUrl = updateSheet.getDeliveryFileUrl();
            String deliveryFileUrl2 = sheet.getDeliveryFileUrl();
            if (!StringUtils.compare(deliveryFileUrl, stockType1)) {
                str.append("文件上传地址信息：" + deliveryFileUrl + "->" + deliveryFileUrl2 + "。");
            }

            Integer status1 = updateSheet.getStatus();
            Integer status2 = sheet.getStatus();
            if (status1.intValue() != status2.intValue()) {
                str.append("表单的状态信息：" + status1 + "->" + status2 + "。");
            }
            return str.toString();
        }

    }
}
