package com.uas.customsdeclaration.business.customer.service;

import com.uas.customsdeclaration.business.customer.model.Customer;
import com.uas.customsdeclaration.util.ResultMap;
import com.uas.platform.core.model.PageParams;

/**
 * 客户资料接口
 *
 * Created by yujia on 2018/3/19.
 */
public interface CustomerService {

    /**
     * 根据企业UU获取客户信息
     * @param enuu
     * @return
     */
    ResultMap findByEnuu(Long enuu);

    /**
     * 保存客户的信息
     *
     * @param params 客户的信息
     * @return ResultMap
     */
    ResultMap saveCustomer(String params);


    /**
     * 验证客户的信息是否正确
     *
     * @param customer 客户信息
     * @return ResultMap
     */
    ResultMap validatorCustomer(Customer customer);


    /**
     * 分页获取客资料信息
     *
     * @param params 分页信息
     * @param keyword 需要搜索的关键字
     * @return ResultMap
     */
    ResultMap getCustomer(PageParams params, String keyword);

    /**
     * 根据enuu 获取客户信息
     *
     * @param id 客户资料的主键
     * @return
     */
    ResultMap findById(Long id);
}
