package com.uas.customsdeclaration.business.customer.service;

import com.uas.customsdeclaration.util.ResultMap;
import com.uas.platform.core.model.PageParams;

/**
 * Created by yujia on 2018/4/20.
 */
public interface RemittanceAccountService {

    /**
     * 保存付汇账号
     *
     * @param params 需要保存的信息
     * @return ResultMap
     */
    ResultMap save(String params);

    /**
     * 分页获取付汇账号信息
     * @param params 分页信息
     * @return ResultMap
     */
    ResultMap getRemittanceAccountByPage(PageParams params);


    /**
     * 根据id 获取付汇账号信息
     * @param id 付汇账号的主键
     * @return ResultMap
     */
    ResultMap getRemittanceAccountById(Long id);


    /**
     * 删除地址的外汇账号信息
     * @param id 需要删除信息的主键
     * @return ResultMap被删除的信息
     */
    ResultMap deleteRemittanceAccountById(Long id);
}
