package com.uas.customsdeclaration.business.facilitator.controller;

import com.uas.customsdeclaration.business.facilitator.service.DeliveryTypeService;
import com.uas.customsdeclaration.util.ResultMap;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;

/**
 * 交货方式控制器
 *
 * @author yuj 2018-03-15 16:07
 */
@RestController
@RequestMapping(value = "/facilitator/deliveryType")
public class DeliveryTypeController {

    private final DeliveryTypeService deliveryTypeService;

    @Autowired
    public DeliveryTypeController(DeliveryTypeService deliveryTypeService) {
        this.deliveryTypeService = deliveryTypeService;
    }

    /**
     * 保存交货方式
     *
     * @param type  交货方式的String 格式
     * @return ResultMap
     */
    @RequestMapping(value = "/save", method = RequestMethod.POST)
    public ResultMap saveDeliveryType(String type) {
        return deliveryTypeService.saveDeliveryType(type);
    }


    /**
     * 根据交货方式及公司enuu获取
     * @param enuu
     * @param type
     * @return ResultMap
     */
    @RequestMapping(value = "/enuu/delivery", method = RequestMethod.GET)
    public ResultMap getDeliveryTypeByEnuuAndType(Long enuu, String type) {
        return deliveryTypeService.getDeliveryTypeByEnuuAndType(enuu, type);

    }
}
