package com.uas.customsdeclaration.business.facilitator.dao;

import com.uas.customsdeclaration.business.facilitator.model.CustomerCodeInfo;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.JpaSpecificationExecutor;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.Param;
import org.springframework.stereotype.Repository;

import java.util.List;

/**
 * 海关编码
 *
 * Created by yujia on 2018/3/26.
 */
@Repository
public interface CustomerCodeInfoDao extends JpaSpecificationExecutor<CustomerCodeInfo>, JpaRepository<CustomerCodeInfo, Long> {

    @Query(value = "select c from CustomerCodeInfo c where c.customerHouseCode in :codes")
    List<CustomerCodeInfo> findCustomerCodeInfoInCodes(@Param("codes") List<String> codes);
}
