package com.uas.customsdeclaration.business.facilitator.dao;

import com.uas.customsdeclaration.business.facilitator.model.ExchangeRate;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.JpaSpecificationExecutor;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.Param;
import org.springframework.stereotype.Repository;

import java.util.List;

/**
 * Created by yujia on 2018/4/11.
 */
@Repository
public interface ExchangeRateDao extends JpaSpecificationExecutor<ExchangeRate>, JpaRepository<ExchangeRate, Long>{

    /**
     * 根据币别名称获取汇率信息
     * @param currencyName 币别名称
     * @return List<ExchangeRate>
     */
    @Query(value = "select e from ExchangeRate e where e.currencyName =:currencyName")
    List<ExchangeRate> findExchangeRateByCurrencyName(@Param("currencyName") String currencyName);
}
