package com.uas.customsdeclaration.business.facilitator.model;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.Table;
import java.io.Serializable;

/**
 * 海关编码库
 *
 * @author yuj 2018-03-22 20:06
 */
@Entity
@Table(name = "cd$customercodeinfo")
public class CustomerCodeInfo implements Serializable {

    private static final long serialVersionUID = 8572322689142331953L;


    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    private Long id;

    /**
     * 海关编码
     */
    @Column(name = "cci_customer_house_code")
    private String customerHouseCode;

    /**
     * 第一单位
     */
    @Column(name = "cci_first_unit")
    private String firstUnit;

    /**
     * 第二单位
     */
    @Column(name = "cci_second_unit")
    private String secondUnit;

    /**
     * 申报要素
     */
    @Column(name = "cci_description")
    private String description;

    public Long getId() {
        return id;
    }

    public CustomerCodeInfo setId(Long id) {
        this.id = id;
        return this;
    }

    public String getCustomerHouseCode() {
        return customerHouseCode;
    }

    public CustomerCodeInfo setCustomerHouseCode(String customerHouseCode) {
        this.customerHouseCode = customerHouseCode;
        return this;
    }

    public String getFirstUnit() {
        return firstUnit;
    }

    public CustomerCodeInfo setFirstUnit(String firstUnit) {
        this.firstUnit = firstUnit;
        return this;
    }

    public String getSecondUnit() {
        return secondUnit;
    }

    public CustomerCodeInfo setSecondUnit(String secondUnit) {
        this.secondUnit = secondUnit;
        return this;
    }

    public String getDescription() {
        return description;
    }

    public CustomerCodeInfo setDescription(String description) {
        this.description = description;
        return this;
    }

    @Override
    public String toString() {
        return "CustomerCodeInfo{" +
                "id=" + id +
                ", customerHouseCode='" + customerHouseCode + '\'' +
                ", firstUnit='" + firstUnit + '\'' +
                ", secondUnit='" + secondUnit + '\'' +
                ", description='" + description + '\'' +
                '}';
    }
}
