package com.uas.customsdeclaration.business.facilitator.model;

import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.OneToMany;
import javax.persistence.OrderBy;
import javax.persistence.Table;
import java.io.Serializable;
import java.util.Date;
import java.util.Set;

/**
 * 关务验证单
 *
 * @author yuj 2018-03-23 15:44
 */
@Entity
@Table(name = "cd$customerhouseservicesheet")
public class CustomerHouseServiceSheet implements Serializable {

    private static final long serialVersionUID = -263037696801991581L;

    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    private Long id;

    /**
     * 生成的单号后缀
     */
    @Column(name = "chss_sheet_no_suffix")
    private String sheetNoSuffix;

    /**
     * 单号后缀
     */
    @Column(name = "chss_sheet_prefix")
    private String sheetPrefix;

    /**
     * 创建时间
     */
    @Column(name = "chss_createtime_str")
    private String createTimeStr;


    @OneToMany(mappedBy = "sheet", cascade = CascadeType.ALL, fetch = FetchType.EAGER)
    @OrderBy("detno")
    Set<CustomerHouseServiceSheetDetail> customerHouseServiceSheetDetail;

    /**
     * 来源单据
     */
    @Column(name = "chss_source_sheet")
    private String sourceSheet;

    /**
     * 创建的时间
     */
    @Column(name = "chss_createtime")
    private Date createTime;

    /**
     * 公司
     */
    @Column(name = "chss_company_name")
    private String companyName;

    /**
     * 公司enuu
     */
    @Column(name = "chss_company_enuu")
    private String companyEnuu;

    /**
     * 币别
     */
    @Column(name = "chss_currency")
    private String currency;

    /**
     * 统计的净重
     */
    @Column(name = "chss_total_net_weight")
    private Double totalNetWeight;


    /**
     * 统计毛重
     */
    @Column(name = "chss_total_gross_weight")
    private Double totalGrossWeight;

    /**
     * 统计的数量
     */
    @Column(name = "chss_total_quantity")
    private Long totalQuantity;

    /**
     * 总计金额
     */
    @Column(name = "chss_total_price")
    private Double totalPrice;

    /**
     * 箱数
     */
    @Column(name = "chss_total_Carton_num")
    private Integer totalCartonNum;

    public Long getId() {
        return id;
    }

    public CustomerHouseServiceSheet setId(Long id) {
        this.id = id;
        return this;
    }

    public String getSheetNoSuffix() {
        return sheetNoSuffix;
    }

    public CustomerHouseServiceSheet setSheetNoSuffix(String sheetNoSuffix) {
        this.sheetNoSuffix = sheetNoSuffix;
        return this;
    }

    public String getSheetPrefix() {
        return sheetPrefix;
    }

    public CustomerHouseServiceSheet setSheetPrefix(String sheetPrefix) {
        this.sheetPrefix = sheetPrefix;
        return this;
    }

    public String getCreateTimeStr() {
        return createTimeStr;
    }

    public CustomerHouseServiceSheet setCreateTimeStr(String createTimeStr) {
        this.createTimeStr = createTimeStr;
        return this;
    }

    public Date getCreateTime() {
        return createTime;
    }

    public String getCompanyName() {
        return companyName;
    }

    public CustomerHouseServiceSheet setCompanyName(String companyName) {
        this.companyName = companyName;
        return this;
    }

    public String getCompanyEnuu() {
        return companyEnuu;
    }

    public CustomerHouseServiceSheet setCompanyEnuu(String companyEnuu) {
        this.companyEnuu = companyEnuu;
        return this;
    }

    public CustomerHouseServiceSheet setCreateTime(Date createTime) {
        this.createTime = createTime;
        return this;
    }

    public Set<CustomerHouseServiceSheetDetail> getCustomerHouseServiceSheetDetail() {
        return customerHouseServiceSheetDetail;
    }

    public CustomerHouseServiceSheet setCustomerHouseServiceSheetDetail(Set<CustomerHouseServiceSheetDetail> customerHouseServiceSheetDetail) {
        this.customerHouseServiceSheetDetail = customerHouseServiceSheetDetail;
        return this;
    }

    public String getSourceSheet() {
        return sourceSheet;
    }

    public CustomerHouseServiceSheet setSourceSheet(String sourceSheet) {
        this.sourceSheet = sourceSheet;
        return this;
    }

    public String getCurrency() {
        return currency;
    }

    public CustomerHouseServiceSheet setCurrency(String currency) {
        this.currency = currency;
        return this;
    }

    public Double getTotalNetWeight() {
        return totalNetWeight;
    }

    public CustomerHouseServiceSheet setTotalNetWeight(Double totalNetWeight) {
        this.totalNetWeight = totalNetWeight;
        return this;
    }

    public Double getTotalGrossWeight() {
        return totalGrossWeight;
    }

    public CustomerHouseServiceSheet setTotalGrossWeight(Double totalGrossWeight) {
        this.totalGrossWeight = totalGrossWeight;
        return this;
    }

    public Long getTotalQuantity() {
        return totalQuantity;
    }

    public CustomerHouseServiceSheet setTotalQuantity(Long totalQuantity) {
        this.totalQuantity = totalQuantity;
        return this;
    }

    public Double getTotalPrice() {
        return totalPrice;
    }

    public CustomerHouseServiceSheet setTotalPrice(Double totalPrice) {
        this.totalPrice = totalPrice;
        return this;
    }

    public Integer getTotalCartonNum() {
        return totalCartonNum;
    }

    public CustomerHouseServiceSheet setTotalCartonNum(Integer totalCartonNum) {
        this.totalCartonNum = totalCartonNum;
        return this;
    }

    @Override
    public String toString() {
        return "CustomerHouseServiceSheet{" +
                "id=" + id +
                ", sheetNoSuffix='" + sheetNoSuffix + '\'' +
                ", sheetPrefix='" + sheetPrefix + '\'' +
                ", createTimeStr='" + createTimeStr + '\'' +
                ", customerHouseServiceSheetDetail=" + customerHouseServiceSheetDetail +
                ", sourceSheet='" + sourceSheet + '\'' +
                ", createTime=" + createTime +
                ", companyName='" + companyName + '\'' +
                ", companyEnuu='" + companyEnuu + '\'' +
                ", currency='" + currency + '\'' +
                ", totalNetWeight=" + totalNetWeight +
                ", totalGrossWeight=" + totalGrossWeight +
                ", totalQuantity=" + totalQuantity +
                ", totalPrice=" + totalPrice +
                ", totalCartonNum=" + totalCartonNum +
                '}';
    }
}
