package com.uas.customsdeclaration.business.facilitator.model;

import com.alibaba.fastjson.annotation.JSONField;
import com.fasterxml.jackson.annotation.JsonIgnore;

import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.Table;
import java.io.Serializable;

/**
 * 关务验证后的表单明细
 *
 * @author yuj 2018-03-23 16:02
 */
@Entity
@Table(name = "cd$customerhouseservicesheetdetail")
public class CustomerHouseServiceSheetDetail implements Serializable {

    private static final long serialVersionUID = 7437701699727062532L;

    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    private Long id;

    /**
     * 序号
     */
    @Column(name = "chssd_detno")
    private Integer detno;

    /**
     * 货物名称
     */
    @Column(name = "chssd_commodity_name")
    private String commodityName;

    /**
     * 型号
     */
    @Column(name = "chssd_cmp_code")
    private String cmpCode;

    /**
     * 单位
     */
    @Column(name = "chssd_unit")
    private String unit;

    /**
     * 数量
     */
    @Column(name = "chssd_amount")
    private Long amount;

    /**
     * 单价
     */
    @Column(name = "chssd_unitprice")
    private Double unitPrice;

    /**
     * 总价
     */
    @Column(name = "chssd_total_price")
    private Double totalPrice;

    /**
     * 品牌信息
     */
    @Column(name = "chssd_brand")
    private String brand;

    /**
     * 申报要素
     */
    @Column(name = "chssd_declare_element")
    private String declareElement;

    /**
     * 净重
     */
    @Column(name = "chssd_netweight")
    private Double netWeight;

    /**
     * 毛重
     */
    @Column(name = "chssd_grossweight")
    private Double grossWeight;

    /**
     * 产地
     */
    @Column(name = "chssd_producearea")
    private String produceArea;


    @ManyToOne(cascade = {CascadeType.PERSIST, CascadeType.REFRESH, CascadeType.DETACH, CascadeType.MERGE}, optional = false)
    @JoinColumn(name = "sheet_id")
    private CustomerHouseServiceSheet sheet;

    /**
     * 来源的订单号
     */
    @Column(name = "chssd_sourceid")
    private String sourceid;

    /**
     * 成交单位
     */
    @Column(name = "chssd_transaction_unit")
    private String transactionUnit;

    /**
     * 成交数量
     */
    @Column(name = "chssd_transaction_quantity")
    private String transactionQuantity;

    /**
     * 法定数量
     */
    @Column(name = "chssd_statutory_quantity")
    private String statutoryQuantity;

    /**
     * 第二个单位
     */
    @Column(name = "chssd_second_unit")
    private String secondUnit;

    /**
     * 第二数量
     */
    @Column(name = "chssd_second_quantity")
    private String secondQuantity;

    /**
     * 原产国
     */
    @Column(name = "chssd_origin_country")
    private String originCountry;

    /**
     * 最终目的国
     */
    @Column(name = "chssd_destination_country")
    private String destinationCountry;

    /**
     * 币制
     */
    @Column(name = "chssd_currency")
    private String currency;

    /**
     * 征免
     */
    @Column(name = "chssd_exemption")
    private String exemption;

    /**
     * 海关编码
     */
    @Column(name = "chssd_customer_house_code")
    private String customerHouseCode;

    public Long getId() {
        return id;
    }

    public CustomerHouseServiceSheetDetail setId(Long id) {
        this.id = id;
        return this;
    }

    public Integer getDetno() {
        return detno;
    }

    public CustomerHouseServiceSheetDetail setDetno(Integer detno) {
        this.detno = detno;
        return this;
    }

    public String getCommodityName() {
        return commodityName;
    }

    public CustomerHouseServiceSheetDetail setCommodityName(String commodityName) {
        this.commodityName = commodityName;
        return this;
    }

    public String getCmpCode() {
        return cmpCode;
    }

    public CustomerHouseServiceSheetDetail setCmpCode(String cmpCode) {
        this.cmpCode = cmpCode;
        return this;
    }

    public String getUnit() {
        return unit;
    }

    public CustomerHouseServiceSheetDetail setUnit(String unit) {
        this.unit = unit;
        return this;
    }

    public Long getAmount() {
        return amount;
    }

    public CustomerHouseServiceSheetDetail setAmount(Long amount) {
        this.amount = amount;
        return this;
    }

    public Double getUnitPrice() {
        return unitPrice;
    }

    public CustomerHouseServiceSheetDetail setUnitPrice(Double unitPrice) {
        this.unitPrice = unitPrice;
        return this;
    }

    public Double getTotalPrice() {
        return totalPrice;
    }

    public CustomerHouseServiceSheetDetail setTotalPrice(Double totalPrice) {
        this.totalPrice = totalPrice;
        return this;
    }

    public String getBrand() {
        return brand;
    }

    public CustomerHouseServiceSheetDetail setBrand(String brand) {
        this.brand = brand;
        return this;
    }

    public String getDeclareElement() {
        return declareElement;
    }

    public CustomerHouseServiceSheetDetail setDeclareElement(String declareElement) {
        this.declareElement = declareElement;
        return this;
    }

    @JsonIgnore
    @JSONField(serialize = false)
    public CustomerHouseServiceSheet getSheet() {
        return sheet;
    }

    public CustomerHouseServiceSheetDetail setSheet(CustomerHouseServiceSheet sheet) {
        this.sheet = sheet;
        return this;
    }

    public String getSourceid() {
        return sourceid;
    }

    public CustomerHouseServiceSheetDetail setSourceid(String sourceid) {
        this.sourceid = sourceid;
        return this;
    }

    public String getTransactionUnit() {
        return transactionUnit;
    }

    public CustomerHouseServiceSheetDetail setTransactionUnit(String transactionUnit) {
        this.transactionUnit = transactionUnit;
        return this;
    }

    public String getStatutoryQuantity() {
        return statutoryQuantity;
    }

    public CustomerHouseServiceSheetDetail setStatutoryQuantity(String statutoryQuantity) {
        this.statutoryQuantity = statutoryQuantity;
        return this;
    }

    public String getSecondUnit() {
        return secondUnit;
    }

    public CustomerHouseServiceSheetDetail setSecondUnit(String secondUnit) {
        this.secondUnit = secondUnit;
        return this;
    }

    public String getOriginCountry() {
        return originCountry;
    }

    public CustomerHouseServiceSheetDetail setOriginCountry(String originCountry) {
        this.originCountry = originCountry;
        return this;
    }

    public String getDestinationCountry() {
        return destinationCountry;
    }

    public CustomerHouseServiceSheetDetail setDestinationCountry(String destinationCountry) {
        this.destinationCountry = destinationCountry;
        return this;
    }

    public String getCurrency() {
        return currency;
    }

    public CustomerHouseServiceSheetDetail setCurrency(String currency) {
        this.currency = currency;
        return this;
    }

    public String getExemption() {
        return exemption;
    }

    public CustomerHouseServiceSheetDetail setExemption(String exemption) {
        this.exemption = exemption;
        return this;
    }

    public Double getNetWeight() {
        return netWeight;
    }

    public CustomerHouseServiceSheetDetail setNetWeight(Double netWeight) {
        this.netWeight = netWeight;
        return this;
    }

    public Double getGrossWeight() {
        return grossWeight;
    }

    public CustomerHouseServiceSheetDetail setGrossWeight(Double grossWeight) {
        this.grossWeight = grossWeight;
        return this;
    }

    public String getProduceArea() {
        return produceArea;
    }

    public CustomerHouseServiceSheetDetail setProduceArea(String produceArea) {
        this.produceArea = produceArea;
        return this;
    }

    public String getCustomerHouseCode() {
        return customerHouseCode;
    }

    public CustomerHouseServiceSheetDetail setCustomerHouseCode(String customerHouseCode) {
        this.customerHouseCode = customerHouseCode;
        return this;
    }

    public String getSecondQuantity() {
        return secondQuantity;
    }

    public CustomerHouseServiceSheetDetail setSecondQuantity(String secondQuantity) {
        this.secondQuantity = secondQuantity;
        return this;
    }

    public String getTransactionQuantity() {
        return transactionQuantity;
    }

    public CustomerHouseServiceSheetDetail setTransactionQuantity(String transactionQuantity) {
        this.transactionQuantity = transactionQuantity;
        return this;
    }

    @Override
    public String toString() {
        return "CustomerHouseServiceSheetDetail{" +
                "id=" + id +
                ", detno=" + detno +
                ", commodityName='" + commodityName + '\'' +
                ", cmpCode='" + cmpCode + '\'' +
                ", unit='" + unit + '\'' +
                ", amount=" + amount +
                ", unitPrice=" + unitPrice +
                ", totalPrice=" + totalPrice +
                ", brand='" + brand + '\'' +
                ", declareElement='" + declareElement + '\'' +
                ", netWeight=" + netWeight +
                ", grossWeight=" + grossWeight +
                ", produceArea='" + produceArea + '\'' +
                ", sheet=" + sheet +
                ", sourceid='" + sourceid + '\'' +
                ", transactionUnit='" + transactionUnit + '\'' +
                ", statutoryQuantity='" + statutoryQuantity + '\'' +
                ", secondUnit='" + secondUnit + '\'' +
                ", secondQuantity='" + secondQuantity + '\'' +
                ", originCountry='" + originCountry + '\'' +
                ", destinationCountry='" + destinationCountry + '\'' +
                ", currency='" + currency + '\'' +
                ", exemption='" + exemption + '\'' +
                ", customerHouseCode='" + customerHouseCode + '\'' +
                '}';
    }
}
