package com.uas.customsdeclaration.business.facilitator.model;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.EnumType;
import javax.persistence.Enumerated;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.Table;
import java.io.Serializable;

/**
 * 交货方式
 *
 * @author yuj 2018-03-15 15:38
 */
@Entity
@Table(name = "cd$deliverytype")
public class DeliveryType implements Serializable {

    private static final long serialVersionUID = -5819634899410262324L;

    @Id
    @Column(name = "id")
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    private Long id;

    /**
     * 交货方式
     */
    @Column(name = "dt_detno", nullable = false)
    private Integer detno;

    /**
     * 交货方式描述
     */
    @Column(name = "dt_description", nullable = false)
    private String description;

    /**
     * 所属公司
     */
    @Column(name = "dt_enuu", nullable = false)
    private Long enuu;

    /**
     * 提示信息
     * <p>市内送货免费，市外送货产生费用（金额暂时不定）<p/>
     */
    @Column(name = "dt_notice")
    private String notice;

    /**
     * 交货类型描述
     * <p>
     *     深圳交货方式
     *     香港交货方式
     *     <p/>
     */
    @Column(name = "dt_type_description", nullable = false)
    private String typeDescription;

    /**
     * 进出口、进出货类型类型
     */
    @Column(name = "dt_import_export_delivery", nullable = false)
    @Enumerated(value = EnumType.STRING)
    private ImportExportDelivery importExportDelivery;

    /**
     * 是否需要录入地址信息
     */
    @Column(name = "dt_required_address", nullable = false)
    private Boolean requiredAddress;

    /**
     * 是否支持文件上传
     */
    @Column(name = "dt_support_file")
    private Boolean supportFile;

    public Long getId() {
        return id;
    }

    public DeliveryType setId(Long id) {
        this.id = id;
        return this;
    }

    public Integer getDetno() {
        return detno;
    }

    public DeliveryType setDetno(Integer detno) {
        this.detno = detno;
        return this;
    }

    public String getDescription() {
        return description;
    }

    public DeliveryType setDescription(String description) {
        this.description = description;
        return this;
    }

    public Long getEnuu() {
        return enuu;
    }

    public DeliveryType setEnuu(Long enuu) {
        this.enuu = enuu;
        return this;
    }

    public String getNotice() {
        return notice;
    }

    public DeliveryType setNotice(String notice) {
        this.notice = notice;
        return this;
    }

    public String getTypeDescription() {
        return typeDescription;
    }

    public DeliveryType setTypeDescription(String typeDescription) {
        this.typeDescription = typeDescription;
        return this;
    }

    public ImportExportDelivery getImportExportDelivery() {
        return importExportDelivery;
    }

    public DeliveryType setImportExportDelivery(ImportExportDelivery importExportDelivery) {
        this.importExportDelivery = importExportDelivery;
        return this;
    }

    public Boolean getRequiredAddress() {
        return requiredAddress;
    }

    public DeliveryType setRequiredAddress(Boolean requiredAddress) {
        this.requiredAddress = requiredAddress;
        return this;
    }

    public Boolean getSupportFile() {
        return supportFile;
    }

    public DeliveryType setSupportFile(Boolean supportFile) {
        this.supportFile = supportFile;
        return this;
    }
}
