package com.uas.customsdeclaration.business.facilitator.model;

import com.uas.customsdeclaration.util.StringUtils;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.Table;
import java.io.Serializable;
import java.util.Date;

/**
 * 汇率的信息
 *
 * @author yuj 2018-04-11 9:03
 */
@Entity
@Table(name = "cd$exchangerate")
public class ExchangeRate implements Serializable {

    private static final long serialVersionUID = 4185719535806190092L;

    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    private Long id;

    /**
     * 币别信息
     */
    @Column(name = "er_currency", unique = true)
    private String currency;

    /**
     * 币别中文名
     */
    @Column(name = "er_currencyname", unique = true)
    private String currencyName;

    /**
     * 创建时间
     */
    @Column(name = "er_createtime")
    private Date createTime;

    /**
     * 汇率
     */
    @Column(name = "er_rate")
    private Double rate;

    /**
     * 操作人
     */
    @Column(name = "er_useruu")
    private Long useruu;

    /**
     * 操作人
     */
    @Column(name = "er_username")
    private String username;

    /**
     * 银行发布时间
     */
    @Column(name = "er_bankpublishtime")
    private String bankPublishTime;

    public Long getId() {
        return id;
    }

    public ExchangeRate setId(Long id) {
        this.id = id;
        return this;
    }

    public String getCurrency() {
        return currency;
    }

    public ExchangeRate setCurrency(String currency) {
        this.currency = currency;
        return this;
    }

    public Date getCreateTime() {
        return createTime;
    }

    public ExchangeRate setCreateTime(Date createTime) {
        this.createTime = createTime;
        return this;
    }

    public Double getRate() {
        return rate;
    }

    public ExchangeRate setRate(Double rate) {
        this.rate = rate;
        return this;
    }

    public Long getUseruu() {
        return useruu;
    }

    public ExchangeRate setUseruu(Long useruu) {
        this.useruu = useruu;
        return this;
    }

    public String getUsername() {
        return username;
    }

    public ExchangeRate setUsername(String username) {
        this.username = username;
        return this;
    }

    public String getCurrencyName() {
        return currencyName;
    }

    public ExchangeRate setCurrencyName(String currencyName) {
        this.currencyName = currencyName;
        return this;
    }

    public String getBankPublishTime() {
        return bankPublishTime;
    }

    public ExchangeRate setBankPublishTime(String bankPublishTime) {
        this.bankPublishTime = bankPublishTime;
        return this;
    }

    @Override
    public String toString() {
        return "ExchangeRate{" +
                "id=" + id +
                ", currency='" + currency + '\'' +
                ", currencyName='" + currencyName + '\'' +
                ", createTime=" + createTime +
                ", rate=" + rate +
                ", useruu=" + useruu +
                ", username='" + username + '\'' +
                ", bankPublishTime='" + bankPublishTime + '\'' +
                '}';
    }

    /**
     * 验证汇率的信息是否填写完整。
     * @return
     */
    public Boolean validate() {
        if (StringUtils.isEmpty(this.currencyName) || this.rate == null) {
            return Boolean.FALSE;
        } else {
            return Boolean.TRUE;
        }
    }
}
