package com.uas.customsdeclaration.business.facilitator.model;

import com.uas.customsdeclaration.util.StringUtils;

/**
 * 进出口交货方式
 *
 * Created by yujia on 2018/3/15.
 */
public enum ImportExportDelivery {

    /**
     * 进口进货
     */
    IMPORTSTOCK(1, "进口进货"),

    /**
     * 进口出货
     */
    IMPORTDELIVERY(2, "进口出货"),

    /**
     * 出口进货
     */
    EXPORTSTOCK(3, "出口进货"),

    /**
     * 出口出货
     */
    EXPORTDELIVERY(4, "出口出货");

    private int code;

    private String phrase;

    ImportExportDelivery(int code, String phrase) {
        this.code = code;
        this.phrase = phrase;
    }

    public int getCode() {
        return code;
    }

    public ImportExportDelivery setCode(int code) {
        this.code = code;
        return this;
    }

    public String getPhrase() {
        return phrase;
    }

    public ImportExportDelivery setPhrase(String phrase) {
        this.phrase = phrase;
        return this;
    }

    public static ImportExportDelivery initImportExportDeliveryByPhrase(String phrase) {
        if (StringUtils.isEmpty(phrase)) {
            return null;
        } else {
            if (IMPORTDELIVERY.getPhrase().equals(phrase)) {
                return IMPORTDELIVERY;
            } else if (IMPORTSTOCK.getPhrase().equals(phrase)) {
                return IMPORTSTOCK;
            } else if (EXPORTDELIVERY.getPhrase().equals(phrase)) {
                return EXPORTDELIVERY;
            } else if (EXPORTSTOCK.getPhrase().equals(phrase)) {
                return EXPORTSTOCK;
            } else {
                return null;
            }
        }
    }


    public static ImportExportDelivery initImportExportDeliveryByName(String name) {
        if (StringUtils.isEmpty(name)) {
            return null;
        } else {
            if (IMPORTDELIVERY.name().equalsIgnoreCase(name)) {
                return IMPORTDELIVERY;
            } else if (IMPORTSTOCK.name().equalsIgnoreCase(name)) {
                return IMPORTSTOCK;
            } else if (EXPORTDELIVERY.name().equalsIgnoreCase(name)) {
                return EXPORTDELIVERY;
            } else if (EXPORTSTOCK.name().equalsIgnoreCase(name)) {
                return EXPORTSTOCK;
            } else {
                return null;
            }
        }
    }
}
