package com.uas.customsdeclaration.business.facilitator.service;

import com.uas.customsdeclaration.util.ResultMap;
import com.uas.platform.core.model.PageParams;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;

/**
 * 验证单据的调整
 *
 * Created by yujia on 2018/3/23.
 */
public interface CustomerHouseServiceSheetService {

    /**
     * 用户保存的
     *
     * @param json
     * @return
     */
    ResultMap save(String json);


    /**
     * 根据id获取验证后的委托单据
     *
     * @param id 主键信息
     * @return CustomerHouseServiceSheet
     */
    ResultMap getCustomerHouseServiceSheetById(Long id);



    /**
     * 根据分页信息获取关务验证单据
     *
     * @param page 分页信息
     * @param keyword 搜索关键字
     * @return ResultMap
     */
    ResultMap findCustomerHouseServiceSheetByPage(PageParams page, String keyword);


    /**
     * 批量下载文件信息
     * @param ids 需要下载的主键信息
     * @param request  请求对象
     * @param response 响应对象
     */
    void downByBatch(String ids, HttpServletRequest request,
                     HttpServletResponse response) throws IOException;


    /**
     * 根据前端合并的商品明细，保存关务验证单
     * @param params
     * @return
     */
    ResultMap saveCustomerHouseServiceSheet(String params, String ids);
}
