package com.uas.customsdeclaration.business.facilitator.service;

import com.uas.customsdeclaration.util.ResultMap;
import com.uas.platform.core.model.PageParams;
import org.springframework.web.multipart.MultipartFile;

/**
 * Created by yujia on 2018/3/23.
 */
public interface DeclarationElementsService {


    /**
     * 保存申报要素
     * @param params 文件的信息
     * @param file 文件信息
     * @return
     */
    ResultMap save(String params, MultipartFile file);


    /**
     * 分页获取申报要素
     *
     * @param keyword 搜索的值
     * @param params 分页的信息
     * @return  ResultMap
     */
    ResultMap getDeclarationElements(String keyword, PageParams params);

    /**
     * 根据id获取申报要素信息
     *
     * @param id 传入的id信息
     * @return ResultMap
     */
    ResultMap getDeclarationElementsById (Long id);



    /**
     * 根据关键字获取联想词，根据时间从近到远排序
     * @param keyword
     * @return
     */
    ResultMap findAssociationaInfo(String keyword);


    /**
     * 根据商品名称、型号、品牌获取申报要素信息
     *
     * @param cmpName 商品名称
     * @param brand 品牌
     * @param code 器件型号
     * @return ResultMap
     */
    ResultMap findDeclarationElementsByCmpNameAndBrandAndCode(String cmpName, String brand, String code);


    /**
     * 批量获取申报要素信息
     * @param params 批量获取
     * @return ResultMap
     */
    ResultMap findDeclarationElementsByCmpNameAndBrandAndCodeByBatch(String params);
}
