package com.uas.customsdeclaration.business.facilitator.util;

import com.uas.customsdeclaration.business.facilitator.model.ExchangeRate;
import com.uas.customsdeclaration.business.facilitator.model.ExchangeRateHistory;

import java.util.Date;

/**
 * 汇率的转化
 *
 * @author yuj 2018-04-23 10:34
 */
public class ExchangeRateHistoryUtil {

    /**
     * 汇率转化成历史汇率
     * @param
     * @return ExchangeRate
     */
    public static ExchangeRateHistory convertExchangeRateToExchangeRateHistory(ExchangeRate exchangeRate) {
        if (exchangeRate == null) {
            return null;
        }
        ExchangeRateHistory history = new ExchangeRateHistory();
        history.setCreateTime(new Date());
        history.setCurrency(exchangeRate.getCurrency());
        history.setCurrencyName(exchangeRate.getCurrencyName());
        history.setUseruu(exchangeRate.getUseruu());
        history.setUsername(exchangeRate.getUsername());
        history.setBankPublishTime(exchangeRate.getBankPublishTime());
        history.setOriginDate(exchangeRate.getCreateTime());
        history.setRate(exchangeRate.getRate());
        history.setSourceId(exchangeRate.getId());
        history.setCreateTime(new Date());
        return history;
    }
}
