package com.uas.customsdeclaration.common.base.controller;

import com.uas.account.sso.integration.entity.UserAccount;
import com.uas.account.sso.integration.service.UserService;
import com.uas.account.sso.integration.util.SSO;
import com.uas.customsdeclaration.core.UserInfoUtil;
import com.uas.customsdeclaration.util.ResultMap;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;

/**
 * 获取用户登录的信息
 *
 * @author yuj 2018-02-28 14:29
 */
@RestController
@RequestMapping(value = "/user")
public class UserController {

    private final UserService userService;

    private final UserInfoUtil userInfoUtil;

    @Autowired
    public UserController(UserService userService, UserInfoUtil userInfoUtil) {
        this.userService = userService;
        this.userInfoUtil = userInfoUtil;
    }

    /**
     * 获取用户的登录信息
     *
     * @return UserView 返回的登录值
     */
    @RequestMapping(value = "/authentication", method = RequestMethod.GET)
    public ResultMap getUserInfo() {
        UserAccount userAccount = SSO.get();
        return ResultMap.success(userAccount);
    }

    @RequestMapping(value = "/test", method = RequestMethod.GET)
    public void getUser() {
        userInfoUtil.getUserInfo("17688562777");
    }

}
