package com.uas.customsdeclaration.common.base.service.impl;

import com.uas.customsdeclaration.common.base.service.FileService;
import com.uas.dfs.service.FileClient;
import com.uas.platform.core.exception.IllegalOperatorException;
import org.apache.commons.io.FilenameUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.web.multipart.MultipartFile;

@Service
public class FileServiceImpl implements FileService {

	@Autowired
	private FileClient fileClient;

	@Override
	public String save(MultipartFile file) {
		try {
			// 上传到文件系统
			return fileClient.upload(file.getBytes(), file.getSize(),
					FilenameUtils.getExtension(file.getOriginalFilename()), null);
		} catch (Exception e) {
			e.printStackTrace();
			throw new IllegalOperatorException("附件上传失败");
		}
	}

	@Override
	public String save(String fileName, byte[] fileBytes) {
		try {
            return fileClient.upload(fileBytes, fileBytes.length, FilenameUtils.getExtension(fileName), null);
		} catch (Exception e) {
			e.printStackTrace();
			throw new IllegalOperatorException("附件上传失败");
		}

	}

}
