package com.uas.customsdeclaration.util;

import org.apache.poi.hssf.usermodel.HSSFCellStyle;
import org.apache.poi.hssf.usermodel.HSSFFont;
import org.apache.poi.hssf.util.HSSFColor;
import org.apache.poi.ss.usermodel.BorderStyle;
import org.apache.poi.ss.usermodel.FillPatternType;
import org.apache.poi.ss.usermodel.HorizontalAlignment;
import org.apache.poi.ss.usermodel.VerticalAlignment;

/**
 * 单元格样式
 *
 * @author yuj 2018-04-27 15:26
 */
public class CellStyleUtil {

    /**
     * 设置粗边框
     * @param cellStyle
     * @return
     */
    public static void setBorderThik(HSSFCellStyle cellStyle) {
        if (cellStyle != null) {
            cellStyle.setBorderRight(BorderStyle.THICK);
            cellStyle.setBorderLeft(BorderStyle.THICK);
            cellStyle.setBorderBottom(BorderStyle.THICK);
            cellStyle.setBorderTop(BorderStyle.THICK);
        }
    }

    /**
     * 设置细边框
     * @param cellStyle
     * @return
     */
    public static void setBorderThin(HSSFCellStyle cellStyle) {
        if (cellStyle != null) {
            cellStyle.setBorderRight(BorderStyle.THIN);
            cellStyle.setBorderLeft(BorderStyle.THIN);
            cellStyle.setBorderBottom(BorderStyle.THIN);
            cellStyle.setBorderTop(BorderStyle.THIN);
        }
    }

    /**
     * 设置居中
     * @param cellStyle
     * @return
     */
    public static void setCenter(HSSFCellStyle cellStyle) {
        if (cellStyle != null) {
            cellStyle.setAlignment(HorizontalAlignment.CENTER);
            cellStyle.setVerticalAlignment(VerticalAlignment.CENTER);
        }
    }

    /**
     * 设置居中
     * @param cellStyle
     * @return
     */
    public static void setTopLeft(HSSFCellStyle cellStyle) {
        if (cellStyle != null) {
            cellStyle.setAlignment(HorizontalAlignment.LEFT);
            cellStyle.setVerticalAlignment(VerticalAlignment.TOP);
        }
    }

    /**
     * 设置居中
     * @param cellStyle
     * @return
     */
    public static void setBackGroundColor_Gray(HSSFCellStyle cellStyle) {
        if (cellStyle != null) {
            cellStyle.setFillForegroundColor(HSSFColor.GREY_25_PERCENT.index);
            cellStyle.setFillPattern(FillPatternType.SOLID_FOREGROUND);
            cellStyle.setFillBackgroundColor(HSSFColor.GREY_25_PERCENT.index);
        }
    }

    /**
     * 设置居中
     * @param font1
     * @return
     */
    public static void setFontSizeAndBold(HSSFFont font1, short fontSize, String type) {
        if (font1 != null) {
            font1.setFontName(type);
            font1.setFontHeightInPoints(fontSize);//设置字体大小
            font1.setBold(true);//加粗
        }
    }
}
