package com.uas.customsdeclaration.util;

import org.springframework.util.StringUtils;

/**
 * 中文的标点转英文
 *
 * @author yuj 2018-03-02 14:45
 */
public class ChinesePunctuationToEnglish {

    /**
     * 中文的标点 转化为英文的标点，全角转半角
     *
     * @param input
     * @return
     */
    public static String toEnglish(String input) {
        if (StringUtils.isEmpty(input)) {
            return null;
        } else {
            /*正则转换中文标点*/
            input = input.replaceAll("\\：", ":")
                    .replaceAll("\\。", ".")
                    .replaceAll("\\“", "\"")
                    .replaceAll("\\”", "\"")
                    .replaceAll("\\【", "[")
                    .replaceAll("\\】", "]")
                    .replaceAll("\\《", "<")
                    .replaceAll("\\》", ">")
                    .replaceAll("\\，", ", ")
                    .replaceAll("\\？", "?")
                    .replaceAll("\\、", ", ")
                    .replaceAll("\\；", ";")
                    .replaceAll("\\（", "(")
                    .replaceAll("\\）", ")")
                    .replaceAll("\\‘", "'")
                    .replaceAll("\\’", "'")
                    .replaceAll("\\『", "[")
                    .replaceAll("\\』", "]")
                    .replaceAll("\\「", "[")
                    .replaceAll("\\」", "]")
                    .replaceAll("\\﹃", "[")
                    .replaceAll("\\﹄", "]")
                    .replaceAll("\\〔", "{")
                    .replaceAll("\\〕", "}")
                    .replaceAll("\\—", "-")
                    .replaceAll("\\·", ".");
            /*正则转换全角为半角*/
            //字符串先转化成数组
            char[] array = input.toCharArray();
            for(int i = 0; i < array.length; i++) {
                //全角空格处理
                if(array[i] == 12288) {
                    array[i] = (char)32;
                    continue;
                }
                /*其他全角*/
                if(array[i] > 65280 && array[i] < 65375){
                    array[i] = (char)(array[i]-65248);
                }
            }
            //数组转换成字符串
            return new String(array);
        }
    }
}
