package com.uas.customsdeclaration.util;

import org.apache.poi.hssf.usermodel.HSSFCell;
import org.apache.poi.hssf.usermodel.HSSFCellStyle;
import org.apache.poi.hssf.usermodel.HSSFFont;
import org.apache.poi.hssf.usermodel.HSSFRow;
import org.apache.poi.hssf.usermodel.HSSFSheet;
import org.apache.poi.hssf.usermodel.HSSFWorkbook;
import org.apache.poi.hssf.util.HSSFColor;
import org.apache.poi.ss.usermodel.BorderStyle;
import org.apache.poi.ss.usermodel.CellType;
import org.apache.poi.ss.util.CellRangeAddress;
import org.apache.poi.ss.util.RegionUtil;

/**
 * 生成 HSSFWorkbook
 *
 * @author yuj 2018-04-26 18:00
 */
public class HSSFWorkbookUtil {


    /**
     * 生成关务部验证单据
     * @return
     */
    public static HSSFWorkbook createCustomerHouseServiceSheetTemplate() {
        HSSFWorkbook wb = new HSSFWorkbook();
        //创建一个sheet表,可以添加名称也可以不添加
        HSSFSheet sheet = wb.createSheet("sheet1");

        sheet.setColumnWidth(0, 20 * 256);

        //在sheet页中添加一行
        HSSFCellStyle hssfCellStyle = setBackGroundColorGrayAndThinAndCenterAndFontFourteen(wb);
        hssfCellStyle.setBorderRight(BorderStyle.THICK);
        hssfCellStyle.setBorderBottom(BorderStyle.NONE);
        setMergedRegionInfoAndStyle(sheet, 0, 1, 0, 17, hssfCellStyle, "中华人民共和国进口海关货物报关单");
        HSSFRow row = getRow(sheet, 0);
        row.setHeightInPoints(20);
        HSSFRow row1 = getRow(sheet, 1);
        row1.setHeightInPoints(20);

        HSSFCellStyle hssfCellStyle2_0 = setBackGroundColorGrayAndThinAndCenterAndFontEight(wb);
        hssfCellStyle2_0.setBorderRight(BorderStyle.NONE);
        hssfCellStyle2_0.setBorderBottom(BorderStyle.NONE);
        hssfCellStyle2_0.setBorderLeft(BorderStyle.NONE);
        hssfCellStyle2_0.setBorderTop(BorderStyle.NONE);
        setSingleRegionInfoAndStyle(sheet, 2, 0, hssfCellStyle2_0, "报关类型");
        setSingleRegionInfoAndStyle(sheet, 2, 1, null, "进口报关单");
        HSSFCellStyle hssfCellStyle2_2 = setBackGroundColorGrayAndThinAndCenterAndFontEight(wb);
        hssfCellStyle2_2.setBorderRight(BorderStyle.THICK);
        hssfCellStyle2_2.setBorderBottom(BorderStyle.NONE);
        hssfCellStyle2_2.setBorderLeft(BorderStyle.NONE);
        hssfCellStyle2_2.setBorderTop(BorderStyle.NONE);
        setMergedRegionInfoAndStyle(sheet, 2, 2, 2, 17, hssfCellStyle2_2, StringUtils.getEmpty());
        HSSFRow row2 = getRow(sheet, 2);
        row2.setHeightInPoints(20);

        setMergedRegionInfoAndStyle(sheet, 3, 3, 0, 3, setBackGroundColorGrayAndTopThikAndCenterAndFontEight(wb), "申报现场");
        setMergedRegionInfoAndStyle(sheet, 3, 3, 4, 8, setBackGroundColorGrayAndTopThikAndCenterAndFontEight(wb), "进口口岸");
        setMergedRegionInfoAndStyle(sheet, 3, 3, 9, 13, setBackGroundColorGrayAndTopThikAndCenterAndFontEight(wb), "备案号");
        HSSFCellStyle hssfCellStyle3_14 = setBackGroundColorGrayAndTopThikAndCenterAndFontEight(wb);
        hssfCellStyle3_14.setBorderRight(BorderStyle.THICK);
        setMergedRegionInfoAndStyle(sheet, 3, 3, 14, 17, hssfCellStyle3_14, "进口日期");
        HSSFRow row3 = getRow(sheet, 3);
        row3.setHeightInPoints(20);

        setMergedRegionInfoAndStyle(sheet, 4, 4, 0, 3, setThinAndCenterAndFontEight(wb), StringUtils.getEmpty());
        setMergedRegionInfoAndStyle(sheet, 4, 4, 4, 8, setThinAndCenterAndFontEight(wb), StringUtils.getEmpty());
        setMergedRegionInfoAndStyle(sheet, 4, 4, 9, 13, setThinAndCenterAndFontEight(wb), StringUtils.getEmpty());
        HSSFCellStyle hssfCellStyle4_14 = setThinAndCenterAndFontEight(wb);
        hssfCellStyle4_14.setBorderRight(BorderStyle.THICK);
        setMergedRegionInfoAndStyle(sheet, 4, 4, 14, 17, hssfCellStyle4_14, StringUtils.getEmpty());
        HSSFRow row4 = getRow(sheet, 4);
        row4.setHeightInPoints(20);

        setSingleRegionInfoAndStyle(sheet, 5, 0 , setBackGroundColorGrayAndThinAndCenterAndFontEight(wb), "收发货人");
        setMergedRegionInfoAndStyle(sheet, 5, 5, 1, 3, setThinAndCenterAndFontEight(wb), StringUtils.getEmpty());
        setMergedRegionInfoAndStyle(sheet, 5, 5, 4, 8, setBackGroundColorGrayAndThinAndCenterAndFontEight(wb), "运输方式");
        setMergedRegionInfoAndStyle(sheet, 5, 5, 9, 13, setBackGroundColorGrayAndThinAndCenterAndFontEight(wb), "运输工具名称");
        HSSFCellStyle hssfCellStyle5_14 = setBackGroundColorGrayAndThinAndCenterAndFontEight(wb);
        hssfCellStyle5_14.setBorderRight(BorderStyle.THICK);
        setMergedRegionInfoAndStyle(sheet, 5, 5, 14, 17, hssfCellStyle5_14, "提运单号");
        HSSFRow row5 = getRow(sheet, 5);
        row5.setHeightInPoints(20);

        setMergedRegionInfoAndStyle(sheet, 6, 6, 0, 3, setThinAndCenterAndFontEight(wb), StringUtils.getEmpty());
        setMergedRegionInfoAndStyle(sheet, 6, 6, 4, 8, setThinAndCenterAndFontEight(wb), StringUtils.getEmpty());
        setMergedRegionInfoAndStyle(sheet, 6, 6, 9, 13, setThinAndCenterAndFontEight(wb), StringUtils.getEmpty());
        HSSFCellStyle hssfCellStyle6_14 = setThinAndCenterAndFontEight(wb);
        hssfCellStyle6_14.setBorderRight(BorderStyle.THICK);
        setMergedRegionInfoAndStyle(sheet, 6, 6, 14, 17, hssfCellStyle6_14, StringUtils.getEmpty());
        HSSFRow row6 = getRow(sheet, 6);
        row6.setHeightInPoints(20);

        setSingleRegionInfoAndStyle(sheet, 7, 0, setBackGroundColorGrayAndThinAndCenterAndFontEight(wb), "消费使用单位");
        setMergedRegionInfoAndStyle(sheet, 7, 7, 1, 3, setThinAndCenterAndFontEight(wb), StringUtils.getEmpty());
        setMergedRegionInfoAndStyle(sheet, 7, 7, 4, 8, setBackGroundColorGrayAndThinAndCenterAndFontEight(wb), "监管方式");
        setMergedRegionInfoAndStyle(sheet, 7, 7, 9, 13, setBackGroundColorGrayAndThinAndCenterAndFontEight(wb), "征免性质");
        HSSFCellStyle hssfCellStyle7_14 = setBackGroundColorGrayAndThinAndCenterAndFontEight(wb);
        hssfCellStyle7_14.setBorderRight(BorderStyle.THICK);
        setMergedRegionInfoAndStyle(sheet, 7, 7, 14, 17, hssfCellStyle7_14, "贸易国（地区）");
        HSSFRow row7 = getRow(sheet, 7);
        row7.setHeightInPoints(20);

        setMergedRegionInfoAndStyle(sheet, 8, 8, 0, 3, setThinAndCenterAndFontEight(wb), StringUtils.getEmpty());
        setMergedRegionInfoAndStyle(sheet, 8, 8, 4, 8, setThinAndCenterAndFontEight(wb), StringUtils.getEmpty());
        setMergedRegionInfoAndStyle(sheet, 8, 8, 9, 13, setThinAndCenterAndFontEight(wb), StringUtils.getEmpty());
        HSSFCellStyle hssfCellStyle8_14 = setThinAndCenterAndFontEight(wb);
        hssfCellStyle8_14.setBorderRight(BorderStyle.THICK);
        setMergedRegionInfoAndStyle(sheet, 8, 8, 14, 17, hssfCellStyle8_14, StringUtils.getEmpty());
        HSSFRow row8 = getRow(sheet, 8);
        row8.setHeightInPoints(20);

        setMergedRegionInfoAndStyle(sheet, 9, 9, 0, 3, setBackGroundColorGrayAndThinAndCenterAndFontEight(wb), "许可证号");
        setMergedRegionInfoAndStyle(sheet, 9, 9, 4, 8, setBackGroundColorGrayAndThinAndCenterAndFontEight(wb), "启运国");
        setMergedRegionInfoAndStyle(sheet, 9, 9, 9, 13, setBackGroundColorGrayAndThinAndCenterAndFontEight(wb), "装货港");
        setMergedRegionInfoAndStyle(sheet, 9, 9, 14, 17, setBackGroundColorGrayAndRightThikAndCenterAndFontEight(wb), "境内目的地");
        HSSFRow row9 = getRow(sheet, 9);
        row9.setHeightInPoints(20);

        setMergedRegionInfoAndStyle(sheet, 10, 10, 0, 3, setThinAndCenterAndFontEight(wb), StringUtils.getEmpty());
        setMergedRegionInfoAndStyle(sheet, 10, 10, 4, 8, setThinAndCenterAndFontEight(wb), StringUtils.getEmpty());
        setMergedRegionInfoAndStyle(sheet, 10, 10, 9, 13, setThinAndCenterAndFontEight(wb), StringUtils.getEmpty());
        HSSFCellStyle hssfCellStyle10_14 = setThinAndCenterAndFontEight(wb);
        hssfCellStyle10_14.setBorderRight(BorderStyle.THICK);
        setMergedRegionInfoAndStyle(sheet, 10, 10, 14, 17, hssfCellStyle10_14, StringUtils.getEmpty());
        HSSFRow row10 = getRow(sheet, 10);
        row10.setHeightInPoints(20);

        setSingleRegionInfoAndStyle(sheet, 11, 0, setBackGroundColorGrayAndThinAndCenterAndFontEight(wb), "申报单位");
        setMergedRegionInfoAndStyle(sheet, 11, 11, 1, 2, setThinAndCenterAndFontEight(wb), StringUtils.getEmpty());
        setSingleRegionInfoAndStyle(sheet, 11, 3, setBackGroundColorGrayAndThinAndCenterAndFontEight(wb), "成交方式");
        setMergedRegionInfoAndStyle(sheet, 11, 11, 4, 8, setBackGroundColorGrayAndThinAndCenterAndFontEight(wb), "运费");
        setMergedRegionInfoAndStyle(sheet, 11, 11, 9, 13, setBackGroundColorGrayAndThinAndCenterAndFontEight(wb), "保费");
        setMergedRegionInfoAndStyle(sheet, 11, 11, 14, 17, setBackGroundColorGrayAndRightThikAndCenterAndFontEight(wb),"杂费");

        setMergedRegionInfoAndStyle(sheet, 12, 12, 0, 2, setThinAndCenterAndFontEight(wb), StringUtils.getEmpty());
        setSingleRegionInfoAndStyle(sheet, 12, 3, setThinAndCenterAndFontEight(wb), StringUtils.getEmpty());
        setSingleRegionInfoAndStyle(sheet, 12, 4, setThinAndCenterAndFontEight(wb), StringUtils.getEmpty());
        setMergedRegionInfoAndStyle(sheet, 12, 12, 5, 7, setThinAndCenterAndFontEight(wb), StringUtils.getEmpty());
        setSingleRegionInfoAndStyle(sheet, 12, 8, setThinAndCenterAndFontEight(wb), StringUtils.getEmpty());
        setSingleRegionInfoAndStyle(sheet, 12, 9, setThinAndCenterAndFontEight(wb), StringUtils.getEmpty());
        setMergedRegionInfoAndStyle(sheet, 12, 12, 10, 12, setThinAndCenterAndFontEight(wb), StringUtils.getEmpty());
        setSingleRegionInfoAndStyle(sheet, 12, 13, setThinAndCenterAndFontEight(wb), StringUtils.getEmpty());
        setSingleRegionInfoAndStyle(sheet, 12, 14, setThinAndCenterAndFontEight(wb), StringUtils.getEmpty());
        setMergedRegionInfoAndStyle(sheet, 12, 12, 15, 16, setThinAndCenterAndFontEight(wb), StringUtils.getEmpty());
        HSSFCellStyle hssfCellStyle12_17 = setThinAndCenterAndFontEight(wb);
        hssfCellStyle12_17.setBorderRight(BorderStyle.THICK);
        setSingleRegionInfoAndStyle(sheet, 12, 17, hssfCellStyle12_17, StringUtils.getEmpty());

        setMergedRegionInfoAndStyle(sheet, 13, 13, 0, 2, setBackGroundColorGrayAndThinAndCenterAndFontEight(wb), "合同协议号");
        setSingleRegionInfoAndStyle(sheet, 13, 3, setBackGroundColorGrayAndThinAndCenterAndFontEight(wb), "件数");
        setMergedRegionInfoAndStyle(sheet, 13, 13, 4, 8, setBackGroundColorGrayAndThinAndCenterAndFontEight(wb), "包装种类");
        setMergedRegionInfoAndStyle(sheet, 13, 13, 9, 13, setBackGroundColorGrayAndThinAndCenterAndFontEight(wb), "毛重(千克)");
        setMergedRegionInfoAndStyle(sheet, 13, 13, 14, 17, setBackGroundColorGrayAndRightThikAndCenterAndFontEight(wb), "净重(千克)");

        setMergedRegionInfoAndStyle(sheet, 14, 14, 0, 2, setThinAndCenterAndFontEight(wb), StringUtils.getEmpty());
        setSingleRegionInfoAndStyle(sheet, 14, 3, setThinAndCenterAndFontEight(wb), StringUtils.getEmpty());
        setMergedRegionInfoAndStyle(sheet, 14, 14, 4, 8, setThinAndCenterAndFontEight(wb), StringUtils.getEmpty());
        setMergedRegionInfoAndStyle(sheet, 14, 14, 9, 13, setThinAndCenterAndFontEight(wb), StringUtils.getEmpty());
        HSSFCellStyle hssfCellStyle14_14 = setThinAndCenterAndFontEight(wb);
        hssfCellStyle14_14.setBorderRight(BorderStyle.THICK);
        setMergedRegionInfoAndStyle(sheet, 14, 14, 14, 17, hssfCellStyle14_14, StringUtils.getEmpty());


        setMergedRegionInfoAndStyle(sheet, 15, 15, 0, 8, setBackGroundColorGrayAndThinAndCenterAndFontEight(wb), "集装箱号");
        setMergedRegionInfoAndStyle(sheet, 15, 15, 9, 13, setBackGroundColorGrayAndThinAndCenterAndFontEight(wb), "随附单据");
        HSSFCellStyle hssfCellStyle15_14 = setBackGroundColorGrayAndRightThikAndCenterAndFontEight(wb);
        HSSFFont font = hssfCellStyle15_14.getFont(wb);
        font.setColor(HSSFColor.RED.index);
        setMergedRegionInfoAndStyle(sheet, 15, 15, 14, 17, hssfCellStyle15_14, "航次号");

        setMergedRegionInfoAndStyle(sheet, 16, 16, 0, 2, setBackGroundColorGrayAndThinAndCenterAndFontEight(wb), "集装箱编号");
        setSingleRegionInfoAndStyle(sheet, 16, 3, setBackGroundColorGrayAndThinAndCenterAndFontEight(wb), "集装箱规格");
        setMergedRegionInfoAndStyle(sheet, 16, 16, 4, 8, setBackGroundColorGrayAndThinAndCenterAndFontEight(wb), "集装箱自重");
        setMergedRegionInfoAndStyle(sheet, 16, 16, 9, 10, setBackGroundColorGrayAndThinAndCenterAndFontEight(wb), "单证代码");
        setMergedRegionInfoAndStyle(sheet, 16, 16, 11, 13, setBackGroundColorGrayAndThinAndCenterAndFontEight(wb), "单证编号");
        HSSFCellStyle hssfCellStyle16_14 = setThinAndCenterAndFontEight(wb);
        hssfCellStyle16_14.setBorderRight(BorderStyle.THICK);
        setMergedRegionInfoAndStyle(sheet, 16, 16, 14, 17, hssfCellStyle16_14, StringUtils.getEmpty());

        setMergedRegionInfoAndStyle(sheet, 17, 17, 0, 2, setThinAndCenterAndFontEight(wb), StringUtils.getEmpty());
        setSingleRegionInfoAndStyle(sheet, 17, 3, setThinAndCenterAndFontEight(wb), StringUtils.getEmpty());
        setMergedRegionInfoAndStyle(sheet, 17, 17, 4, 8, setThinAndCenterAndFontEight(wb), StringUtils.getEmpty());
        setMergedRegionInfoAndStyle(sheet, 17, 17, 9, 10, setThinAndCenterAndFontEight(wb), StringUtils.getEmpty());
        setMergedRegionInfoAndStyle(sheet, 17, 17, 11, 13, setThinAndCenterAndFontEight(wb), StringUtils.getEmpty());
        setSingleRegionInfoAndStyle(sheet, 17, 14, setBackGroundColorGrayAndThinAndCenterAndFontEight(wb), "特殊关系确认");
        setSingleRegionInfoAndStyle(sheet, 17, 15, setBackGroundColorGrayAndThinAndCenterAndFontEight(wb), "价格影响确认");
        setMergedRegionInfoAndStyle(sheet, 17, 17, 16, 17, setBackGroundColorGrayAndRightThikAndCenterAndFontEight(wb), "支付特许权使用费确认");

        setMergedRegionInfoAndStyle(sheet, 18, 18, 0, 2, setThinAndCenterAndFontEight(wb), StringUtils.getEmpty());
        setSingleRegionInfoAndStyle(sheet, 18, 3, setThinAndCenterAndFontEight(wb), StringUtils.getEmpty());
        setMergedRegionInfoAndStyle(sheet, 18, 18, 4, 8, setThinAndCenterAndFontEight(wb), StringUtils.getEmpty());
        setMergedRegionInfoAndStyle(sheet, 18, 18, 9, 10, setThinAndCenterAndFontEight(wb), StringUtils.getEmpty());
        setMergedRegionInfoAndStyle(sheet, 18, 18, 11, 13, setThinAndCenterAndFontEight(wb), StringUtils.getEmpty());
        setSingleRegionInfoAndStyle(sheet, 18, 14, setThinAndCenterAndFontEight(wb), StringUtils.getEmpty());
        setSingleRegionInfoAndStyle(sheet, 18, 15, setThinAndCenterAndFontEight(wb), StringUtils.getEmpty());
        HSSFCellStyle hssfCellStyle18_16 = setThinAndCenterAndFontEight(wb);
        hssfCellStyle18_16.setBorderRight(BorderStyle.THICK);
        setMergedRegionInfoAndStyle(sheet, 18, 18, 16, 17, hssfCellStyle18_16, StringUtils.getEmpty());

        setMergedRegionInfoAndStyle(sheet, 19, 19, 0, 2, setThinAndCenterAndFontEight(wb), StringUtils.getEmpty());
        setSingleRegionInfoAndStyle(sheet, 19, 3, setThinAndCenterAndFontEight(wb), StringUtils.getEmpty());
        setMergedRegionInfoAndStyle(sheet, 19, 19, 4, 8, setThinAndCenterAndFontEight(wb), StringUtils.getEmpty());
        setMergedRegionInfoAndStyle(sheet, 19, 19, 9, 10, setThinAndCenterAndFontEight(wb), StringUtils.getEmpty());
        setMergedRegionInfoAndStyle(sheet, 19, 19, 11, 13, setThinAndCenterAndFontEight(wb), StringUtils.getEmpty());
        setSingleRegionInfoAndStyle(sheet, 19, 14, setThinAndCenterAndFontEight(wb), StringUtils.getEmpty());
        setSingleRegionInfoAndStyle(sheet, 19, 15, setThinAndCenterAndFontEight(wb), StringUtils.getEmpty());
        HSSFCellStyle hssfCellStyle19_16 = setThinAndCenterAndFontEight(wb);
        hssfCellStyle19_16.setBorderRight(BorderStyle.THICK);
        setMergedRegionInfoAndStyle(sheet, 19, 19, 16, 17, hssfCellStyle19_16, StringUtils.getEmpty());

        setMergedRegionInfoAndStyle(sheet, 20, 22, 0, 1, setBackGroundColorGrayAndThikAndCenterAndFontEight(wb), "标记唛码及备注");
        setMergedRegionInfoAndStyle(sheet, 20, 22, 2, 17, setBackGroundColorGrayAndThikAndCenterAndFontEight(wb), StringUtils.getEmpty());

        setMergedRegionInfoAndStyle(sheet, 23, 24, 0, 0, setBackGroundColorGrayAndTopThikAndCenterAndFontEight(wb), "项号");
        setMergedRegionInfoAndStyle(sheet, 23, 24, 1, 1, setBackGroundColorGrayAndTopThikAndCenterAndFontEight(wb), "商品编号");
        setMergedRegionInfoAndStyle(sheet, 23, 23, 2, 6, setBackGroundColorGrayAndTopThikAndCenterAndFontEight(wb), "商品名称、 规格型号");
        setSingleRegionInfoAndStyle(sheet, 24, 2, setBackGroundColorGrayAndThinAndCenterAndFontEight(wb), "商品名称");
        setMergedRegionInfoAndStyle(sheet, 24, 24, 3, 6, setBackGroundColorGrayAndThinAndCenterAndFontEight(wb), "申报要素");
        setMergedRegionInfoAndStyle(sheet, 23, 24, 7, 7, setBackGroundColorGrayAndTopThikAndCenterAndFontEight(wb), "成交数量");
        setMergedRegionInfoAndStyle(sheet, 23, 24, 8, 8, setBackGroundColorGrayAndTopThikAndCenterAndFontEight(wb), "成交单位");
        setMergedRegionInfoAndStyle(sheet, 23, 24, 9, 9, setBackGroundColorGrayAndTopThikAndCenterAndFontEight(wb), "法定数量");
        setMergedRegionInfoAndStyle(sheet, 23, 24, 10, 10, setBackGroundColorGrayAndTopThikAndCenterAndFontEight(wb), "第二数量");
        setMergedRegionInfoAndStyle(sheet, 23, 24, 11, 11, setBackGroundColorGrayAndTopThikAndCenterAndFontEight(wb), "第二单位");
        setMergedRegionInfoAndStyle(sheet, 23, 24, 12, 12, setBackGroundColorGrayAndTopThikAndCenterAndFontEight(wb), "原产国");
        setMergedRegionInfoAndStyle(sheet, 23, 24, 13, 13, setBackGroundColorGrayAndTopThikAndCenterAndFontEight(wb), "最终目的国");
        setMergedRegionInfoAndStyle(sheet, 23, 24, 14, 14, setBackGroundColorGrayAndTopThikAndCenterAndFontEight(wb), "单价");
        setMergedRegionInfoAndStyle(sheet, 23, 24, 15, 15, setBackGroundColorGrayAndTopThikAndCenterAndFontEight(wb), "总价");
        setMergedRegionInfoAndStyle(sheet, 23, 24, 16, 16, setBackGroundColorGrayAndTopThikAndCenterAndFontEight(wb), "币制");
        setMergedRegionInfoAndStyle(sheet, 23, 24, 17, 17, setBackGroundColorGrayAndTopThikAndCenterAndFontEight(wb), "征免");
        setMergedRegionInfoAndStyle(sheet, 23, 24, 18, 18, setBackGroundColorGrayAndTopThikAndCenterAndFontEight(wb), "自定义毛重");
        setMergedRegionInfoAndStyle(sheet, 23, 24, 19, 19, setBackGroundColorGrayAndTopThikAndCenterAndFontEight(wb), "自定义净重");
        setMergedRegionInfoAndStyle(sheet, 23, 24, 20, 20, setBackGroundColorGrayAndTopThikAndCenterAndFontEight(wb), "自定义件数");
        return wb;
    }

    /**
     * 设置字体宋体、字体大小、背景灰色、文字居中、粗体
     * @param wb
     * @return
     */
    public static HSSFCellStyle setBackGroundColorGrayAndThinAndCenterAndFontEight(HSSFWorkbook wb) {
        if (wb == null) {
            return null;
        } else {
            HSSFCellStyle cellStyle = wb.createCellStyle();
            HSSFFont font = wb.createFont();
            setBackGroundColorGrayAndCenterAndFontEight(cellStyle, font);
            CellStyleUtil.setBorderThin(cellStyle);
            return cellStyle;
        }
    }

    /**
     * 设置字体宋体、字体大小、背景灰色、文字居中、粗体
     * @param wb
     * @return
     */
    public static HSSFCellStyle setThinAndCenterAndFontEight(HSSFWorkbook wb) {
        if (wb == null) {
            return null;
        } else {
            HSSFCellStyle cellStyle = wb.createCellStyle();
            HSSFFont font = wb.createFont();
            setCenterAndFontEight(cellStyle, font);
            CellStyleUtil.setBorderThin(cellStyle);
            return cellStyle;
        }
    }

    /**
     * 设置字体宋体、字体大小、背景灰色、文字居中、粗体
     * @param wb
     * @return
     */
    public static HSSFCellStyle setBackGroundColorGrayAndThinAndCenterAndFontFourteen(HSSFWorkbook wb) {
        if (wb == null) {
            return null;
        } else {
            HSSFCellStyle cellStyle = wb.createCellStyle();
            HSSFFont font = wb.createFont();
            setBackGroundColorGrayAndCenterAndFontEight(cellStyle, font);
            font.setFontHeightInPoints((short) 14);
            cellStyle.setFont(font);
            CellStyleUtil.setBorderThin(cellStyle);
            return cellStyle;
        }
    }

    /**
     * 设置字体宋体、字体大小、背景灰色、文字居中、粗体
     * @param wb
     * @return
     */
    public static HSSFCellStyle setBackGroundColorGrayAndTopThikAndCenterAndFontEight(HSSFWorkbook wb) {
        if (wb == null) {
            return null;
        } else {
            HSSFCellStyle cellStyle = wb.createCellStyle();
            HSSFFont font = wb.createFont();
            setBackGroundColorGrayAndCenterAndFontEight(cellStyle, font);
            CellStyleUtil.setBorderThin(cellStyle);
            cellStyle.setBorderTop(BorderStyle.THICK);
            return cellStyle;
        }
    }

    /**
     * 设置字体宋体、字体大小、背景灰色、文字居中、粗体
     * @param wb
     * @return
     */
    public static HSSFCellStyle setBackGroundColorGrayAndThikAndCenterAndFontEight(HSSFWorkbook wb) {
        if (wb == null) {
            return null;
        } else {
            HSSFCellStyle cellStyle = wb.createCellStyle();
            HSSFFont font = wb.createFont();
            setBackGroundColorGrayAndCenterAndFontEight(cellStyle, font);
            CellStyleUtil.setBorderThik(cellStyle);
            return cellStyle;
        }
    }

    /**
     * 设置字体宋体、字体大小、背景灰色、文字居中、粗体
     * @param wb
     * @return
     */
    public static HSSFCellStyle setBackGroundColorGrayAndRightThikAndCenterAndFontEight(HSSFWorkbook wb) {
        if (wb == null) {
            return null;
        } else {
            HSSFCellStyle cellStyle = wb.createCellStyle();
            HSSFFont font = wb.createFont();
            setBackGroundColorGrayAndCenterAndFontEight(cellStyle, font);
            CellStyleUtil.setBorderThin(cellStyle);
            cellStyle.setBorderRight(BorderStyle.THICK);
            return cellStyle;
        }
    }

    /**
     * 设置字体宋体、字体大小、背景灰色、文字居中、粗体
     * @param cellStyle
     * @return
     */
    public static void setBackGroundColorGrayAndCenterAndFontEight(HSSFCellStyle cellStyle, HSSFFont font) {
        if (cellStyle != null) {
            CellStyleUtil.setBackGroundColor_Gray(cellStyle);
            CellStyleUtil.setCenter(cellStyle);
            CellStyleUtil.setFontSizeAndBold(font, (short) 8, "宋体");
            cellStyle.setFont(font);
        }
    }

    /**
     * 设置字体宋体、字体大小、文字居中
     * @param cellStyle
     * @return
     */
    public static void setCenterAndFontEight(HSSFCellStyle cellStyle, HSSFFont font) {
        if (cellStyle != null) {
            CellStyleUtil.setCenter(cellStyle);
            CellStyleUtil.setFontSizeAndBold(font, (short) 8, "宋体");
            font.setBold(false);
            cellStyle.setFont(font);
        }
    }

    /**
     * 根据
     * @param fromRange 开始列
     * @param toRange 结束列
     * @param fromColumn  开始行
     * @param toColumn  结束行
     * @param sheet 表格
     */
    public static void createCell(int fromColumn, int toColumn, int fromRange, int toRange, HSSFSheet sheet) {
        if (sheet != null) {
            for (int i = fromColumn; i <= toColumn; i++) {
                HSSFRow row = getRow(sheet, i);
                for(int j = fromRange; j <= toRange; j++) {
                    getCell(row, j);
                }
            }
        }
    }

    /**
     * 合并单元格
     * @param fromColumn
     * @param toColumn
     * @param fromRange
     * @param toRange
     * @param sheet
     */
    public static void mergedRegion(int fromColumn, int toColumn, int fromRange, int toRange, HSSFSheet sheet, HSSFCellStyle hssfCellStyle) {
        if (sheet != null) {
            createCell(fromColumn, toColumn, fromRange, toRange, sheet);
            CellRangeAddress rangeAddress = new CellRangeAddress(fromColumn, toColumn, fromRange, toRange);
            sheet.addMergedRegion(rangeAddress);
            if (hssfCellStyle != null) {
                RegionUtil.setBorderBottom(hssfCellStyle.getBorderBottomEnum(), rangeAddress, sheet);
                RegionUtil.setBorderTop(hssfCellStyle.getBorderTopEnum(), rangeAddress, sheet);
                RegionUtil.setBorderLeft(hssfCellStyle.getBorderLeftEnum(), rangeAddress, sheet);
                RegionUtil.setBorderRight(hssfCellStyle.getBorderRightEnum(), rangeAddress, sheet);
            }
        }
    }

    /**
     * 获取列对象
     * @param sheet 单元表格
     * @param i 列内容
     * @return
     */
    public static HSSFRow getRow(HSSFSheet sheet, int i) {
        if (sheet != null) {
            HSSFRow row = sheet.getRow(i);
            if (row == null) {
                row = sheet.createRow(i);
            }
            return row;
        }
        return null;
    }

    /**
     * 获取列对象
     * @param row 行对象
     * @param i 列内容
     * @return
     */
    public static HSSFCell getCell(HSSFRow row, int i) {
        if (row != null) {
            HSSFCell cell = row.getCell(i);
            if (cell == null) {
                cell = row.createCell(i);
            }
            return cell;
        }
        return null;
    }

    /**
     * 设置合并单元格的内容及样式
     * @param sheet 表格
     * @param fromRow 开始行
     * @param toRow 结束行
     * @param fromColumn 开始列
     * @param toColumn 结束列
     * @param hssfCellStyle 样式
     * @param title 名称
     * @return 单元格
     */
    public static HSSFCell setMergedRegionInfoAndStyle(HSSFSheet sheet, int fromRow, int toRow, int fromColumn, int toColumn, HSSFCellStyle hssfCellStyle, String title) {
        //在sheet页中添加一行
        mergedRegion(fromRow, toRow, fromColumn, toColumn, sheet, hssfCellStyle);
        HSSFRow row = getRow(sheet, fromRow);
        HSSFCell cell = getCell(row, fromColumn);
        cell.setCellType(CellType.STRING);
        cell.setCellValue(title);
        if (hssfCellStyle != null) {
            cell.setCellStyle(hssfCellStyle);
        }
        return cell;
    }

    /**
     * 设置合并单元格的内容及样式
     * @param sheet 表格
     * @param rowIndex 开始行
     * @param columnIndex 开始列
     * @param hssfCellStyle 样式
     * @param title 名称
     * @return 单元格
     */
    public static HSSFCell setSingleRegionInfoAndStyle(HSSFSheet sheet, int rowIndex, int columnIndex, HSSFCellStyle hssfCellStyle, String title) {
        //在sheet页中添加一行
        HSSFRow row = getRow(sheet, rowIndex);
        HSSFCell cell = getCell(row, columnIndex);
        cell.setCellType(CellType.STRING);
        if (title != null) {
            cell.setCellValue(title);
        }
        if (hssfCellStyle != null) {
            cell.setCellStyle(hssfCellStyle);
        }
        return cell;
    }



    /**
     * 生成关务部验证单据
     * @return
     */
    public static HSSFWorkbook createCommissionSheetTemplate() {
        HSSFWorkbook wb = new HSSFWorkbook();
        //创建一个sheet表,可以添加名称也可以不添加
        HSSFSheet sheet = wb.createSheet("sheet1");

        //在sheet页中添加一行
        setMergedRegionInfoAndStyle(sheet, 0, 2, 0, 6, null, "");

        HSSFCellStyle cellStyle = wb.createCellStyle();
        HSSFFont font = wb.createFont();
        font.setColor(HSSFColor.DARK_TEAL.index);
        CellStyleUtil.setFontSizeAndBold(font, (short) 8, "宋体");
        cellStyle.setFont(font);
        setMergedRegionInfoAndStyle(sheet, 0, 2, 7, 12, cellStyle, "TEL: 0755-83619962      FAX: 0755-83115210\n" +
                "地址: 深圳市羅湖區新秀路新秀村瑞思大廈A座1005\n" +
                "ADD: No.1005 Block A Ruisi Building Xinxiu Village Xinxiu Road LuoHu District, ShenZhen.");

        HSSFCellStyle cellStyle3_5 = wb.createCellStyle();
        HSSFFont font3_5 = wb.createFont();
        CellStyleUtil.setFontSizeAndBold(font3_5, (short) 28, "楷体");
        CellStyleUtil.setCenter(cellStyle3_5);
        cellStyle3_5.setFont(font3_5);
        setMergedRegionInfoAndStyle(sheet, 3, 5, 5, 8, cellStyle3_5, "委托报关单");

        HSSFCellStyle cellStyle3_11 = wb.createCellStyle();
        CellStyleUtil.setCenter(cellStyle3_11);
        setMergedRegionInfoAndStyle(sheet, 3, 3, 11, 13, cellStyle3_11, "委託單號（入倉號）");

        HSSFCellStyle cellStyle4_11 = wb.createCellStyle();
        HSSFFont font4_11 = wb.createFont();
        CellStyleUtil.setFontSizeAndBold(font4_11, (short) 13, "楷体");
        CellStyleUtil.setCenter(cellStyle4_11);
        cellStyle4_11.setFont(font4_11);
        setMergedRegionInfoAndStyle(sheet, 4, 5, 11, 13, cellStyle4_11, "JL120818");

        HSSFCellStyle cellStyle7_0 = wb.createCellStyle();
        HSSFFont font7_0 = wb.createFont();
        CellStyleUtil.setFontSizeAndBold(font7_0, (short) 9, "仿宋");
        CellStyleUtil.setCenter(cellStyle7_0);
        cellStyle7_0.setFont(font7_0);
        setMergedRegionInfoAndStyle(sheet, 7, 7, 0, 1, cellStyle7_0, "委  托  方");
        setMergedRegionInfoAndStyle(sheet, 7, 7, 2, 6, null, StringUtils.getEmpty());
        setMergedRegionInfoAndStyle(sheet, 7, 7, 7, 8, cellStyle7_0, "供  货  方");
        setMergedRegionInfoAndStyle(sheet, 7, 7, 9, 13, null, StringUtils.getEmpty());

        setMergedRegionInfoAndStyle(sheet, 8, 8, 0, 1, cellStyle7_0, "负  责  人");
        setMergedRegionInfoAndStyle(sheet, 8, 8, 2, 6, null, StringUtils.getEmpty());
        setMergedRegionInfoAndStyle(sheet, 8, 8, 7, 8, cellStyle7_0, "负  责  人");
        setMergedRegionInfoAndStyle(sheet, 8, 8, 9, 13, null, StringUtils.getEmpty());

        setMergedRegionInfoAndStyle(sheet, 9, 9, 0, 1, cellStyle7_0, "联 系 方 式");
        setMergedRegionInfoAndStyle(sheet, 9, 9, 2, 6, null, StringUtils.getEmpty());
        setMergedRegionInfoAndStyle(sheet, 9, 9, 7, 8, cellStyle7_0, "联 系 方 式");
        setMergedRegionInfoAndStyle(sheet, 9, 9, 9, 13, null, StringUtils.getEmpty());

        setMergedRegionInfoAndStyle(sheet, 10, 10, 0, 6, cellStyle7_0, "受托方：深圳市晶琳进出口有限公司");
        setMergedRegionInfoAndStyle(sheet, 10, 10, 7, 13, cellStyle7_0, "供货方发、送货须凭入仓号才能入仓（敬请填写入仓号）");

        setMergedRegionInfoAndStyle(sheet, 11, 11, 0, 1, cellStyle7_0, "深圳交货方式");
        setMergedRegionInfoAndStyle(sheet, 11, 11, 2, 6, null, StringUtils.getEmpty());
        setMergedRegionInfoAndStyle(sheet, 11, 11, 7, 8, cellStyle7_0, "香港交货方式");
        setMergedRegionInfoAndStyle(sheet, 11, 11, 9, 13, null, StringUtils.getEmpty());

        setMergedRegionInfoAndStyle(sheet, 12, 12, 0, 1, cellStyle7_0, "收  货  人");
        setMergedRegionInfoAndStyle(sheet, 12, 12, 2, 6, null, StringUtils.getEmpty());
        setMergedRegionInfoAndStyle(sheet, 12, 12, 7, 8, cellStyle7_0, "货仓联系人");
        setMergedRegionInfoAndStyle(sheet, 12, 12, 9, 13, null, StringUtils.getEmpty());

        setMergedRegionInfoAndStyle(sheet, 13, 13, 0, 1, cellStyle7_0, "联 系 方 式");
        setMergedRegionInfoAndStyle(sheet, 13, 13, 2, 6, null, StringUtils.getEmpty());
        setMergedRegionInfoAndStyle(sheet, 13, 13, 7, 8, cellStyle7_0, "联 系 方 式");
        setMergedRegionInfoAndStyle(sheet, 13, 13, 9, 13, null, StringUtils.getEmpty());

        setMergedRegionInfoAndStyle(sheet, 14, 14, 0, 1, cellStyle7_0, "交 货 地 址");
        setMergedRegionInfoAndStyle(sheet, 14, 14, 2, 6, null, StringUtils.getEmpty());
        setMergedRegionInfoAndStyle(sheet, 14, 14, 7, 8, cellStyle7_0, "香港仓库");
        setMergedRegionInfoAndStyle(sheet, 14, 14, 9, 13, null, StringUtils.getEmpty());

        setSingleRegionInfoAndStyle(sheet, 15, 0, cellStyle7_0, "序号");
        setSingleRegionInfoAndStyle(sheet, 15, 1, cellStyle7_0, "商品名称");
        setSingleRegionInfoAndStyle(sheet, 15, 2, cellStyle7_0, "规格型号");
        setSingleRegionInfoAndStyle(sheet, 15, 3, cellStyle7_0, "数量(PCS)");
        setSingleRegionInfoAndStyle(sheet, 15, 4, cellStyle7_0, "箱数");
        setSingleRegionInfoAndStyle(sheet, 15, 5, cellStyle7_0, "净重(kg)");
        setSingleRegionInfoAndStyle(sheet, 15, 6, cellStyle7_0, "毛重(kg)");
        setSingleRegionInfoAndStyle(sheet, 15, 7, cellStyle7_0, "币种");
        setSingleRegionInfoAndStyle(sheet, 15, 8, cellStyle7_0, "单价");
        setSingleRegionInfoAndStyle(sheet, 15, 9, cellStyle7_0, "总价");
        setSingleRegionInfoAndStyle(sheet, 15, 10, cellStyle7_0, "品牌");
        setSingleRegionInfoAndStyle(sheet, 15, 11, cellStyle7_0, "产地");
        setSingleRegionInfoAndStyle(sheet, 15, 12, cellStyle7_0, "批号");
        setSingleRegionInfoAndStyle(sheet, 15, 13, cellStyle7_0, "备注");
        sheet.setColumnWidth(0, 6*256);
        sheet.setColumnWidth(1, 12*256);
        sheet.setColumnWidth(2, 20*256);
        sheet.setColumnWidth(3, 9*256);
        sheet.setColumnWidth(4, 9*256);
        sheet.setColumnWidth(5, 9*256);
        sheet.setColumnWidth(6, 9*256);
        sheet.setColumnWidth(7, 9*256);
        sheet.setColumnWidth(8, 9*256);
        sheet.setColumnWidth(9, 12*256);
        sheet.setColumnWidth(10, 12*256);
        sheet.setColumnWidth(11, 12*256);
        sheet.setColumnWidth(12, 12*256);
        return wb;
    }
}
