package com.uas.customsdeclaration.util;

/**
 * 判断是否是中文字符串
 *
 * @author yuj 2018-03-02 14:14
 */
public class JudgingChinese {

    /**
     *  根据UnicodeBlock方法判断中文标点符号
     *
     *  @param c 字符串
      */
    public static boolean isChinesePunctuation(char c) {
        Character.UnicodeBlock ub = Character.UnicodeBlock.of(c);
        if (ub == Character.UnicodeBlock.GENERAL_PUNCTUATION
                || ub == Character.UnicodeBlock.CJK_SYMBOLS_AND_PUNCTUATION
                || ub == Character.UnicodeBlock.HALFWIDTH_AND_FULLWIDTH_FORMS
                || ub == Character.UnicodeBlock.CJK_COMPATIBILITY_FORMS
                || ub == Character.UnicodeBlock.VERTICAL_FORMS) {
            return true;
        } else {
            return false;
        }
    }


    /**
     * 使用UnicodeScript方法判断
     *
     * @param c 需要判断的中文字符串
     * @return 是/否
     */
    public static boolean isChineseByScript(char c) {
        Character.UnicodeScript sc = Character.UnicodeScript.of(c);
        if (sc == Character.UnicodeScript.HAN) {
            return true;
        }
        return false;
    }
}
