package com.uas.customsdeclaration.util;

import com.uas.customsdeclaration.core.StringConstant;

import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.concurrent.atomic.AtomicInteger;

/**
 * 生成订单号的接口
 *
 * @author yuj 2017-12-21 19:44
 */
public class OrderNumberUtil {

    /**
     * 统计的偏移量
     */
    public static volatile AtomicInteger offset = new AtomicInteger(0);

    /**
     * 关务验证单据
     */
    public static volatile AtomicInteger offset1 = new AtomicInteger(0);

    /**
     * 生成流水号
     *
     * @return String
     */
    public synchronized static String getOrderId() {
        // 如果偏移量超过了100000000, 则重新统计
        if (offset.get() > 100000000) {
            offset.set(0);
        }
        int offsetValue = offset.incrementAndGet();

        StringBuilder s = new StringBuilder();
        SimpleDateFormat df = new SimpleDateFormat(StringConstant.YMDHMS);
        String rdNum = df.format(new Date());
        String paddingStr = AssistantUtil.paddingStr(String.valueOf(offsetValue), 9);
        StringBuilder append = s.append(rdNum).append(paddingStr);
        return append.toString();
    }

    /**
     * 生成表单号，单号偏移量 10000
     *
     * @return
     */
    public synchronized static String generateOrderId() {
        // 如果偏移量超过了100000000, 则重新统计
        if (offset1.get() > 10000) {
            offset1.set(0);
        }
        int offsetValue = offset1.incrementAndGet();

        StringBuilder s = new StringBuilder();
        SimpleDateFormat df = new SimpleDateFormat(StringConstant.YMD);
        String rdNum = df.format(new Date());
        String paddingStr = AssistantUtil.paddingStr(String.valueOf(offsetValue), 5);
        StringBuilder append = s.append(rdNum).append(paddingStr);
        return append.toString();
    }
}
