package com.uas.customsdeclaration.util;

import com.fasterxml.jackson.annotation.JsonInclude;
import com.uas.platform.core.util.serializer.FlexJsonUtils;

/**
 * 请求结果集
 *
 * history:
 * Created by huxz on 2017-3-29 16:30:32
 */
@JsonInclude(JsonInclude.Include.NON_EMPTY)
public class ResultMap {

	private int code;

	private boolean success;

	private String message;

	private Object content;

	public ResultMap() {
	}

	public ResultMap(int status, String message) {
		if (CodeType.OK.code() == status) {
			this.success = true;
		} else {
			this.success = false;
		}
		this.code = status;
		this.message = message;
	}

	public ResultMap(CodeType status, String message) {
		if (CodeType.OK.code() == status.code()) {
			this.success = true;
		} else {
			this.success = false;
		}
		this.message = message;
		this.code = status.code();
	}

	public ResultMap(int status, String message, Object content) {
		if (CodeType.OK.code() == status) {
			this.success = true;
		} else {
			this.success = false;
		}
		this.code = status;
		this.message = message;
		this.content = content;
	}

	/*public ResultMap(CodeType status, Object data) {
		this.code = status.code();
		if (CodeType.OK == status) {
			this.success = true;
			this.data = data;
		} else {
			this.success = false;
			this.message = status.message();
		}
	}*/

	public int getCode() {
		return code;
	}

	public void setCode(int code) {
		this.code = code;
	}

	public boolean isSuccess() {
		return success;
	}

	public void setSuccess(boolean success) {
		this.success = success;
	}

	public String getMessage() {
		return message;
	}

	public void setMessage(String message) {
		this.message = message;
	}

	public Object getContent() {
		return content;
	}

	public ResultMap setContent(Object content) {
		this.content = content;
		return this;
	}

	@Override
	public String toString() {
		return FlexJsonUtils.toJson(this);
	}

	public static ResultMap success(Object content) {
		ResultMap result = new ResultMap(CodeType.OK.code(), null);
		result.content = content;
		return result;
	}

	public static ResultMap success(Object content, String message) {
		ResultMap result = new ResultMap(CodeType.OK.code(), null);
		result.content = content;
		result.message = message;
		return result;
	}
}
