package com.uas.customsdeclaration.util;

import com.uas.customsdeclaration.SSOProperties;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.ResponseEntity;
import org.springframework.stereotype.Component;
import org.springframework.web.client.RestTemplate;

import java.util.LinkedHashMap;
import java.util.Map;

/**
 * 账户中心辅助类
 *
 * @author yuj 2018-04-23 16:09
 */
@Component
public class SSOUtil {

    private final SSOProperties SSOProperties;

    private final RestTemplate restTemplate;

    @Autowired
    public SSOUtil(SSOProperties SSOProperties, RestTemplate restTemplate) {
        this.SSOProperties = SSOProperties;
        this.restTemplate = restTemplate;
    }

    /**
     * 根据公司名获取公司信息
     * @param spaceName
     * @return
     */
    public ResultMap getSpaceBySpaceName(String spaceName) {
        if (StringUtils.isEmpty(spaceName)) {
            return new ResultMap(CodeType.DEFICIENCY_INFO, "公司名称为空");
        } else {
            String url = SSOProperties.getGetSpaceByName().replaceAll("\\{name\\}", spaceName);
            ResponseEntity<Object> restTemplateForEntity = restTemplate.getForEntity(url, Object.class);
            LinkedHashMap map = (LinkedHashMap)restTemplateForEntity.getBody();
            Boolean status = (Boolean) map.get("success");
            if (status) {
                Map<String, Object> content = (Map<String, Object>) map.get("content");
                return ResultMap.success(content);
            } else {
                return new ResultMap(CodeType.FAILURE, "获取企业资料失败");
            }
        }
    }
}
