package com.uas.customsdeclaration.util;

import com.uas.customsdeclaration.core.StringConstant;

import java.text.SimpleDateFormat;
import java.util.Date;

/**
 * @author sunyj
 * @since 2017年5月25日 上午11:09:36
 */
public class StringUtils {

	public static String getEmpty() {
		return "";
	}

	/**
	 * 获取字符串
	 *
	 * @param str
	 * @return
	 */
	public static String getString(String str) {
		if (isEmpty(str)) {
			return "";
		} else {
			return str;
		}
	}

	/**
	 * 判断是否是空值
	 *
	 * @param str
	 * @return
	 */
	public static boolean isEmpty(Object str) {
		return (str == null || "".equals(str));
	}

	public static String reverse(String str) {
		if (isEmpty(str)) {
			return str;
		}
		char[] array = str.toCharArray();
		int begin = 0;
		int end = str.length() - 1;
		while (begin < end) {
			array[begin] = (char) (array[begin] ^ array[end]);
			array[end] = (char) (array[begin] ^ array[end]);
			array[begin] = (char) (array[begin] ^ array[end]);
			begin++;
			end--;
		}
		return new String(array);
	}

	/**
	 * 移除空格
	 *
	 * @param str
	 * @return
	 */
	public static String cutOutBlank(Object str) {
		if (str == null) {
			return null;
		} else {
			String s = str.toString();
			if (StringUtils.isEmpty(s)) {
				return s;
			} else {
				s = s.replaceAll(" ", "");
				return s;
			}
		}

	}


	/**
	 * 格式化信息，中文标点转英文标点，去掉前后空格，中间连续的空格只保留一个，多条连续横线只有一条。
	 *
	 * @param input 传入的信息
	 * @return 格式化之后的数据
	 */
	public static String formatcmpName(String input) {
		if (StringUtils.isEmpty(input)) {
			return input;
		} else {
			return FewLineaeToSingle.toSingle(StringTrimBlank.removeBlankKeepSingle(ChinesePunctuationToEnglish.toEnglish(input)));
		}
	}

	/**
	 * 比较两个字符串的信息
	 *
	 * @param str1
	 * @param str2
	 * @return 相等则为true，不相等则为false
	 */
	public static Boolean compare(String str1, String str2) {
		if (str1 == null && str2 == null) {
			return Boolean.TRUE;
		} else {
			if (str1 != null) {
				if (str1.equals(str2)) {
					return Boolean.TRUE;
				} else {
					return Boolean.FALSE;
				}
			} else {
				return Boolean.FALSE;
			}
		}
	}

	public static String formateTime() {
		SimpleDateFormat df = new SimpleDateFormat(StringConstant.YMD_LINETHROUG);
		String str = df.format(new Date());
		return str;
	}

	/**
	 *	格式化日期
	 * @param time 时间戳
	 * @return String
	 */
	public static String formateTimeYMDHMS(Date time) {
		if (time == null) {
			time = new Date();
		}
		SimpleDateFormat df = new SimpleDateFormat(StringConstant.YMDHMS_LINETHROUG);
		String str = df.format(time);
		return str;
	}
}
