package com.uas.customsdeclaration.util;

import com.uas.customsdeclaration.business.common.model.CommissionSheet;
import org.apache.poi.hssf.usermodel.HSSFWorkbook;

import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.List;
import java.util.zip.ZipEntry;
import java.util.zip.ZipOutputStream;

/**
 * 压缩文件辅助类
 *
 * @author yuj 2018-04-24 19:04
 */
public class ZipUtil {

    /**
     * 根据数据转成字节流
     * @param sheetList
     * @return
     */
    public static ByteArrayOutputStream createZipStream(List<CommissionSheet> sheetList) {
        // 压缩流
        ByteArrayOutputStream byteArrayOutputStream = new ByteArrayOutputStream();
        ZipOutputStream toClient = new ZipOutputStream(byteArrayOutputStream);
        for (CommissionSheet serviceSheet : sheetList) {
            try {
                HSSFWorkbook workbook = HSSFWorkbookUtil.createCommissionSheetTemplate();
                WorkBookFillDataUtil.fillCommissionSheetWorkBookData(workbook, serviceSheet);
                String fileName = serviceSheet.getCsid() + ".xls";
                String dicPath = new File(".").getCanonicalPath();
                String srcPath = dicPath + "\\down";
                File newPath = new File(srcPath);
                newPath.mkdirs();
                File file = new File(newPath + "\\"+ fileName);
                FileOutputStream fos = new FileOutputStream(file);
                workbook.write(fos);
                FileInputStream fin = new FileInputStream(file);
                ZipEntry entry = new ZipEntry(file.getName());
                toClient.putNextEntry(entry);
                int b;
                while ((b = fin.read()) != -1) {
                    toClient.write(b);
                }
                fin.close();
                toClient.closeEntry();
                if (file.exists()) {
                    file.delete();
                }
            } catch (Exception e) {
                e.printStackTrace();
            }
        }
        try {
            toClient.close();
        } catch (IOException e) {
            e.printStackTrace();
        }

        return byteArrayOutputStream;
    }
}
